C $Id: delrem.r,v 1.66 2001/08/04 22:18:29 hess Exp $
C FORTRAN PROGRAM PREPROCESSOR
C $Log: delrem.r,v $
C Revision 1.66  2001/08/04 22:18:29  hess
C C//FILENAME
C
C  DELC+          UPPER_.C SUBROUTINE PRESENT
C//FILE 'cmn.h'
CJN  modified by C. Kind and J. Neugebauer 16.12.2001
      INTEGER mfil,milx,maxc,mxsub,mxdol,mxstmt,
     *mxpar,mxwat,mxendo,maxcpp,maxdel,mxvar,mxdata,mxcard,mxfram
      PARAMETER (MFIL=15,MILX=200,MAXC=500,
     *MXSUB=200,MXDOL=2000,
     *MXSTMT=50000,MXPAR=80,MXWAT=10,MXENDO=10,MAXCPP=20,MAXDEL=20,
     *MXVAR=5000,MXDATA=5000,mxcard=20000,mxfram=50)

* mnemonic names for statement types (saved in ixstat(8))
      INTEGER tpara,tcommon,tformat,
     *tdoloop,tunknown,tassign,tpointer,tdata,tpointee,tdim,
     *timpltyped,tcmnn,tfctdef,tend,treal,tint,tlogical,tchar,tentry,
     *tcomplex,tgoto,tdouble,tr8,tr16,tc16,tc32,tstop,treturn
      PARAMETER (tformat=8,
     *tpara=10,tcommon=12,tdouble=13,tr8=15,tr16=16,
     *treal=17,tc16=19,tc32=20,tcomplex=21,tint=26,tlogical=30,tchar=31,
     *tpointer=35,tdata=36,
     *tfctdef=37,tend=41,tgoto=48,tstop=51,treturn=52,
     *tentry=54,tdoloop=59,tcmnn=94,
     *timpltyped=95,tpointee=96,tdim=97,tassign=98,tunknown=99
     *)

* sequence number of dollar and underscore
      INTEGER mlastc,mundersc,mdollar,ninitial,nenddo
      PARAMETER (mlastc=25,mundersc=27,mdollar=28,ninitial=28)

      INTEGER ibfrd,iq,ilx,ily,idel,ienbl,iflow,itrace,istat,itim,
     *isavs,nctr,out,nsub,ndol,iprof,ibatch,nr,ido,iupper,irep,
     *logf,iimpl,idebug,isprof,istio,leave,nwati,nwatr,ienddo,idbg,ierr,
     *memchk,jdo,ibigl,jbigl,ilb,ilc,fis,fie,ila,isub,
     *menddo,ihexx,icpp,kcpp,iatt,
     *ixstat,ixvar,itvar,nvar,ipointer,npointer,
     *mwordl,mlongr,implt,impll,lsrname,idollar,itmph,ndata,nfil,
     *nc1,nc2,nc3,nc4,ieof,naxf,ifram,cfram,ifileb,itabs,ifex

      COMMON /CVT/ IBFRD,IQ,ILX,ILY,IDEL,IENBL,IFLOW,ITRACE,ISTAT,ITIM,
     *ISAVS,NCTR,OUT,NSUB,NDOL,IPROF,IBATCH,NR,IDO,IUPPER,IREP,
     *LOGF,IIMPL,IDEBUG,ISPROF,ISTIO,LEAVE,NWATI,NWATR,IENDDO,
     *IDBG,IERR,MEMCHK,nfil,nc1,nc2,nc3,nc4,ieof,naxf,
     *nvar,ipointer,npointer,mwordl,mlongr,lsrname,
     *idollar,itmph,ndata,ifram,cfram,ifileb,itabs,ifex

      INTEGER fs,fe,fn

      COMMON /arrays/
     *JDO(MILX),IBIGL,JBIGL(MILX),
     *ILB(MILX),ILC(MILX),FIS(MFIL),FIE(MFIL),ILA(99999),ISUB(MXSUB),
     *MENDDO(MXENDO),NENDDO,IHEXX,ICPP,KCPP(MAXCPP),IATT(MAXDEL),
     *ixstat(8),ixvar(mxvar),itvar(mxvar),implt(ninitial),
     *impll(ninitial),fs(mxfram),fe(mxfram),fn(mxfram)


      CHARACTER*8 CMEMCK
      CHARACTER*2 DEL,OUTSIG,DIRSIG
      CHARACTER*128 Q,BUF,BUFSCR,CPPV
      CHARACTER*60 FILNAM,PROTO
      CHARACTER*80 CWATR,CWATI,varnam,srname,dstmt,fileb
      CHARACTER*6  UNIT

      COMMON /CHARS/ OUTSIG,DIRSIG,UNIT,BUF,PROTO,CMEMCK,bufscr,srname,
     *Q(MAXC),DEL(MAXDEL),FILNAM(MFIL),
     *CWATR(MXWAT),CWATI(MXWAT),CPPV(MAXCPP),varnam(mxvar),
     *dstmt(mxdata),fileb(mxcard)

* mxvar : maximal number of variables
* maxc  : maximal number of continutaion cards
* mxcard: maximal number of cards in a deck
* mxfram: maximal number of frames
C//END
      PROGRAM delrem
      IMPLICIT none
      INCLUDE 'cmn.h'
      CHARACTER*128 OUTC,CARD
      CHARACTER*2000 rec
      LOGICAL comment_card
      EQUIVALENCE (CARD,OUTC)
      CHARACTER*70 VERSION
      CHARACTER*4 vnr
      INTEGER infile,irc,i,iret,fctrl,finfil,l
      DATA VERSION 
     */'$Id: delrem.r,v 1.66 2001/08/04 22:18:29 hess Exp $'/
      CALL getver(version,vnr)
      CALL inivar(version)
      CALL impldef
      CALL ckfile('delrem.h',4,fctrl)
      infile=5
      CALL mkfram(infile,finfil,'standard input')
* if the input should be read from a file, finfil will be negative and the
* filename will have been stored in <buf>
      CALL clear(card,128)
      card='fort.2' 
      IF (finfil.LT.0) THEN
       CALL ckfile(buf,4,finfil)
       CALL tlength(buf,l)
       DO i=l,1,-1
        IF (buf(i:i).EQ.'.') GOTO 10
       ENDDO
       i=l
10     l=i
       card='TMP.'//buf(1:l)//'f'
      ENDIF
      CALL tlength(card,l)
      OPEN (UNIT=OUT,FILE=card(1:l),FORM='FORMATTED',STATUS='UNKNOWN',
     * IOSTAT=i)
      WRITE (idbg,*) 'open file <',card(1:l),'> for output, RC=',i

      IF (fctrl.EQ.0) THEN
       cfram=finfil
      ELSE
       fn(fctrl)=finfil
       cfram=fctrl
      ENDIF
      nr=0

1     CALL flsh(out)
      CALL getbuf(ieof,0)
      IF (ieof.GT.0) GOTO 2

      card=q(1)

      IF (card(1:8) .EQ. '#define ') THEN
       CALL dcpp(card,irc)
       GOTO 1
      ENDIF

*     C// cards
      CALL dcmd(card,irc)
      IF (irc.EQ.0) GOTO 1

*     treat conditionally commented cards

      DO 68 i=1,iq
       CALL ccard(q(i),outc,iret,ieof)
       IF (IRET.EQ.1) GOTO 1
68    CONTINUE

      IF (comment_card(q(1))) GOTO 1

*     INCLUDE cards
      CALL incc(q(1),irc)
      IF (irc.EQ.0) GOTO 1

* perform brace substitution
      CALL brace(irc)
      if (irc.NE.0) GOTO 1

      CALL preprec(rec)
      IF (rec(1:1).EQ.' ') GOTO 1

      CALL setstat(card,rec)

      IF (IENBL.GT.0 .OR. ISAVS.GT.0 .OR. IIMPL.GT.0)
     *CALL DTRC(CARD,REC,OUTC,IRET)
      GOTO 1

* end of file

2     CONTINUE
      CALL runout(vnr)
      STOP
      END
****************************************************************************
* get the first and last location of the first argument on the line
****************************************************************************
      SUBROUTINE argloc(rec,il,ir)
      IMPLICIT none
      INCLUDE 'cmn.h'
      CHARACTER*(*) rec
      INTEGER i,l,il,ir,ipast,irc
      LOGICAL quote,dquote
      quote=.FALSE.
      dquote=.FALSE.
      irc=0
      CALL getl(l,rec)
      il=1
      ipast=0
      DO 1 i=1,l
       IF (rec(i:i).EQ.'''') quote=.NOT.quote
       IF (rec(i:i).EQ.'"') dquote=.NOT.dquote
       IF (.NOT.quote .AND. .NOT.dquote) THEN
        IF (rec(i:i).EQ.'(') irc=irc+1
        IF (rec(i:i).EQ.')') irc=irc-1
         IF (irc.GT.0.AND.ipast.EQ.0) THEN
          ipast=1
          il=i+1
         ENDIF
         IF (irc.EQ.0.AND.ipast.EQ.1) THEN
          ir=i-1
          GOTO 999
         ENDIF
       ENDIF
1     CONTINUE
      ir=l
999   CONTINUE
C@    WRITE (idbg,*) 'argloc| ','<',rec,'>',il,ir
      RETURN
      END
******
****** brace substitution {cond:string|cond:string|string}
****** cond may be a cond character for the time being
******
      SUBROUTINE brace(jrc)
      IMPLICIT none
      INCLUDE 'cmn.h'
      INTEGER jrc
      INTEGER jq,i,j,k,i1,i2,i3,i4,done
      jrc=0
      jq=iq
      DO i=1,jq
       CALL dmatch(q(i),'{','}',i1,i2)
       IF (i1.NE.0) THEN
        CALL queue(q(i))
        q(iq)(1:6)='CDbra '
* check conditions
        done=0
        j=i1+1
        q(i)(i2:i2)='|'
        q(i)(i1:i1)=' '
1       IF (j.GE.i2) GOTO 2
        CALL match(q(i)(j:i2),'|',i3)
        i3=j+i3-2
        IF (done.NE.0) THEN
         GOTO 4
        ELSE
         q(i)(i3+1:i3+1)=' '
        ENDIF
* condition?
        CALL match(q(i)(j:i3),':',i4)
        IF (i4+done.EQ.0) GOTO 2
        i4=j+i4-2
C@      WRITE (idbg,*) ' brace| ',j,i4,'[',q(i)(j:i4),']'

* empty condition is considered met
        IF (j.GT.i4) GOTO 3

* check condition
        DO k=1,idel
         IF (del(k)(2:2).EQ.q(i)(j:i4) .AND. iatt(k).EQ.1) GOTO 3
        ENDDO
        
* clear this alternative
4       q(i)(j:i3+1)=' '
        j=i3+2
        GOTO 1

* condition met; clear condition text
3       CONTINUE
        q(i)(j:i4+1)=' '
        done=1
        j=i3+2
        GOTO 1

2       CONTINUE
       ENDIF
      ENDDO
      RETURN
      END
******
****** PROCESS COMMENTS AND SKIP CARDS
******
      SUBROUTINE CCARD(CARD,OUTC,IRET,jeof)
      CHARACTER*128 CARD,OUTC
      INCLUDE 'cmn.h'
      IRET=0
C
C     C//SKIPC# CARD
C
      IF (CARD(1:7).EQ.'C//SKIP') THEN
       DO 11 I=1,IDEL
       IF (DEL(I).EQ.CARD(8:9) .AND. iatt(i).EQ.1) THEN
       IRET=1
       IF (CARD(10:10).EQ.' ') THEN
        ISKIP=1000000
       ELSE
        ISKIP=0
        J=10
22      K=-1
        IF (CARD(J:J).EQ.'0') K=0
        IF (CARD(J:J).EQ.'1') K=1
        IF (CARD(J:J).EQ.'2') K=2
        IF (CARD(J:J).EQ.'3') K=3
        IF (CARD(J:J).EQ.'4') K=4
        IF (CARD(J:J).EQ.'5') K=5
        IF (CARD(J:J).EQ.'6') K=6
        IF (CARD(J:J).EQ.'7') K=7
        IF (CARD(J:J).EQ.'8') K=8
        IF (CARD(J:J).EQ.'9') K=9
         IF (K.GE.0) THEN
          ISKIP=10*ISKIP+K
          J=J+1
          GOTO 22
         ENDIF
        ENDIF
        CARD(2:3)=DIRSIG
        CALL GETL(INPL,OUTC)
        WRITE (OUT,101) OUTC(1:INPL)
        IQ=0
        CALL display(card)

        IF (IDEBUG.GT.0) WRITE (IDEBUG,'(A,I10,I10,I10,A,A)')
     *  'CCARD: skip ',ISKIP,IBFRD,IQ,' : ',CARD(1:INPL)
        OUTSIG=' #'
        DO 12 J=1,ISKIP
        CALL getbuf(jeof,1)
        IF (jeof.GT.0) GOTO 2
        CARD(1:2)=DEL(I)
        CARD(1:1)='c'
        NC2=NC2+1
        CALL GETL(INPL,CARD)
        WRITE (OUT,101) CARD(1:INPL)
        IF (IDEBUG.GT.0) WRITE (IDEBUG,'(A,I10,A,A)')
     *  'CCARD: skip ',J,' : ',CARD(1:INPL)
        IF (IDEBUG.GT.0) WRITE (IDEBUG,'(A,I10,A,A)')
     *  'CCARD: BUF  ',J,' : ',BUF
        IF (CARD(3:6).EQ.'/END') GOTO 2
12      CONTINUE
        GOTO 2
       ENDIF
11     CONTINUE
       CARD(2:3)='--'
       GOTO 2
      ENDIF
      IF (card(1:1).EQ.'c') card(1:1)='C'
      CALL ffin(card(1:2),katt,irt)
      IF (katt.EQ.1) THEN
       CARD(1:2)='  '
       NC1=NC1+1
      ENDIF
****** handle DO/ENDDO
      IF (IENDDO.GT.0) CALL CENDDO(CARD)
****** check for hex constants
      IF (IHEXX.GT.0) CALL CHEX(CARD)
100   FORMAT((A))
101   FORMAT((A))
660   FORMAT(1X,I5,' | ',(A))
      RETURN
2     IRET=0
      OUTSIG=' |'
      RETURN
      END
      SUBROUTINE ckfile(f,jn,fctrl)
      IMPLICIT none
      INCLUDE 'cmn.h'
      CHARACTER*(*) f
      INTEGER jn,fctrl
      LOGICAL zex
      fctrl=0
      INQUIRE (FILE=f,EXIST=zex)
      IF (zex) THEN
       OPEN (UNIT=jn,FILE=f,FORM='FORMATTED',STATUS='UNKNOWN')
       WRITE (idbg,*) 'ckfile| reading ',f
       CALL mkfram(jn,fctrl,f)
       CLOSE (UNIT=jn)
      ENDIF
      RETURN
      END
      SUBROUTINE ckdim(i,j,t1,t2)
      IMPLICIT none
      CHARACTER*(*) t1,t2
      INTEGER i,j
      IF (i.GT.j) THEN
       WRITE (*,*) 'fatal error: need more than ',j,t1
       WRITE (*,*) 'increase parameter ',t2,' and recompile DELREM'
       STOP 'dimension overflow'
      ENDIF
      RETURN
      END
*
* stack a single card to frame
*
      SUBROUTINE sframe(fctrl,c)
      IMPLICIT none
      INCLUDE 'cmn.h'
      INTEGER fctrl
      CHARACTER*(*) c
      ifram=ifram+1
      CALL ckdim(ifram,mxfram,'frames','mxfram')
      fs(ifram)=ifileb+1
      fe(ifram)=ifileb+1
      ifileb=ifileb+1
      CALL ckdim(ifileb,mxcard,'card slots','mxcard')
      fn(ifram)=fctrl
      fileb(ifileb)=c
      fctrl=ifram
      RETURN
      END
*
* stack a single card to frame
*
      SUBROUTINE flshframe(fctrl)
      IMPLICIT none
      INCLUDE 'cmn.h'
      INTEGER fctrl,i,i1,i2
      CHARACTER*128 c
      CALL wipe(c)
1     CONTINUE
      IF (fctrl.EQ.0) RETURN
      i1=fs(fctrl)
      i2=fe(fctrl)
      fctrl=fn(fctrl)
      DO i=i1,i2
       c=fileb(i)
       CALL stack(c)
      ENDDO
      GOTO 1
      END
******
****** decode C// command card
******
      SUBROUTINE DCMD(REC,IRC)
      INCLUDE 'cmn.h'
      CHARACTER*(*) REC
      CHARACTER*80 CARD
      CHARACTER*80 scname
C
C@    WRITE (idbg,*) '  dcmd|           : [',card(1:10),']'
      irc=-1
      IF (rec(1:3) .NE. 'C//' .AND. card(1:3) .NE. 'c//') GOTO 1

      CARD(1:80)=REC(1:80)
      IRC=0

      IF (CARD(1:7).EQ.'C//FILE') THEN
       IF (leave.EQ.0) CALL filec(card)
       RETURN
      ENDIF
C
C     C//PROTO XXX CARD
C
C     C//DELC# CARD
C
      IF (CARD(1:6).EQ.'C//DEL') THEN
       CALL fnew(card(7:8),-1,iret)
       IF (iret.LT.0) THEN
        card(2:6)=' inv '
       ELSE
        IF (iatt(iret).EQ.1) card(2:6)=' act '
        IF (iatt(iret).EQ.2) card(2:6)=' dea '
       ENDIF
       Q(1)=CARD
       CALL display(card)
       RETURN
      ENDIF
C
C     C//DEFC# CARD
C
      IF (CARD(1:6).EQ.'C//DEF') THEN
       CALL defdef(rec,irc)
       RETURN
      ENDIF

      IF (CARD(1:8).EQ.'C//LEAVE') THEN
       LEAVE=1
       RETURN
      ENDIF

C
C     C//FLOW CARD
C
      IF (CARD(1:7).EQ.'C//FLOW') THEN
      IF (IENBL.EQ.1) THEN
      IFLOW=1
      CARD(2:3)=DIRSIG
      ELSE
      CARD(2:3)='--'
      ENDIF
      CARD(10:16)=UNIT
      Q(1)=CARD
      CALL display(card)
      GOTO 1
      ENDIF
C
C     C//NOFLOW
C
      IF (CARD(1:9).EQ.'C//NOFLOW') THEN
       iflow=0
       CARD(2:3)=DIRSIG
       Q(1)=CARD
       CALL display(card)
       GOTO 1
      ENDIF
C
C     C//SAVE CARD
C
      IF (CARD(1:7).EQ.'C//SAVE') THEN
      ISAVS=1
      CARD(2:3)=DIRSIG
      Q(1)=CARD
      CALL display(card)
      GOTO 1
      ENDIF
C
C     C//ENDDO CARD
C
      IF (CARD(1:8).EQ.'C//ENDDO') THEN
      IENDDO=1
      CARD(2:3)=DIRSIG
      Q(1)=CARD
      CALL display(card)
      GOTO 1
      ENDIF
C
C     C//HEXINIT CARD
C
      IF (CARD(1:6).EQ.'C//HEX') THEN
      IHEXX =1
      CARD(2:3)=DIRSIG
      Q(1)=CARD
      CALL display(card)
      GOTO 1
      ENDIF
C
C     C//DEBUG CARD
C
      IF (CARD(1:8).EQ.'C//DEBUG') THEN
      IDEBUG=41
      WRITE (*,*) '***** WRITING INTERNAL DELREM DEBUGGING MESSAGES TO'
      WRITE (*,*) '***** LOGICAL UNIT ',IDEBUG
      CARD(2:3)=DIRSIG
      Q(1)=CARD
      CALL display(card)
      GOTO 1
      ENDIF
C
C     C//IMPLICIT
C
      IF (CARD(1:7).EQ.'C//IMPL') THEN
      ISAVS=1
      IIMPL=1
      CARD(2:3)=DIRSIG
      Q(1)=CARD
      CALL display(card)
      GOTO 1
      ENDIF
C
C     C//TRACE CARD
C
      IF (CARD(1:8).EQ.'C//TRACE') THEN
      IF (IENBL.EQ.1) THEN
      ITRACE=1
      iupper=1
      CARD(2:3)=DIRSIG
      ELSE
      CARD(2:3)='--'
      ENDIF
      CARD(10:16)=UNIT
      Q(1)=CARD
      CALL display(card)
      GOTO 1
      ENDIF
C
C     C//TIO   CARD
C
      IF (CARD(1:6).EQ.'C//TIO') THEN
      IF (IENBL.EQ.1) THEN
      ISTIO=1
      CARD(2:3)=DIRSIG
      ELSE
      CARD(2:3)='--'
      ENDIF
      CARD(10:16)=UNIT
      Q(1)=CARD
      CALL display(card)
      GOTO 1
      ENDIF
C
C     C//UPPER CARD
C
      IF (CARD(1:8).EQ.'C//UPPER') THEN
      IUPPER=1
      CARD(2:3)=DIRSIG
      Q(1)=CARD
      CALL display(card)
      GOTO 1
      ENDIF
C
C     C//NOTRACE CARD
C
      IF (CARD(1:10).EQ.'C//NOTRACE') THEN
      IF (IENBL.EQ.1) THEN
      IF (ITRACE.GT.0) THEN
      NCTR=NCTR+ITRACE-1
      ITRACE=0
      CARD(2:3)=DIRSIG
      ELSE
      CARD(2:3)=' ?'
      ENDIF
      ELSE
      CARD(2:3)='--'
      ENDIF
      Q(1)=CARD
      CALL display(card)
      GOTO 1
      ENDIF
C
C     C//WATCHI X
C
      IF (CARD(1:9).EQ.'C//WATCHI') THEN
      IF (IENBL.EQ.1) THEN
       IF (NWATI.GE.MXWAT) THEN
        IERR=1
        CALL display(card)
        WRITE (6,662) MXWAT
662     FORMAT(' ###### cannot watch more than ',I5,
     *   ' integer variables.')
        GOTO 1
       ENDIF
       NWATI=NWATI+1
       CARD(2:3)=DIRSIG
       CALL CLEAR(CWATI(NWATI),80)
       CALL GETNAM(CARD,CWATI(NWATI),10)
       CALL GETL(INPL,CWATI(NWATI))
       CALL wipe(scname)
       scname(1:inpl)=cwati(nwati)(1:inpl)
       CALL makescal(scname(1:inpl))
       IF (ixstat(5)+ixstat(6).EQ.0) THEN
        CALL clear(bufscr,128)
        JP=0
        CALL putc(bufscr,jp,'*','      INTEGER ')
        CALL putc(bufscr,jp,'N',scname(1:inpl))
        CALL putc(bufscr,jp,'N','_')
        CALL queue(bufscr)
       ELSE
        WRITE (*,*) '*ERROR* WATCHI must be placed before executables'
       ENDIF
       CALL wipe(bufscr)
       jp=0
       CALL putc(bufscr,jp,'*','      ')
       CALL putc(bufscr,jp,'N',scname(1:inpl))
       CALL putc(bufscr,jp,'N','_=-999999')
       CALL sframe(ifex,bufscr)
      ELSE
       CARD(2:3)='--'
      ENDIF
      Q(1)=CARD
      CALL display(card)
      GOTO 1
660   FORMAT(1X,I5,' | ',(A))
      ENDIF
C
C     C//WATCHR X
C
      IF (card(1:9).EQ.'C//WATCHR') THEN
      IF (ienbl.EQ.1) THEN
       IF (nwatr.GE.mxwat) THEN
        ierr=1
        CALL display(card)
        WRITE (6,661) mxwat
661     FORMAT(' ###### cannot watch more than ',I5,
     *   ' real*8 variables.')
        GOTO 1
       ENDIF
       nwatr=nwatr+1
       card(2:3)=dirsig
       CALL clear(cwatr(nwatr),80)
       CALL getnam(card,cwatr(nwatr),10)
       CALL getl(inpl,cwatr(nwatr))
       CALL wipe(scname)
       scname(1:inpl)=cwatr(nwatr)(1:inpl)
       CALL makescal(scname(1:inpl))
       IF (ixstat(5)+ixstat(6).EQ.0) THEN
        CALL clear(bufscr,128)
        JP=0
        CALL putc(bufscr,jp,'*','      REAL*8 ')
        CALL putc(bufscr,jp,'N',scname(1:inpl))
        CALL putc(bufscr,jp,'N','_')
        CALL queue(bufscr)
       ELSE
        WRITE (*,*) '*ERROR* WATCHR must be placed before executables'
       ENDIF
       jp=0
       CALL putc(bufscr,jp,'*','      ')
       CALL putc(bufscr,jp,'N',scname(1:inpl))
       CALL putc(bufscr,jp,'N','_=-999999')
       CALL sframe(ifex,bufscr)
      ELSE
       CARD(2:3)='--'
      ENDIF
      Q(1)=CARD
      CALL display(card)
      GOTO 1
      ENDIF
C
C     C//MEMCHK X
C
      IF (CARD(1:9).EQ.'C//MEMCHK') THEN
      MEMCHK=1
      CARD(2:3)=DIRSIG
      CALL CLEAR(CMEMCK,8)
      CALL GETNAM(CARD,CMEMCK,10)
      IF (IENBL.EQ.0 .AND. cmemck(1:1).NE.'*') THEN
       memchk=0
       CARD(2:3)='--'
      ENDIF
      Q(1)=CARD
      CALL display(card)
      GOTO 1
      ENDIF
C
C     C//MEMOFF
C
      IF (CARD(1:9).EQ.'C//MEMOFF') THEN
       memchk=0
       CARD(2:3)=DIRSIG
       Q(1)=CARD
       CALL display(card)
       GOTO 1
      ENDIF
C
C     C//WATCHOFF
C
      IF (CARD(1:11).EQ.'C//WATCHOFF') THEN
      nwati=0
      nwatr=0
      CARD(2:3)=DIRSIG
      Q(1)=CARD
      CALL display(card)
      GOTO 1
      ENDIF
C
C     C//ENABLE CARD
C
      IF (CARD(1:9).EQ.'C//ENABLE') THEN
      IENBL=1
      CARD(2:3)=DIRSIG
      Q(1)=CARD
      CALL display(card)
      GOTO 1
      ENDIF
C
C     C//PROFILE CARD
C
      IF (CARD(1:10).EQ.'C//PROFILE') THEN
      IENBL=1
      ISTAT=1
      ISPROF=1
      CARD(2:3)=DIRSIG
      Q(1)=CARD
      CALL display(card)
      GOTO 1
      ENDIF
C
C     C//POINTER n
C
      IF (CARD(1:10).EQ.'C//POINTER') THEN
      ipointer=INTGR(card(11:25),IP,14)
      IF (ipointer.EQ.0) ipointer=1000000
      WRITE (card(50:63),'(I14)') ipointer
      CARD(2:3)=DIRSIG
      Q(1)=CARD
      CALL display(card)
      GOTO 1
      ENDIF
C
C     C//REPORT CARD
C
      IF (CARD(1:9).EQ.'C//REPORT') THEN
      IF (ISPROF.GT.0) THEN
      IREP=-1
      CALL REPORT
      CARD(2:3)=DIRSIG
      ELSE
      CARD(2:3)='--'
      ENDIF
      Q(1)=CARD
      CALL display(card)
      GOTO 1
      ENDIF
C
C     C//SAMPLE CARD
C
      IF (CARD(1:9).EQ.'C//SAMPLE') THEN
      IF (ISTAT.NE.0) THEN
      ITIM=INTGR(CARD(10:30),IP,10)
      IF (ITIM.LE.0) ITIM=100000
      CARD(2:3)=DIRSIG
      WRITE (CARD(10:30),'(I10,10X)') ITIM
      ELSE
      CARD(2:3)='--'
      ENDIF
      Q(1)=CARD
      CALL display(card)
      GOTO 1
      ENDIF
      IRC=-1
1     RETURN
      END
****************************************************************************
* determine if <left> and <right> are substrings in <rec>
****************************************************************************
      SUBROUTINE dmatch(rec,left,right,irc,jrc)
      IMPLICIT none
      CHARACTER*(*) rec,left,right
      INTEGER irc,jrc,idbg
      idbg=41
      CALL match(rec,left,irc)
      IF (irc.LE.0) RETURN
      CALL match(rec(irc+1:),right,jrc)
      IF (jrc.EQ.0) THEN
       irc=-irc
       return
      ENDIF
      jrc=jrc+irc
C@    WRITE (idbg,*) 'dmatch:',left,right,irc,jrc
      RETURN
      END
      SUBROUTINE DTRC(CARD,REC,OUTC,IRET)
      CHARACTER*128 CARD,OUTC,TREC,VAR,T72
      CHARACTER*(*) REC
      LOGICAL LCARD
      INCLUDE 'cmn.h'
      EQUIVALENCE (TREC,T72)
      CALL CLEAR(VAR,128)
      IF (ixstat(8).EQ.tend) RETURN
      IF (ixstat(8).EQ.tentry) RETURN
C
C     DO NOT TRACE NON-EXECUTABLE STATEMENTS
C
      IF (REC(1:10).EQ.'SUBROUTINE' .OR.
     *REC(1:7) .EQ.'PROGRAM') THEN
       J=11
       IF (REC(1:1).EQ.'P') THEN
        J=8
       ENDIF
       IF (IFLOW.LT.0) IFLOW=1
       IF (ISTAT.LT.0) ISTAT=1
       ILX=0
       ILY=90000
       DO 41 I=1,9999
41     ILA(I)=0
       UNIT='      '
       DO 15 I=J,J+5
       IF (REC(I:I).EQ.' '.OR.REC(I:I).EQ.'(') GOTO 17
       UNIT(I-J+1:I-J+1)=REC(I:I)
15     CONTINUE
17     CONTINUE
       CALL CHKPAR(REC,IPAR)
       WRITE (*,'(A,''['',I3,'']'')') UNIT,IPAR
       IF (ISTAT.EQ.0) RETURN
       IF (NSUB.GE.MXSUB) THEN
        WRITE (*,*) UNIT,' not profiled - too many subroutines.'
        ISTAT=-2
        RETURN
       ENDIF
       NSUB=NSUB+1
       ISUB(NSUB)=NR
       RETURN
      ENDIF
      IF (REC(1:8).EQ.'IMPLICIT') THEN
* insert SAVE statement after IMPLICIT, if requested
       IF (ISAVS.GT.0) THEN
        IF (UNIT(1:4).EQ.'MAIN') RETURN
        CALL CLEAR(T72,128)
        T72(7:10)='SAVE'
        CALL QUEUE(T72)
       RETURN
       ENDIF
      ENDIF
      IF (IENBL.EQ.0) RETURN
C
C     READ statements
C
      IF (ISTIO.GT.0) THEN
       CALL CHKTIO(REC,IPAR)
      ENDIF
      
C
C     HANDLE DO STATEMENT
C
      IF (ixstat(8).EQ.tdoloop) THEN
       CALL PROF02
       CALL DOLOOP(CARD,REC)
      ENDIF

      IF (IFLOW.EQ.0 .AND. ITRACE.EQ.0 .AND. ISTAT.EQ.0 .AND.
     * NWATI.EQ.0 .AND. NWATR.EQ.0 .AND. MEMCHK.EQ.0
     * ) GOTO 999
      IF (REC(1:6).EQ.'FORMAT') RETURN
      IF (REC(1:9).EQ.'CHARACTER') RETURN
      IF (REC(1:9).EQ.'PARAMETER') RETURN
      IF (REC(1:9).EQ.'DIMENSION') RETURN
      IF (REC(1:9).EQ.'BLOCKDATA') RETURN
      IF (REC(1:9).EQ.'EQUIVALEN') RETURN
      IF (REC(1:8).EQ.'NAMELIST') RETURN
      IF (REC(1:8).EQ.'EXTERNAL') RETURN
      IF (REC(1:8).EQ.'IMPLICIT') RETURN
      IF (REC(1:7).EQ.'INTEGER') RETURN
      IF (REC(1:7).EQ.'POINTER') RETURN
      IF (REC(1:4).EQ.'REAL') RETURN
      IF (REC(1:6).EQ.'DOUBLE') RETURN
      IF (REC(1:7).EQ.'LOGICAL') RETURN
      IF (REC(1:4).EQ.'DATA') THEN
       IF (ISPROF.GT.0) CALL PROF01
       RETURN
      ENDIF
      IF (REC(1:4).EQ.'SAVE') RETURN
      IF (REC(1:4).EQ.'ELSE') GOTO 999
      IF (REC(1:6).EQ.'COMMON') RETURN
      IF (REC(1:5).EQ.'ENDIF') RETURN
      IF (REC(1:6).EQ.'END IF') RETURN
C
      IF (ISPROF.GT.0.AND.ISTAT.NE.0) THEN
       IF (IDEBUG.GT.0) WRITE (IDEBUG,'(A,I10,I10)')
     *  'DTRC : prof ',ISPROF,ISTAT
       IF (ISTAT.EQ.-1) THEN
C
C     MAKE SURE THAT IT IS NOT A STATEMENT FUNCTION DEFINITION
        CALL indx(REC,72,'=',IRC)
        IF (IRC.GT.0) THEN
         CALL indx(REC,IRC,'(',JRC)
         IF (JRC.GT.0) RETURN
        ENDIF
       ENDIF
       IF (REC(1:6).EQ.'END   ') THEN
C
C      BUG: FUNCTIONS ARE NOT PROFILED. DO LOOP PROFILING TERMINATES
C      AT AN END STATEMENT
       ISTAT=-3
       RETURN
       ENDIF
      CALL PROF02
      ENDIF
      IF (IFLOW.GT.0) THEN
*      make sure it's not a statement function definiton
       CALL indx(REC,72,'=',IRC)
       IF (IRC.GT.0) THEN
        CALL indx(REC,IRC,'(',JRC)
        IF (JRC.GT.0) RETURN
       ENDIF
       CALL CLEAR(VAR,128)
       VAR(7:13)='entered'
       CALL mktrec(trec,unit,var)
       CALL STACK(T72)
       CALL CLEAR(TREC,128)
       TREC(6:17)=' WRITE (*,*)'
       CALL STACK(T72)
       IFLOW=-IFLOW
      ENDIF
      IF (ISTAT.NE.0.AND.ISTAT.GE.-2) THEN
       IF (REC(1:8).EQ.'CONTINUE') GOTO 701
       IF (REC(1:4).EQ.'STOP') THEN
       IF (ISPROF.GT.0) CALL REPORT
       GOTO 701
      ENDIF
      IF (REC(1:6).EQ.'RETURN') GOTO 701
      IF (REC(1:4).EQ.'GOTO') GOTO 701
      IF (REC(1:2).EQ.'DO') GOTO 701
C     -- START PROFILING BLOCK --
      IF (ISPROF.GT.0) THEN
C
C       EXECUTED FORTRAN STATEMENTS
CC      CALL CLEAR(TREC,128)
CC      WRITE (TREC(6:80),700) JDO(IDO),JDO(IDO)
CC700   FORMAT(' IDELR05(',I5,') = IDELR05(',I5,') +1')
CC      CALL QUEUE(T72)
        IF (ITIM.GT.0) THEN
        CALL CLEAR(T72,128)
        WRITE (TREC(6:72),300) NR
300     FORMAT(' IDELR22=',I10)
        CALL QUEUE(T72)
        ENDIF
C
C       DO NOT EXAMINE I/O STATEMENTS
        IF (LCARD(REC,'READ',0,IRC)) GOTO 704
        IF (LCARD(REC,'RETURN',0,IRC)) GOTO 704
        CALL FLOP(REC,NFLOP)
        IF (NFLOP.EQ.0) GOTO 701
        CALL CLEAR(TREC,128)
        IF (IDO.GT.1) THEN
        WRITE (TREC(6:80),702) JDO(IDO),JDO(IDO),NFLOP
702     FORMAT(' IDELR07(',I5,') = IDELR07(',I5,') +',I10)
        ELSE
        WRITE (TREC(6:80),703) NSUB,NSUB,NFLOP
703     FORMAT(' IDELR09(',I5,') = IDELR09(',I5,') +',I10)
        ENDIF
        CALL QUEUE(T72)
       ENDIF
C      -- END OF PROFILING BLOCK --
701    CONTINUE
      ENDIF
      IF (IFLOW.NE.0) THEN
       IF (REC(1:4).EQ.'CALL') THEN
C      -- prepend to stack --
        CALL MKTREC(TREC,UNIT,CARD)
        CALL STACK(T72)
        CALL CLEAR(TREC,128)
        TREC(6:17)=' WRITE (*,*)'
        CALL STACK(T72)
C      -- append at end of stack --
        CALL CLEAR(TREC,128)
        TREC(6:17)=' WRITE (*,*)'
        CALL QUEUE(T72)
        CALL CLEAR(VAR,128)
        VAR(7:23)='... returned from'
        CALL MKTREC(TREC,UNIT,VAR)
        CALL QUEUE(T72)
        CALL CLEAR(TREC,128)
        TREC(6:17)=' WRITE (*,*)'
        CALL QUEUE(T72)
        CALL MKTREC(TREC,UNIT,CARD)
        CALL QUEUE(T72)
       ENDIF
C      trace RETURN statement if we are still in a subroutine (ISTAT.GT.0)
       IF (ISTAT.GT.0.AND.REC(1:7).EQ.'RETURN') THEN
        CALL MKTREC(TREC,UNIT,CARD)
        CALL STACK(T72)
        CALL CLEAR(TREC,128)
        TREC(6:17)=' WRITE (*,*)'
        CALL STACK(T72)
       ENDIF
      ENDIF
C      do not watch cards that do not return
      IF (LCARD(REC,'RETURN',0,IRC)) GOTO 704
      IF (LCARD(REC,'STOP',0,IRC)) GOTO 704
      IF (LCARD(REC,'END',0,IRC)) GOTO 704
      IF (ixstat(8).EQ.tgoto) GOTO 704
* memchk
      IF (memchk.GT.0 .AND. cmemck(1:1).NE.'*') THEN
       CALL CLEAR(BUFSCR,128)
       JP=0
       CALL PUTC(BUFSCR,JP,'*','      CALL memmgr(memchk,''')
       CALL PUTC(BUFSCR,JP,'*',UNIT)
       WRITE (BUFSCR(JP:JP+7),'(I8)') NR-1
       JP=JP+8
       CALL PUTC(BUFSCR,JP,'*',''',')
       CALL PUTC(BUFSCR,JP,'N',CMEMCK)
       CALL PUTC(BUFSCR,JP,'*',',6,0)')
       CALL QUEUE(BUFSCR)
      ENDIF
      DO 8001 ip=1,nwati
       CALL CLEAR(BUFSCR,128)
       CALL PUTC(BUFSCR,JP,'I','      CALL delrut(1,''')
       CALL PUTC(BUFSCR,JP,'*',unit)
       CALL PUTC(BUFSCR,JP,'*',''',')
       WRITE (BUFSCR(JP:JP+7),'(I8)') NR-1
       JP=JP+8
       CALL PUTC(BUFSCR,JP,'*',',''')
       CALL PUTC(BUFSCR,JP,'N',CWATI(IP))
       CALL PUTC(BUFSCR,JP,'*',''',')
       CALL PUTC(BUFSCR,JP,'N',CWATI(IP))
       CALL PUTC(BUFSCR,JP,'*',',')
       CALL wipe(t72)
       t72=cwati(ip)
       CALL getl(lw,t72)
       CALL makescal(t72(1:lw))
       CALL PUTC(BUFSCR,JP,'N_',t72(1:lw))
       CALL PUTC(BUFSCR,JP,'*','_,0.0,0.0)')
       CALL QUEUE(BUFSCR)
8001  CONTINUE
      DO 8002 ip=1,nwatr
       CALL clear(bufscr,128)
       CALL putc(bufscr,jp,'I','      CALL DELRUT(2,''')
       CALL putc(bufscr,jp,'*',UNIT)
       CALL putc(bufscr,jp,'*',''',')
       WRITE (bufscr(jp:jp+7),'(I8)') NR-1
       JP=JP+8
       CALL putc(bufscr,jp,'*',',''')
       CALL putc(bufscr,jp,'N',CWATR(IP))
       CALL putc(bufscr,jp,'*',''',0,0,')
       CALL putc(bufscr,jp,'N',CWATR(IP))
       CALL putc(bufscr,jp,'*',',')
       CALL wipe(t72)
       t72=cwatr(ip)
       CALL getl(lw,t72)
       CALL makescal(t72(1:lw))
       CALL PUTC(BUFSCR,JP,'N_',t72(1:lw))
       CALL PUTC(BUFSCR,JP,'*','_)')
       CALL QUEUE(BUFSCR)
8002  CONTINUE
704   CONTINUE
      IF (itrace.NE.0 .AND. ixstat(8).GT.tend .AND.
     * ixstat(8).NE.tstop .AND. ixstat(8).NE.treturn) CALL trcgen(rec)
C
C     HANDLE DO LOOP TARGETS
C
999   IF (CARD(1:5).NE.'      ') CALL PLABEL(CARD)
      RETURN
      END
      SUBROUTINE filec(card)
      IMPLICIT none
      INCLUDE 'cmn.h'
      CHARACTER*(*) card
      INTEGER i,inpl
      CHARACTER*80 name

C@    WRITE (idbg,*) ' filec|             [',card(1:10),']'
C
C     C//FILE XXX CARD
C
      NC3=NC3+1
      CARD(1:3)='C'//DIRSIG
      CALL GETL(INPL,CARD)
      WRITE (OUT,101) CARD(1:INPL)
101   FORMAT((A))

C@    WRITE (idbg,*) ' filec| C//FILE card detected'
C
C      SEARCH FOR FILENAME, BEGINNING AT COLUMN 8
      CALL GETNAM(CARD,NAME,8)
      DO 34 I=1,NFIL
       IF (NAME.EQ.FILNAM(I)) THEN
        IERR=1
        WRITE (6,38) NR,NAME
38      FORMAT(1X,I5,' | DUPLICATE FILE: ',A60)
        CALL fend(ieof)
        GOTO 2
       ENDIF
 34   CONTINUE
C@    CALL getl(inpl,name)
C@    WRITE (idbg,*) ' filec| file name is ',name(1:inpl)
      CALL ckdim(nfil,mfil,'files','mfil')
      NFIL=NFIL+1
      FILNAM(NFIL)=NAME
      FIS(NFIL)=fs(cfram)
      CALL fend(ieof)
      IF (ieof.NE.0) GOTO 2
      fie(nfil)=fs(cfram)-2
C@    WRITE (idbg,*) ' filec| normal return ',nfil,fis(nfil),fie(nfil)
      RETURN
*
2     CONTINUE
C@    WRITE (idbg,*) ' filec| EOF/error return'
      RETURN
      END
      SUBROUTINE fend(jeof)
      IMPLICIT none
      INCLUDE 'cmn.h'
      INTEGER jeof
2     CALL getbuf(jeof,0)
      IF (jeof.NE.0) GOTO 1
      IF (q(1)(1:6).EQ.'C//END') GOTO 1
      GOTO 2
1     CONTINUE
      RETURN
      END
******
******
******
      SUBROUTINE FLSH(NTAPE)
      INCLUDE 'cmn.h'
      DO 1 I=1,IQ
      CALL GETL(L,Q(I))
      WRITE (NTAPE,100) Q(I)(1:L)
1     CONTINUE
      IQ=0
100   FORMAT((A))
      RETURN
      END
      INTEGER FUNCTION INTGR(X,I,MX)
      CHARACTER*20 X
      CHARACTER*128 F
      DO 3 J=1,MX
      IF (X(J:J).NE.' ') GOTO 4
3     CONTINUE
      INTGR=0
      RETURN
4     CONTINUE
      DO 1 I=J,MX
      IF (X(I:I).GT.'9' .OR. X(I:I) .LT. '0') GOTO 2
1     CONTINUE
      I=21
2     I=I-J
      IF (I.EQ.0) THEN
      INTGR=0
      RETURN
      ENDIF
      WRITE (F,100) I
100   FORMAT('(I',I2,')')
      READ (X(J:20),F) K
      INTGR=K
      RETURN
      END
******
******
******
      SUBROUTINE CLEAR(X,N)
      CHARACTER*128 X
      DO 1 I=1,N
1     X(I:I)=' '
      RETURN
      END
******
******
******
      SUBROUTINE DOLOOP(CARD,REC)
      INCLUDE 'cmn.h'
      CHARACTER*128 CARD,REC,VAR
C
      LABEL=INTGR(REC(3:22),IP,10)
      IF (LABEL.GT.90000) CALL BIGLAB(LABEL)
      IF (LABEL.EQ.0) RETURN
      CALL CLEAR(VAR,128)
      IP=IP+2
      CALL NEWLAB
      IF (ILA(LABEL).NE.0) THEN
      IF (ILA(LABEL).GT.0) THEN
      IF (ILX.EQ.MILX) THEN
      WRITE (*,*) '###### CANNOT HANDLE THAT MANY IDENTICAL TARGETS'
      WRITE (*,*) '###### SPECIFY DIFFERENT TARGETS FOR EACH DO LOOP'
      STOP 'DOLOOP: FATAL ERROR'
      ENDIF
      ILX=ILX+1
      ILB(ILX)=LABEL
      ILC(ILX)=ILA(LABEL)
      ILA(LABEL)=-1
      ENDIF
      IF (ILX.EQ.MILX) THEN
      WRITE (*,*) '###### CANNOT HANDLE THAT MANY IDENTICAL TARGETS'
      WRITE (*,*) '###### SPECIFY DIFFERENT TARGETS FOR EACH DO LOOP'
      STOP 'DOLOOP: FATAL ERROR'
      ENDIF
      ILX=ILX+1
      ILB(ILX)=LABEL
      ILC(ILX)=ILY
      ILA(LABEL)=ILA(LABEL)-1
      ELSE
      ILA(LABEL)=ILY
      ENDIF
      VAR(1:6)=CARD(1:6)
      VAR(7:10)='DO '
      WRITE (VAR(11:16),'(I5,1X)') ILY
      DO 21 I=72,1,-1
      IF (REC(I:I).NE.' ') GOTO 22
21    CONTINUE
22    CONTINUE
      IREST=I-IP
      IF (IREST.GT.55) THEN
      WRITE (*,*) '###### SPLIT THIS STMT AND CONTINUE ON NEXT CARD:'
      WRITE (*,*) CARD
      STOP 'DOLOOP: FATAL ERROR'
      ENDIF
      VAR(17:17+IREST)=REC(IP+1:IP+IREST)
      Q(1)(1:128)=VAR(1:128)
      IF (ISTAT.NE.0) CALL PRFDO(CARD)
      RETURN
      END
      SUBROUTINE PLABEL(CARD)
      INCLUDE 'cmn.h'
      CHARACTER*128 CARD,VAR
      LABEL=INTGR(CARD(1:6),IP,6)
      IF (LABEL.GT.90000) CALL BIGLAB(LABEL)
      IF (LABEL.LE.0) RETURN
      IF (ILA(LABEL).EQ.0) RETURN
      IF (ILA(LABEL).GT.0) THEN
      CALL CLEAR(VAR,128)
      WRITE (VAR,100) ILA(LABEL)
100   FORMAT(I5,' CONTINUE')
      CALL QUEUE(VAR)
      ILA(LABEL)=0
      IF (IDO.GT.1) IDO=IDO-1
      RETURN
      ENDIF
      N=-ILA(LABEL)
      DO 2 K=N,1,-1
      M=K
      DO 1 J=1,ILX
      IF (ILB(J).EQ.LABEL) M=M-1
      IF (M.EQ.0) THEN
      ILA(LABEL)=ILA(LABEL)+1
      CALL CLEAR(VAR,128)
      WRITE(VAR,100) ILC(J)
      CALL QUEUE(VAR)
      IF (IDO.GT.1) IDO=IDO-1
      GOTO 2
      ENDIF
1     CONTINUE
2     CONTINUE
      END
******
****** determine length of nonblank data in BUF
******
      SUBROUTINE GETL(INPL,BUF)
      CHARACTER*(*) BUF
      L=LEN(BUF)
      DO 1 I=L,1,-1
      IF (BUF(I:I).NE.' ') GOTO 2
1     CONTINUE
      I=1
2     INPL=I
      RETURN
      END
      SUBROUTINE REPORT
      CHARACTER*128 TREC,T72
      INCLUDE 'cmn.h'
      EQUIVALENCE (TREC,T72)
      IF (IREP.EQ.0) IREP=1
      CALL QSAVE
      CALL CLEAR(TREC,128)
      TREC(6:60)=
     *' OPEN (UNIT=99,FILE=''DYNAMIC'',FORM=''FORMATTED'')'
      CALL QUEUE(T72)
      CALL CLEAR(TREC,128)
      MAGIC=70291
      WRITE (TREC(6:80),200) NSUB,NR,MAGIC,MAGIC,MAGIC
200   FORMAT(' WRITE (99,*) 1,',I6,4(',',I6))
      CALL QUEUE(T72)
C
C     COMPUTE TOTAL NUMBER OF OPERATIONS
      CALL CLEAR(TREC,128)
      WRITE(TREC(6:80),205) 
205   FORMAT(' IDELR11=0')
      CALL QUEUE(T72)
      CALL CLEAR(TREC,128)
      WRITE(TREC(6:80),211)
211   FORMAT(' IDELR12=0')
      CALL QUEUE(T72)
      CALL CLEAR(TREC,128)
      CALL NEWLAB
      WRITE(TREC(6:80),206) ILY
206   FORMAT(' DO ',I10,' IDELR10=1,IDELR02')
      CALL QUEUE(T72)
      CALL CLEAR(TREC,128)
      TREC(6:80)=' IDELR11=IDELR11+IDELR09(IDELR10)'
      CALL QUEUE(T72)
      CALL CLEAR(TREC,128)
      WRITE (TREC(1:80),207) ILY
207   FORMAT(I5,' CONTINUE')
      CALL QUEUE(T72)
      CALL CLEAR(TREC,128)
      CALL NEWLAB
      WRITE(TREC(6:80),208) ILY
208   FORMAT(' DO ',I10,' IDELR10=1,IDELR04')
      CALL QUEUE(T72)
      CALL CLEAR(TREC,128)
      TREC(6:80)=' IDELR11=IDELR11+IDELR07(IDELR10)'
      CALL QUEUE(T72)
      CALL CLEAR(TREC,128)
      TREC(6:80)=' IDELR12=IDELR12+IDELR05(IDELR10)'
      CALL QUEUE(T72)
      CALL CLEAR(TREC,128)
      WRITE (TREC(1:80),209) ILY
209   FORMAT(I5,' CONTINUE')
      CALL QUEUE(T72)
      CALL CLEAR(TREC,128)
      TREC(6:80)=' WRITE (99,*) 4,0,IDELR11,IDELR12,0,0'
      CALL QUEUE(T72)
C
C     TIMING, IF AVAILABLE
      IF (ITIM.GT.0) THEN
C
C     WRITE TOTAL NUMBER OF TICS, INTERVAL, MXSTMT
      CALL QREC0(' WRITE (99,*) 5,0,IDELR20,IDELR21,IDELR24,0')
      CALL CLEAR(TREC,128)
      CALL NEWLAB
      CALL QREC1('('' DO'',I10,'' IDELR10=1,IDELR24'')',ILY)
      CALL QREC0(' IF (IDELR23(IDELR10).GT.0) THEN')
      CALL QREC0(' WRITE (99,*) 6,0,IDELR10,IDELR23(IDELR10),0,0')
      CALL QREC0(' ENDIF')
      CALL CLEAR(TREC,128)
      WRITE (TREC(1:80),309) ILY
309   FORMAT(I5,' CONTINUE')
      CALL QUEUE(T72)
      ENDIF
C
C     WRITE SUMMARY FOR SUBROUTINES
      CALL CLEAR(TREC,128)
      CALL NEWLAB
      CALL QREC1('('' DO '',I19,'' IDELR10=1,IDELR02'')',ILY)
      CALL QREC0(' IF (IDELR01(IDELR10).NE.0) THEN')
      CALL QREC0(
     *' WRITE (99,*) 2,0,IDELR10,IDELR01(IDELR10),IDELR09(IDELR10),0')
      CALL QREC0(' ENDIF')
      CALL CLEAR(TREC,128)
      WRITE (TREC(1:80),202) ILY
202   FORMAT(I5,' CONTINUE')
      CALL QUEUE(T72)
C
C     WRITE OUT SUMMARY FOR DO LOOPS
      CALL NEWLAB
      CALL CLEAR(TREC,128)
      WRITE(TREC(6:80),203) ILY
203   FORMAT(' DO ',I10,' IDELR10=1,IDELR04')
      CALL QUEUE(T72)
      CALL CLEAR(TREC,128)
      TREC(6:80)=' IF (IDELR03(IDELR10).NE.0) THEN'
      CALL QUEUE(T72)
      CALL CLEAR(TREC,128)
      TREC(6:80)=
     *' WRITE (99,*) 3,0,IDELR10,IDELR03(IDELR10),'
      CALL QUEUE(T72)
      CALL CLEAR(TREC,128)
      TREC(6:80)=
     *'*IDELR05(IDELR10),IDELR07(IDELR10)'
      CALL QUEUE(T72)
      CALL CLEAR(TREC,128)
      TREC(6:80)=' ENDIF'
      CALL QUEUE(T72)
      CALL CLEAR(TREC,128)
      WRITE (TREC(1:80),204) ILY
204   FORMAT(I5,' CONTINUE')
      CALL QUEUE(T72)
      CALL FLSH(OUT)
      CALL QRESTO
      RETURN
      END
      SUBROUTINE PROF01
C
C     MEMORY FOR STATISTICS ARRAYS
C     IDELR01    NUMBER OF CALLS TO A SUBROUTINE
C     IDELR03    NUMBER OF INSTANCES A DO LOOP WAS EXECUTED
C     IDELR05    NUMBER OF STATEMENTS EXECUTED WITHIN THAT DO LOOP
C     IDELR07    NUMBER OF FLOPS (APPROXIMATELY) EXECUTED IN DO LOOP
C     IDELR09    NUMBER OF FLOPS EXECUTED OUTSIDE DO LOOP IN SUBROUTINE
      INCLUDE 'cmn.h'
      CHARACTER*128 TREC,T72
      EQUIVALENCE (TREC,T72)
      IF (ISPROF.EQ.0.OR.ISTAT.LE.0) RETURN
C
C     MAKE SURE THAT DECLARATION STUFF COMES BEFORE ALL EXECUTABLES
C     (INCLUDING DATA)
      CALL QSAVE
C
C     WRITE MAXIMAL NUMBER OF SUBROUTINES AND MAX NO OF DO LOOPS
      CALL CLEAR(T72,128)
      WRITE (TREC(6:72),200) MXSUB,MXDOL,MXSTMT
200   FORMAT(' PARAMETER (IDELR02=',I5,',IDELR04=',I5,
     *',IDELR24=',I10,')')
      CALL QUEUE(T72)
      CALL CLEAR(T72,128)
      CALL QREC0(' COMMON /DELR01/ IDELR01(IDELR02),IDELR03(IDELR04),')
      CALL QREC0('*IDELR05(IDELR04),IDELR07(IDELR04),IDELR09(IDELR02)')
C
C     INTERVAL TIMER COMMON
      IF (ITIM.GT.0) CALL QREC0(
     *' COMMON /DELR03/ IDELR20,IDELR21,IDELR22,IDELR23(IDELR24)')
C
C     WRITE TO FORTRAN FILE
      CALL FLSH(OUT)
      CALL QRESTO
      ISTAT=-1
      RETURN
      END
      SUBROUTINE PROF02
C
C     CALLED WHEN THE 1ST EXECUTABLE STATEMENT IN A SUBROUTINE IS
C     ENCOUNTERED.
      INCLUDE 'cmn.h'
      CHARACTER*128 TREC,T72
      EQUIVALENCE (TREC,T72)
      IF (ISPROF.EQ.0.OR.ISTAT.LT.-1) RETURN
      IF (ISTAT.EQ.1) CALL PROF01
      IF (UNIT.EQ.'MAIN  ') CALL PROF03
      CALL QSAVE
      CALL CLEAR(T72,128)
      WRITE (TREC(6:72),201) NSUB,NSUB
201   FORMAT(' IDELR01(',I5,')=IDELR01(',I5,') + 1')
      CALL QUEUE(T72)
      CALL FLSH(OUT)
      CALL QRESTO
      ISTAT=-2
      CALL PROPEN
      ITYP=1
      WRITE (IPROF,202) ITYP,ISUB(NSUB),NSUB,UNIT
202   FORMAT(3I7,1X,A6)
      RETURN
      END
      SUBROUTINE PROF03
C
C     CALLED IN MAIN PROGRAM. STATISTICES ARRAYS ARE ZEROED
      INCLUDE 'cmn.h'
      CHARACTER*128 TREC,T72
      EQUIVALENCE (TREC,T72)
      IF (ISPROF.EQ.0) RETURN
      CALL QSAVE
      CALL CLEAR(T72,128)
      CALL NEWLAB
      WRITE (TREC(6:60),205) ILY
205   FORMAT(' DO ',I5,' IDELR00=1,IDELR02')
      CALL QUEUE(T72)
      CALL CLEAR(T72,128)
      TREC(6:60)=' IDELR09(IDELR00)=0'
      CALL QUEUE(T72)
      CALL CLEAR(T72,128)
      WRITE (TREC(1:60),206) ILY
206   FORMAT(I5,' IDELR01(IDELR00)=0')
      CALL QUEUE(T72)
      CALL CLEAR(T72,128)
      CALL NEWLAB
      WRITE (TREC(6:60),207) ILY
207   FORMAT(' DO ',I5,' IDELR00=1,IDELR04')
      CALL QUEUE(T72)
      CALL CLEAR(T72,128)
      TREC(6:60)=' IDELR05(IDELR00)=0'
      CALL QUEUE(T72)
      CALL CLEAR(T72,128)
      TREC(6:60)=' IDELR07(IDELR00)=0'
      CALL QUEUE(T72)
      CALL CLEAR(T72,128)
      WRITE (TREC(1:60),208) ILY
208   FORMAT(I5,' IDELR03(IDELR00)=0')
      CALL QUEUE(T72)
C
C     INTERVAL TIMER COMMON
      IF (ITIM.GT.0) THEN
      CALL QREC0(' IDELR20=0')
      CALL QREC1('('' IDELR21='',I10)',ITIM)
      CALL QREC1('('' IDELR22='',I10)',NR)
      CALL QREC0(' CALL DELR02(IDELR21)')
      ENDIF
      CALL FLSH(OUT)
      CALL QRESTO
      RETURN
      END
      SUBROUTINE PROPEN
      INCLUDE 'cmn.h'
      IF (IPROF.GT.0) RETURN
      IPROF=-IPROF
      OPEN (UNIT=IPROF,FILE='STATIC',FORM='FORMATTED',
     * STATUS='UNKNOWN')
      IBATCH=IBATCH+1
      RETURN
      END
      SUBROUTINE PRFDO(CARD)
      INCLUDE 'cmn.h'
      CHARACTER*128 TREC,T72,CARD
      EQUIVALENCE (TREC,T72)
      IF (ISTAT.LT.-2) RETURN
      IF (IDO.GE.MILX) THEN
       ISTAT=-3
       WRITE (*,*) 'cannot profile DO loop - too many nested DO loops:'
       WRITE (*,*) CARD
       RETURN
      ENDIF
      IF (NDOL.GE.MXDOL) THEN
       ISTAT=-3
       WRITE (*,*) 'cannot profile DO loop - too many DO loops:'
       WRITE (*,*) CARD
       RETURN
      ENDIF
      NDOL=NDOL+1
      IDO=IDO+1
      JDO(IDO)=NDOL
      CALL PROPEN
      ITYP=3
      WRITE (IPROF,202) ITYP,NR,NDOL,CARD(1:50)
202   FORMAT(3I5,1X,A60)
      CALL CLEAR(T72,128)
      WRITE (TREC(6:72),201) NDOL,NDOL
201   FORMAT(' IDELR03(',I5,')=IDELR03(',I5,') + 1')
      CALL QUEUE(T72)
      RETURN
      END
      SUBROUTINE XTRC(TXT,INT)
      CHARACTER*(*) TXT
      INCLUDE 'cmn.h'
      CHARACTER*128 TREC,T72
      EQUIVALENCE (TREC,T72)
      CALL CLEAR(T72,128)
      WRITE (TREC(1:72),201) TXT,INT
201   FORMAT('C xtrc: ',A,I10)
      CALL QUEUE(T72)
      RETURN
      END
      SUBROUTINE FLOP(REC,NFLOP)
      CHARACTER*(*) REC
      DATA NPLUS /1/, NTIMES /1/, NDIV /1/, NEXP /10/
      L=LEN(REC)
      NFLOP=0
      ITIMES=0
      DO 1 I=1,L
      IF (REC(I:I).EQ.'+') GOTO 10
      IF (REC(I:I).EQ.'-') GOTO 10
      IF (REC(I:I).EQ.'*') GOTO 20
      IF (REC(I:I).EQ.'/') GOTO 30
      IF (REC(I:I).EQ.' ') GOTO 1
      IF (ITIMES.EQ.0) GOTO 1
C
C     IF NTIMES =/= 0, WE HAVE DETECTED A * SIGN BEFORE
      ITIMES=0
      NFLOP=NFLOP+NTIMES
      GOTO 1
10    CONTINUE
      NFLOP=NFLOP+NPLUS
      GOTO 1
20    CONTINUE
      ITIMES=ITIMES+1
      IF (ITIMES.EQ.1) GOTO 1
C
C     WE FOUND AN EXPONENTIATION SIGN
      ITIMES=0
      NFLOP=NFLOP+NEXP
      GOTO 1
30    CONTINUE
      NFLOP=NFLOP+NDIV
1     CONTINUE
      RETURN
      END
      SUBROUTINE indx(REC,N,X,IRC)
C
C     GIVE THE indx OF X IN REX
      CHARACTER*(*) X
      CHARACTER*(*) REC
      L=LEN(X)
      DO 1 I=1,N
      IF (REC(I:I+L-1).EQ.X) GOTO 2
1     CONTINUE
      IRC=0
      RETURN
2     IRC=I
      RETURN
      END
      SUBROUTINE QSAVE
      INCLUDE 'cmn.h'
      SAVE
      CHARACTER*128 QQ(MAXC)
      IQS=IQ
      DO 1 I=1,IQ
1     QQ(I)=Q(I)
      IQ=0
      RETURN
      ENTRY QRESTO
      IQ=IQS
      DO 2 I=1,IQ
2     Q(I)=QQ(I)
      RETURN
      END
      SUBROUTINE NEWLAB
      INCLUDE 'cmn.h'
C
C     MAKE SURE THAT THE NEW LABEL HAS NOT SPECIFIED IN THE PROGRAM
C     BEFORE.
10    ILY=ILY+1
      DO 1 I=1,IBIGL
      IF (ILY.EQ.JBIGL(I)) GOTO 10
1     CONTINUE
      RETURN
      END
      SUBROUTINE BIGLAB(LABEL)
      INCLUDE 'cmn.h'
C
C     TEST IF IT ALREADY OCCURED AND HAS BEEN NOTED DOWN
      DO 1 I=1,IBIGL
      IF (LABEL.EQ.JBIGL(I)) RETURN
1     CONTINUE
C
C     TEST IF IT HAS ALREADY BEEN AUTOMATICALLY GENERATED
      IF (LABEL.LT.ILY) THEN
       WRITE (*,*) '###### CANNOT HANDLE LABEL ',LABEL
       WRITE (*,*) '###### USE LABELS < 90000.'
       STOP 'BAD LABEL (1)'
      ENDIF
C
C     REMEMBER THIS LABEL
      IBIGL=IBIGL+1
      IF (IBIGL.GT.MILX) THEN
       WRITE (*,*) '###### TOO MANY LABELS > 90000.'
       WRITE (*,*) '###### USE LABELS < 90000.'
       STOP 'BAD LABEL (2)'
      ENDIF
      JBIGL(IBIGL)=LABEL
      RETURN
      END
      SUBROUTINE QREC0(T)
      CHARACTER*(*) T
      CHARACTER*128 TREC,T72
      EQUIVALENCE (TREC,T72)
      CALL CLEAR(T72,128)
      WRITE (TREC(6:72),201) T
201   FORMAT(A)
      CALL QUEUE(T72)
      RETURN
      END
      SUBROUTINE QREC1(FORM,INT1)
      CHARACTER*(*) FORM
      CHARACTER*128 TREC,T72
      EQUIVALENCE (TREC,T72)
      CALL CLEAR(T72,128)
      WRITE (TREC(6:72),FORM) INT1
      CALL QUEUE(T72)
      RETURN
      END
      SUBROUTINE TIMI01
      INCLUDE 'cmn.h'
C
C     IDELR20      TOTAL NUMBER OF TICS
C     IDELR21      NUMBER OF MICROSECONDS PER TIC
C     IDELR22      STATEMENT NUMBER EXECUTING AT TIC TIME
C     IDELR23      NUMBER OF TICS FOR SPECIFIC STATEMENT
C     IDELR24      MAX NUMBER OF STATEMENTS
C 
      CALL QREC0(' SUBROUTINE DELR04')
      CALL QREC1('('' PARAMETER (IDELR24='',I10,'')'')',MXSTMT)
      CALL QREC0(' COMMON /DELR03/ IDELR20,IDELR21,IDELR22,')
      CALL QREC0('*IDELR23(IDELR24)')
      CALL QREC0(' IDELR20=IDELR20+1')
      CALL QREC0(' IF (IDELR22.GT.IDELR24) IDELR22=IDELR24')
      CALL QREC0(' IDELR23(IDELR22)=IDELR23(IDELR22)+1')
      CALL QREC0(' RETURN')
      CALL QREC0(' END')
      CALL FLSH(OUT)
      RETURN
      END
      SUBROUTINE LOGINP(MR,BU)
      CHARACTER*(*) BU
      INCLUDE 'cmn.h'
      L=LEN(BU)
      MR=MR+1
      CALL GETL(INPL,BU)
      WRITE (LOGF,100) MR,OUTSIG,BU(1:INPL)
100   FORMAT(I6,A2,' ',A)
      IF (IUPPER.EQ.1) CALL upper(bu,inpl)
      RETURN
      END
      SUBROUTINE LOGINC(L,BU)
      CHARACTER*(*) BU
      INCLUDE 'cmn.h'
      CALL GETL(INPL,BU)
      WRITE (LOGF,100) -L,BU(1:INPL)
100   FORMAT(' ',I5,' * ',A)
      RETURN
      END
      SUBROUTINE GETNAM(CARD,NAME,IST)
      CHARACTER*(*) CARD,NAME
C
C     LOOK FOR A SINGLE PARAMETER ON 'CARD', BEGINNING AT COL. 'IST'
C     COPY THE PARAMETER TO 'NAME'
      LNAM=LEN(NAME)
      LCARD=LEN(CARD)
      DO 39 I=1,LNAM
39    NAME(I:I)=' '
C
C     FIND FIRST NONBLANK
      DO 30 I=IST,LCARD
      IF (CARD(I:I).NE.' ') GOTO 31
30    CONTINUE
31    J=0
C
C     COPY UNTIL BLANK
      DO 32 K=I,LCARD
      IF (CARD(K:K).EQ.' ') GOTO 33
      J=J+1
      IF (J.GT.LNAM) GOTO 99
      NAME(J:J)=CARD(K:K)
32    CONTINUE
33    CONTINUE
99    CONTINUE
      RETURN
      END
      SUBROUTINE TRACEREC(T)
      CHARACTER*(*) T
      INCLUDE 'cmn.h'
      WRITE (*,*) '****** TRACEREC called from ',T
      DO 1 I=1,IQ
      CALL GETL(L,Q(I))
      WRITE (*,100) Q(I)(1:L)
1     CONTINUE
100   FORMAT((A))
      WRITE (*,101)
101   FORMAT(70('-'))
      RETURN
      END
      SUBROUTINE CHKPAR(REC,IPAR)
      INCLUDE 'cmn.h'
      CHARACTER*(*) REC
      CHARACTER*10 PAR(MXPAR)
      ITYP=0
      IERR=0
      IF (REC(1:10).EQ.'SUBROUTINE') ITYP=11
      IF (ITYP.EQ.0) RETURN
      CALL GETL(L,REC)
      DO 1 I=ITYP,L
      IF (REC(I:I).EQ.'(') GOTO 2
1     CONTINUE
      RETURN
2     IPAR=0
      J=I
5     I=J+1
      IPAR=IPAR+1
      IF (IPAR.GT.MXPAR) THEN
       WRITE (*,*) '###### CHKPAR (3) WARNING:'
       WRITE (*,*) '       more than ',MXPAR,' arguments'
       IPAR=MXPAR
       IERR=IERR+1
       GOTO 4
      ENDIF
      CALL CLEAR(PAR(IPAR),10)
      IC=0
      DO 3 J=I,L
      IF (REC(J:J).EQ.')') GOTO 4
      IF (REC(J:J).EQ.'?') GOTO 6
      IF (REC(J:J).EQ.',') GOTO 5
      IC=IC+1
      IF (IC.LE.10) PAR(IPAR)(IC:IC)=REC(J:J)
3     CONTINUE
      WRITE (*,*) '###### CHKPAR (1) WARNING:'
      WRITE (*,*)
     *'       closing parentheses for argument list not found'
      WRITE (*,*) '       length of REC :',L,' now reading at ',J
      IERR=IERR+1
      GOTO 4
6     WRITE (*,*) '###### CHKPAR (4) WARNING:'
      WRITE (*,*) '       cannot handle such a long argument list'
      IERR=IERR+1
4     CONTINUE
      DO 9 I=1,IPAR
      CALL UPPER(PAR(I),10)
  9   CONTINUE
      DO 10 I=1,IPAR
      DO 11 J=I+1,IPAR
      IF (PAR(I).EQ.PAR(J)) THEN
       WRITE (*,*) '###### CHKPAR (2) WARNING: arguments no. ',
     *  I,' and ',J
       WRITE (*,*) '       argument occurs more than once: ',PAR(I)
       IERR=IERR+1
      ENDIF
11    CONTINUE
10    CONTINUE
      IF (IERR.GT.0) CALL TRACEREC('CHKPAR')
      RETURN
      END
      SUBROUTINE CHKTIO(REC,IPAR)
      INCLUDE 'cmn.h'
      CHARACTER*(*) REC
      CHARACTER*10 PAR(MXPAR)
      ITYP=0
      IF (REC(1:4).EQ.'READ') ITYP=5
      IF (REC(1:5).EQ.'WRITE') ITYP=6
      IF (ITYP.EQ.0) RETURN
      IERR=0
      IP=0
      IPAR=0
      ILUP=1
      CALL GETL(L,REC)
      DO 1 I=ITYP,L
      IF (REC(I:I).EQ.'(') GOTO 2
1     CONTINUE
      RETURN
2     IPAR=0
      IP1=I+1
      LREC=L
      J=I
5     I=J+1
      IPAR=IPAR+1
      IF (IPAR.GT.MXPAR) THEN
       WRITE (*,*) '###### CHKTIO (3) WARNING:'
       WRITE (*,*) '       more than ',MXPAR,' arguments'
       IPAR=MXPAR
       IERR=IERR+1
       GOTO 4
      ENDIF
      CALL CLEAR(PAR(IPAR),10)
      IC=0
      DO 3 J=I,L
      IF (REC(J:J).EQ.')') THEN
       IF (IP.EQ.0) GOTO 4
       IP=IP-1
      ENDIF
      IF (REC(J:J).EQ.'?') GOTO 6
      IF (REC(J:J).EQ.',') GOTO 5
      IF (REC(J:J).EQ.'(') IP=IP+1
      IC=IC+1
      IF (IC.LE.10) PAR(IPAR)(IC:IC)=REC(J:J)
3     CONTINUE
      WRITE (*,*) '###### CHKTIO (1) WARNING:'
      WRITE (*,*)
     *'       closing parentheses for argument list not found'
      WRITE (*,*) '       length of REC :',L,' now reading at ',J
      IERR=IERR+1
      GOTO 4
6     WRITE (*,*) '###### CHKTIO (4) WARNING:'
      WRITE (*,*) '       cannot handle such a long argument list'
      IERR=IERR+1
4     CONTINUE
      IP2=J
      ISEND=0
      ISERR=0
      ISTAT=0
C      foor a write statement, there should be no END=
      IF (ITYP.EQ.6) ISEND=1
      DO 9 I=1,IPAR
      CALL UPPER(PAR(I),10)
      IF (PAR(I)(1:4).EQ.'END=') ISEND=1
      IF (PAR(I)(1:5).EQ.'UNIT=') ILUP=I
      IF (PAR(I)(1:4).EQ.'ERR=') ISERR=1
      IF (PAR(I)(1:7).EQ.'IOSTAT=') ISTAT=1
9     CONTINUE
      IF (IERR.GT.0) CALL TRACEREC('CHKTIO')
C      if IOSTAT was coded, assume that all errors will be treated by the
C      program itself
      IF (ISTAT.GT.0 .OR. ISEND+ISERR.EQ.2) RETURN
C
C     insert ERR= END= IOSTAT= statements
C
      IP=0
      DO 8004 I=1,IQ
       CALL GETL(L,Q(I))
       DO 8003 J=1,L
        IF (Q(I)(J:J).EQ.'(') IP=IP+1
        IF (Q(I)(J:J).EQ.')') THEN
         IP=IP-1
         IF (IP.EQ.0) GOTO 56
        ENDIF
8003   CONTINUE
8004  CONTINUE
56    CONTINUE
      CALL GETL(L,Q(I))
      LX=LEN(Q(I))
      ISH=4-ISERR-ISEND
      IF (IQ+ISH .GT. MAXC) THEN
       WRITE (*,*) 'sorry, too many continuation cards'
       RETURN
      ENDIF
      IQ=IQ+ISH
C      space for END= ERR= IOSTAT=
      DO 8005 K=IQ,I,-1
8005   Q(K+ISH)=Q(K)
C      clip argument list (including right par)
      CALL CLEAR(Q(I)(J:LX),LX-J+1)
C      clip up to right par
      CALL CLEAR(Q(I+ISH),J-1)
      Q(I+ISH)(6:6)='*'
      DO 8006 K=1,ISH-2
      CALL CLEAR(Q(I+K),LX)
8006  CONTINUE
C      branch around calls to error routine
      CALL NEWLAB
      IQ=IQ+1
      CALL CLEAR(Q(IQ),LX)
      WRITE (Q(IQ),642) ILY
642   FORMAT('       GOTO ',I10)
      ITO=ILY
C     
      I=I+1
      IF (ISEND.EQ.0) THEN
       CALL NEWLAB
       WRITE (Q(I),'(A,I10)') '     *,END=',ILY
       IQ=IQ+1
       CALL CLEAR(Q(IQ),LX)
       WRITE (Q(IQ),640) ILY,UNIT,NR-1,PAR(ILUP)
640    FORMAT(I5,1X,
     * 'CALL DELRER(''unexpected EOF'',''',A,''',',I10,',''',
     * A,''',IRCDEL)')
       I=I+1
      ENDIF
C      error exit
      IF (ISERR.EQ.0) THEN
       CALL NEWLAB
       WRITE (Q(I),'(A,I10)') '     *,ERR=',ILY
       IQ=IQ+1
       CALL CLEAR(Q(IQ),LX)
       WRITE (Q(IQ),641) ILY,UNIT,NR-1,PAR(ILUP)
641    FORMAT(I5,1X,'CALL DELRER(''I/O error'',''',A,''',',I10,',''',
     * A,''',IRCDEL)')
       I=I+1
      ENDIF
       Q(I)='     *,IOSTAT=IRCDEL'
C       target for branch
       IQ=IQ+1
       CALL CLEAR(Q(IQ),LX)
       WRITE (Q(IQ),643) ITO
643    FORMAT(I5,1X,'CONTINUE')
      RETURN
      END
*****
***** check CARD for keyword WHAT, starting at column ICOL.
*****
      LOGICAL FUNCTION LCARD(CARD,WHAT,ICOL,N)
      CHARACTER*(*) CARD,WHAT
      CHARACTER*80 BUFA
      N=ICOL
      IF (N.LE.0) THEN
       N=0
1      N=N+1
       IF (N.GT.80) GOTO 2
       IF (CARD(N:N) .EQ. ' ') GOTO 1
2      CONTINUE
      ENDIF
      L=LEN(WHAT)
      IF (L.GT.80) STOP 'increase BUFA size in LCARD'
      BUFA(1:L)=CARD(N:N+L-1)
      CALL UPPER(BUFA,L)
      IF (BUFA(1:L) .EQ. WHAT) THEN
       LCARD=.TRUE.
       RETURN
      ENDIF
      LCARD=.FALSE.
      RETURN
      END
*****
***** check if the character C is numeric
*****
      LOGICAL FUNCTION LCNUM(C)
      CHARACTER*1 C
      CHARACTER*1 LC(10)
      DATA LC /'0','1','2','3','4','5','6','7','8','9'/
      LCNUM=.TRUE.
      DO 1 i=1,10
       IF (C.EQ.LC(I)) RETURN
1     CONTINUE
      LCNUM=.FALSE.
      RETURN
      END
******
****** if we have a DO statement without a DO target number, supply a 
****** target number and remember it in stack MENDDO(NENDDO).
****** if we have an ENDDO statement, pop the MENDDO stack and supply a
****** CONTINUE card
******
      SUBROUTINE CENDDO(CARD)
      INCLUDE 'cmn.h'
      LOGICAL LCARD,LCNUM
      CHARACTER*(*) CARD
      CHARACTER*500 REC
      CHARACTER*128 XXX
      CALL PREPREC(REC)
      IRC=0
      IF (LCARD(REC,'DO',1,IRC)) GOTO 10 
      IF (LCARD(REC,'ENDDO',1,IRC)) GOTO 11
      RETURN
****** DO statement; remember location of DO
10    CONTINUE
      IF (LCARD(REC,'DOWHILE',1,IRC)) GOTO 12
      IDO=IRC+2
      CALL indx(CARD,72,'=',IRC)
      IF (IRC.EQ.0) RETURN
      IF (LCNUM(REC(3:3))) RETURN
      IF (NENDDO.GE.MXENDO) THEN
       WRITE (*,*) '###### too many nested DO/ENDDO blocks.'
       RETURN
      ENDIF
      NENDDO=NENDDO+1
      CALL NEWLAB
      MENDDO(NENDDO)=ILY
      CALL CLEAR(XXX,128)
      JP=0
      CALL PUTC(XXX,JP,'*',CARD(1:6))
      CALL PUTC(XXX,JP,'*','DO ')
      WRITE (XXX(10:20),'(I10)') ILY
      JP=21
      CALL PUTC(XXX,JP,'*',CARD(IDO:72))
      CARD(1:3)='C::'
      CALL QUEUE(XXX)
      RETURN
12    CONTINUE
      IF (NENDDO+1.GE.MXENDO) THEN
       WRITE (*,*) '###### too many nested DO/ENDDO blocks.'
       RETURN
      ENDIF
      NENDDO=NENDDO+1
      CALL NEWLAB
      MENDDO(NENDDO)=-ILY
      CALL CLEAR(XXX,128)
      WRITE (XXX,'(I5)') ILY
      JP=7
      CALL PUTC(XXX,JP,'*','CONTINUE')
      CALL QUEUE(XXX)
      CALL NEWLAB
      NENDDO=NENDDO+1
      MENDDO(NENDDO)=ILY
      CALL CLEAR(XXX,128)
      JP=7
      CALL PUTC(XXX,JP,'*','IF (.NOT.')
      CALL GETL(LL,REC)
      CALL PUTC(XXX,JP,'*',REC(8:LL))
      CALL PUTC(XXX,JP,'*',') GOTO ')
      WRITE (XXX(JP+1:JP+10),'(I10)') ILY
      CARD(1:3)='C::'
      CALL QUEUE(XXX)
      RETURN
11    CONTINUE
      CALL GETL(LL,REC)
      IF (LL.NE.5) RETURN
      IF (NENDDO.GT.0) THEN
       CALL CLEAR(XXX,128)
       CARD(1:3)='C::'
       IF (NENDDO.GT.1 .AND. MENDDO(NENDDO-1).LT.0) THEN
        JP=7
        CALL PUTC(XXX,JP,'*','GOTO ')
        WRITE (XXX(JP+1:JP+6),'(I5)') -MENDDO(NENDDO-1)
        CALL QUEUE(XXX)
        WRITE (XXX,'(I5)') MENDDO(NENDDO)
        JP=7
        CALL PUTC(XXX,JP,'*','CONTINUE')
        NENDDO=NENDDO-2
        CALL QUEUE(XXX)
       ELSE
        WRITE (XXX,'(I5)') MENDDO(NENDDO)
        JP=7
        CALL PUTC(XXX,JP,'*','CONTINUE')
        NENDDO=NENDDO-1
        CALL QUEUE(XXX)
       ENDIF
      ELSE
       WRITE (*,*) '###### ENDDO without DO found.'
      ENDIF
      RETURN
      END
C//SKIPC+
      SUBROUTINE UPPER(BUF,L)
      CHARACTER*(*) BUF
      CHARACTER*1 CP(26),SM(26)
      INTEGER k,kdq
      DATA  CP  /'A','B','C','D','E','F','G','H','I','J',
     *           'K','L','M','N','O','P','Q','R','S','T',
     *           'U','V','W','X','Y','Z'/
      DATA SM   /'a','b','c','d','e','f','g','h','i','j',
     *           'k','l','m','n','o','p','q','r','s','t',
     *           'u','v','w','x','y','z'/
      k=1
      kdq=1
      DO 1 I=1,L
       IF (buf(i:i).EQ.'''') k=-k
       IF (buf(i:i).EQ.'"') kdq=-kdq
       IF (k.GT.0 .AND. kdq.GT.0) THEN
        DO 2 J=1,26
         IF (BUF(I:I) .EQ. SM(J)) THEN
          BUF(I:I)=CP(J)
          GOTO 1
         ENDIF
2       CONTINUE
       ENDIF
1     CONTINUE
      RETURN
      END
C//END
******
****** handle hex constant
******
      SUBROUTINE CHEX(CARD)
      INCLUDE 'cmn.h'
      CHARACTER*(*) CARD
      CHARACTER*256 XXX
      CHARACTER*1 SIG
      CHARACTER*20 CHAR
      ML=256
      XXX(1:72)=CARD(1:72)
      CALL UPPER(XXX,72)
10    CALL indx(XXX,ML,'''X',IRC)
      IF (IRC.NE.0) GOTO 1
      CALL indx(XXX,ML,'''Z',IRC)
      IF (IRC.NE.0) GOTO 2
      RETURN
1     SIG='X'
      GOTO 3
2     SIG='Z'
3     I=1
11    CONTINUE
      DO 4 I1=I,ML
       IF (XXX(I1:I1).EQ.'''') GOTO 5
4     CONTINUE
      RETURN
5     DO 6 I2=I1+1,ML
       IF (XXX(I2:I2).EQ.'''') GOTO 7
6     CONTINUE
      GOTO 999
7     I=I2+1
      IF (XXX(I:I).NE.SIG) GOTO 3
      CALL GETHEX(XXX(I1+1:I-2),IHX,CHAR,L1ST)
      XXX(I1:I1)='"'
      XXX(I2:I2)='"'
      WRITE (*,*) IHX,L1ST,'<',CHAR(L1ST:),'>'
      GOTO 10
999   RETURN
      END
****** return hexadecimal number in X as decimal in C, as integer in IHX;
****** LC is the column of the first nonblank in C
****** if X is invalid, IHX is set to 0, and C starts with ??
      SUBROUTINE GETHEX(X,IHX,C,LC)
      CHARACTER*(*) X
      CHARACTER*20 C
      CHARACTER*1 HX(16)
      DATA HX /'0','1','2','3','4','5','6','7','8',
     *'9','A','B','C','D','E','F'/
      L=LEN(X)
      M=1
      IHX=0
      DO 1 I=L,1,-1
       DO 2 J=1,16
        IF (X(I:I) .EQ. HX(J)) GOTO 3
2      CONTINUE
       IHX=0
       C='??      invalid hex no'
       C(5:5)=X(I:I)
       LC=1
       RETURN
3      IHX=IHX+(J-1)*M
       M=M*16
1     CONTINUE
      WRITE (C,'(I20)') IHX
      DO 4 I=1,20
       IF (C(I:I).NE.' ') GOTO 5
4     CONTINUE
      I=20
5     LC=I
      RETURN
      END
      SUBROUTINE DCPP(REC,IRC)
      INCLUDE 'cmn.h'
      CHARACTER*(*) REC
      CHARACTER*80 CARD
C
      CARD(1:80)=REC(1:80)
      IRC=0
      CARD(1:1)='C'
      Q(1)=CARD
      CALL GETL(INPL,CARD)
      WRITE (idbg,660) NR,CARD(1:INPL)
      I=8
1     I=I+1
      IF (CARD(I:I).EQ.' ') GOTO 1
      IV=I
      LV=-1
2     I=I+1
      LV=LV+1
      IF (CARD(I:I).NE.' ') GOTO 2
3     I=I+1
      IF (CARD(I:I).EQ.' ') GOTO 3
      IW=I
      LW=-1
4     I=I+1
      LW=LW+1
      IF (CARD(I:I).NE.' ') GOTO 4
*     check if already there
      DO 7 i=1,icpp
       IF (cppv(i)(1:lv+1).EQ.card(IV:IV+LV)) GOTO 5
7     CONTINUE
      IF (ICPP.GE.MAXCPP) GOTO 6
      icpp=icpp+1
      CALL clear(CPPV(icpp),128)
      cppv(icpp)(1:lv+1)=card(iv:iv+lv)
      kcpp(icpp)=0
      IF (card(iw:iw).NE.'0') kcpp(icpp)=1
*     WRITE (*,*) '      | ',kcpp(icpp),' ->',cppv(icpp)(1:lv+1)
      RETURN
* symbol already encountered; store the new value
5     CONTINUE
      kcpp(i)=0
      IF (card(iw:iw).NE.'0') kcpp(i)=1
*     WRITE (*,*) '      | ',kcpp(i),' =>',cppv(i)(1:lv+1)
      RETURN
6     CONTINUE
      WRITE (*,*) 'delrem: ',card(iv:iv+lv),' not stored.'
      CALL CLEAR(CARD,80)
      i=1
      CALL PUTC(CARD,i,'*',
     *'C delrem: *** WARNING *** too many CPP symbols')
      WRITE (*,*) 'delrem: *** WARNING *** too many CPP symbols'
      CALL QUEUE(CARD)
      RETURN
660   FORMAT(1X,I5,' | ',(A))
      END
      SUBROUTINE DEFDEF(rec,IRC)
      INCLUDE 'cmn.h'
      CHARACTER*(*) rec
      CHARACTER*80 card
      card(1:80)=rec(1:80)
      IRC=0
* get symbol
      I=8
1     I=I+1
      IF (CARD(I:I).EQ.' ') GOTO 1
      IV=I
      LV=-1
2     I=I+1
      LV=LV+1
      IF (CARD(I:I).NE.' ') GOTO 2
      DO 7 i=1,icpp
       IF (cppv(i)(1:lv+1).EQ.card(IV:IV+LV)) GOTO 5
7     CONTINUE
      WRITE (*,*) '      | symbol ',card(iv:iv+lv),' not defined.'
      irc=-2
      GOTO 900
5     CONTINUE
      IF (kcpp(i).EQ.0) THEN
* unset the flag, if it is active
       CALL fnew(card(7:8),2,iact)
C@     IF (iact.NE.0) WRITE (*,*) card
       card(2:6)=' dea '
      ELSE
* set the flag
       CALL fnew(card(7:8),1,iact)
       card(2:6)=' act '
      ENDIF
900   CONTINUE
      Q(1)=CARD
      CALL GETL(INPL,CARD)
      WRITE (idbg,660) NR,CARD(1:INPL)
660   FORMAT(1X,I5,' | ',(A))
      RETURN
      END
      SUBROUTINE ffin(flag,katt,iret)
* find attribute of delrem flag
      CHARACTER*2 FLAG
      INCLUDE 'cmn.h'
* returncodes:
* 0             flag not in dictionary
* n             entry number
      iret=0
      katt=0
      DO 1 i=1,idel
       IF (del(i).EQ.flag) GOTO 2
1     CONTINUE
      GOTO 900
2     iret=i
      katt=iatt(i)
900   CONTINUE
      RETURN
      END
      SUBROUTINE fnew(flag,katt,iret)
* catalogue a new flag with attribute katt
      CHARACTER*2 FLAG
      INCLUDE 'cmn.h'
* returncodes:
*  n            flag set
* -1            too many flags
* attributes:
* +/-1             active
* +/-2             deactivated
* if katt>0, override existing attribute, otherwise use existing one
      iret=-2
      flag(1:1)='C'
      IF (flag.EQ.'C ' .OR. flag.EQ.'C/') THEN
        WRITE (*,*) '      | invalid flag C<blank> or C<slash>'
        GOTO 900
      ENDIF
      CALL ffin(flag,latt,iret)
      IF (iret.GT.0) THEN
       IF (katt.GT.0) iatt(iret)=katt
       GOTO 900
      ENDIF
      iret=-2
      IF (idel.GE.maxdel) THEN 
        WRITE (*,*) '      | ######## too many C//DEL flags'
        WRITE (*,*) '      | maximum number id ',maxdel
        GOTO 900
      ENDIF
      idel=idel+1
      del(idel)=flag
      iatt(idel)=iabs(katt)
      iret=idel
900   CONTINUE
      RETURN
      END
      SUBROUTINE display(card)
      CHARACTER*(*) card
      INCLUDE 'cmn.h'
      IF (ierr.NE.0) idbg=6
      CALL GETL(INPL,CARD)
      WRITE (idbg,660) NR,CARD(1:INPL)
      IF (ierr.NE.0) THEN
       ierr=0
       idbg=41
      ENDIF
      RETURN
660   FORMAT(1X,I5,' | ',(A))
      END
      SUBROUTINE skipbl(v,i)
      CHARACTER*(*) v
 1    CONTINUE
      IF (v(i:i).EQ.' ') THEN
       i=i+1
       GOTO 1
      ENDIF
      RETURN
      END
      SUBROUTINE skipnb(v,i)
      CHARACTER*(*) v
 1    CONTINUE
      IF (v(i:i).NE.' ') THEN
       i=i+1
       GOTO 1
      ENDIF
      RETURN
      END
      SUBROUTINE getver(v,vnr)
      CHARACTER*(*) v
      CHARACTER*4 vnr
      i=1
      CALL skipnb(v,i)
      CALL skipbl(v,i)
      CALL skipnb(v,i)
      CALL skipbl(v,i)
      vnr=v(i:i+3)
      RETURN
      END
      LOGICAL FUNCTION comment_card(b)
      IMPLICIT none
      CHARACTER*(*) b
      IF (b(1:1).EQ.'C' .OR. b(1:1).EQ.'*'.OR. b(1:1).EQ.'c') THEN
       comment_card=.TRUE.
      ELSE
       comment_card=.FALSE.
      ENDIF
      RETURN
      END
      SUBROUTINE getbuf(jeof,inr)
      IMPLICIT none
      INCLUDE 'cmn.h'
      INTEGER jeof,inpl,i,j,k,inr
      LOGICAL comment_card,zcomm
      CHARACTER*80 card
C@    INTEGER start

      IF (cfram.EQ.0) GOTO 2
      i=fs(cfram)
      IF (i.EQ.0) GOTO 2
C@    start=i
      iq=0

1     CALL wipe(card)
      card=fileb(i)
      CALL loginp(nr,card)
      IF (card(1:2).EQ.'/*') card(1:1)='*'
      CALL getl(inpl,card)
      WRITE (idbg,660) nr,card(1:inpl)
660   FORMAT(1X,I5,' | ',(A))
      iq=iq+1
      CALL ckdim(iq,maxc,'queue positions','maxc')
* check for tabs
9     CALL match(card,'\t',k)
      IF (k.NE.0) THEN
       CALL texpnd(card,k)
       GOTO 9
      ENDIF
      zcomm=comment_card(card)
* check for comments separated by an exclamation mark
      IF (.NOT.zcomm) THEN
       CALL match(card,'!',k)
       IF (k.NE.0) THEN
* relocate comment
        DO j=iq,2,-1
         IF (q(j-1)(1:1).EQ.'C') GOTO 8
         q(j)=q(j-1)
        ENDDO
        j=1
8       CALL wipe(q(j))
        q(j)=card(k:inpl)
        q(j)(1:1)='C'
        CALL wipe(card(k:inpl))
        iq=iq+1
        CALL ckdim(iq,maxc,'queue positions','maxc')
       ENDIF
      ENDIF
      q(iq)=card
      fs(cfram)=i+1
      IF (i.GE.fe(cfram)) THEN
       IF (cfram.EQ.ifram) ifram=ifram-1
       cfram=fn(cfram)
      ENDIF
      IF (card(1:3).EQ.'C//' .OR. card(1:1).EQ.'#') GOTO 3
      IF (inr.NE.0) GOTO 3

* check if the next card is a comment card or a continuation card

      IF (cfram.EQ.0) GOTO 3
      i=fs(cfram)
      IF (i.EQ.0) GOTO 3
      card=fileb(i)
      IF (card(1:3).EQ.'C//' .OR. card(1:1).EQ.'#') GOTO 3

* check for conditional comments
      IF (card(1:1).EQ.'C' .OR. card(1:1).EQ.'c') THEN
       IF (card(2:2).EQ.' ') GOTO 1
       IF (card(6:6).NE.' ') GOTO 1
      ELSE
       IF (comment_card(card) .OR. card(6:6).NE.' ') GOTO 1
      ENDIF

3     jeof=0
C@    WRITE (idbg,*) 'getbuf| ',cfram,start,fe(cfram),iq
      RETURN
2     jeof=1
C@    WRITE (idbg,*) 'getbuf| EOF return: frame=',cfram
      END
****************************************************************************
* handle IMPLICIT statement
****************************************************************************
      SUBROUTINE implst(rec)
      CHARACTER*(*) rec
      INCLUDE 'cmn.h'
      LOGICAL chgd
      chgd=.FALSE.
      CALL getl(ir,rec)
      ip=8
      IF (rec(9:12).EQ.'NONE') THEN
       DO 20 i=1,ninitial
        implt(i)=0
20      impll(i)=0
       GOTO 999
      ENDIF
11    CONTINUE
      jpsave=ip
      CALL typedec(rec(ip+1:ir),it,il,irc)
      ip=ip+irc
10    CONTINUE
      CALL implp(rec(ip:ir),irc,ir,it,il)
*
* handle IMPLICIT TYPE($) statement
      IF (rec(ip:ip+3).EQ.'($)') THEN
       idollar=1
       DO 19 i=jpsave,ip+3
        rec(i:i)=' '
19     CONTINUE
       chgd=.TRUE.
       DO 41 j=1,iq
41     q(j)(1:5)='CIMPL'
      ENDIF

      ip=ip+irc
C@    WRITE (idbg,*) 'implst: ',rec(ip:ir)
      IF (ip.GT.ir) GOTO 999
      IF (rec(ip:ip).EQ.',') GOTO 11
999   CONTINUE
      WRITE (idbg,*) 'implst: implicit typing'
      WRITE (idbg,*) (i,implt(i),impll(i),i=1,ninitial)
      IF (chgd) CALL makeq('     ',rec,iq,0)
      RETURN
      END
****************************************************************************
* set IMPLICIT defaults
****************************************************************************
      SUBROUTINE impldef
      INCLUDE 'cmn.h'
      DO 1 i=1,mlastc
       impll(i)=mwordl
       implt(i)=treal
1     CONTINUE
      DO 2 i=9,14
       implt(i)=tint
2     CONTINUE
      impll(mdollar)=0
      implt(mdollar)=0
      impll(mundersc)=0
      implt(mundersc)=0
      RETURN
      END
****************************************************************************
* determine type and length of type declaration
****************************************************************************
      SUBROUTINE typedec(rec,itype,ilen,nx)
      CHARACTER*(*) rec
      INCLUDE 'cmn.h'
      ilen=mwordl
      CALL getl(ir,rec)
      nx=0
      IF (rec(1:4).EQ.'REAL') THEN
       itype=treal
       nx=5
      ENDIF
      IF (rec(1:7).EQ.'INTEGER') THEN
       itype=tint
       nx=8
      ENDIF
      IF (rec(1:7).EQ.'LOGICAL') THEN
       itype=tlogical
       nx=8
      ENDIF
      IF (rec(1:9).EQ.'CHARACTER') THEN
       itype=tchar
       nx=10
      ENDIF
      IF (rec(1:7).EQ.'COMPLEX') THEN
       itype=tcomplex
       nx=8
      ENDIF
      IF (rec(1:15).EQ.'DOUBLEPRECISION') THEN
       itype=treal
       ilen=mwordl*mlongr
       nx=16
       GOTO 999
      ENDIF
      IF (nx.EQ.0) THEN
       itype=tunknown
       ilen=0
       GOTO 999
      ENDIF
      IF (rec(nx:nx).NE.'*') GOTO 999
      IF (rec(nx+1:nx+1).EQ.'(*)') THEN
       ilen=-1
       nx=nx+4
       GOTO 999
      ENDIF
      ilen=intgr(rec(nx+1:ir),ip,10)
      nx=nx+ip+1
999   CONTINUE
      CALL match(rec,'$',irc)
      IF (irc.NE.0) idollar=1
C@    WRITE (idbg,*) 'typedec: ',itype,ilen,nx
      RETURN
      END
****************************************************************************
* check type of variable
****************************************************************************
      SUBROUTINE chktype(rec,it,il)
      CHARACTER*(*) rec
      INCLUDE 'cmn.h'
      CALL eqchar(rec,irc)
      IF (irc.LT.0) THEN
       it=tunknown
       il=0
      ELSE
       it=implt(irc)
       il=impll(irc)
      ENDIF
C@    WRITE (idbg,*) 'chktype: ',rec,it,il
      RETURN
      END
****************************************************************************
* get character number
****************************************************************************
      SUBROUTINE eqchar(c,irc)
      CHARACTER*1 c
      INCLUDE 'cmn.h'
      CHARACTER*1 asc(ninitial)
      DATA  asc /'A','B','C','D','E','F','G','H','I','J',
     *           'K','L','M','N','O','P','Q','R','S','T',
     *           'U','V','W','X','Y','Z','_','$'/
      DO 1 irc=1,ninitial
       IF (c.EQ.asc(irc)) RETURN
1     CONTINUE
      irc=-1
      RETURN
      END
****************************************************************************
* handle IMPLICIT parameter
****************************************************************************
      SUBROUTINE implp(rec,ip,ir,it,il)
      CHARACTER*(*) rec
      INCLUDE 'cmn.h'
C@    WRITE (idbg,*) 'implp: ',rec
      ip=2
10    CONTINUE
      CALL eqchar(rec(ip:ip),i1)
      IF (i1.LT.0) THEN
       WRITE (*,*) '*ERROR* character not recognized on card ',nr
       WRITE (*,*) '        <',rec(ip:ip),'>'
       RETURN
      ENDIF
      ip=ip+1
      IF (ip.GT.ir .OR. rec(ip:ip).NE.'-') THEN
C@     WRITE (idbg,*) 'implp: ',i1,it,il
       implt(i1)=it
       impll(i1)=il
       IF (ip.GT.ir .OR. rec(ip:ip).EQ.')') GOTO 999
       GOTO 13
      ENDIF
      ip=ip+1
      CALL eqchar(rec(ip:ip),i2)
      IF (i2.LT.0) THEN
       WRITE (*,*) '*ERROR* character not recognized on card ',nr
       WRITE (*,*) '        <',rec(ip:ip),'>'
       GOTO 999
      ENDIF
      DO 11 i=i1,i2
C@     WRITE (idbg,*) 'implp: ',i,it,il
       implt(i)=it
11     impll(i)=il
12    ip=ip+1
      IF (ip.GT.ir .OR. rec(ip:ip).EQ.')') GOTO 999
13    IF (rec(ip:ip).EQ.',') GOTO 12
      GOTO 10
999   CONTINUE
      IF (implt(mdollar).NE.0) idollar=1
      RETURN
      END
      SUBROUTINE addimpl
      INCLUDE 'cmn.h'
      IF (ixstat(2).EQ.0) THEN
       CALL wipe(bufscr)
       jp=7
       CALL putc(bufscr,jp,'*','IMPLICIT REAL*8 (A-H,O-Z)')
       CALL queue(bufscr)
       ixstat(2)=2
      ENDIF
      RETURN
      END
****************************************************************************
* handle dollar character
****************************************************************************
      SUBROUTINE hdollar(rec,card,irc)
      CHARACTER*(*) rec,card
      INTEGER irc
      INCLUDE 'cmn.h'
      LOGICAL chgq,notascii
      CHARACTER*5 lf
      CHARACTER*80 file

* IMPLICIT
      IF (ixstat(8).EQ.4) THEN
       IF (idollar.NE.1) RETURN
       idollar=2
       IF (itmph.EQ.0) THEN
        itmph=4
        file='TMPdelr.'//srname(1:lsrname)//'.h'
        OPEN (UNIT=itmph,FILE=file,FORM='FORMATTED',
     *   STATUS='UNKNOWN',IOSTAT=irc)
        IF (irc.NE.0) THEN
         WRITE (*,*) 'cannot open file ',file
         STOP 'TMPdelr.h'
        ENDIF
       ENDIF
       WRITE (itmph,'(A)') '* declarations for $ variables'
       CALL wipe(bufscr)
       jp=7
       CALL getl(l,file)
       CALL putc(bufscr,jp,'*','INCLUDE ''')
       CALL putc(bufscr,jp,'*',file(1:l))
       CALL putc(bufscr,jp,'*','''')
       CALL queue(bufscr)
       RETURN
      ENDIF

      chgq=.FALSE.
      lf=q(1)(1:5)
      ipend=0
90    CONTINUE
      CALL match(rec,'$',irc)
      IF (irc.EQ.0) GOTO 999

* FORMAT?
      IF (ixstat(8).EQ.tformat) RETURN

* declaration?
      IF (ixstat(8).GE.11 .AND. ixstat(8).LE.tpointer) GOTO 20

* initial character?
      IF (irc.EQ.1 .OR. notascii(rec(irc-1:irc-1))) THEN
       IF (ipend.NE.0)
     *  CALL wexplty(rec(ipend:irc),implt(mdollar),impll(mdollar))
       ipend=0
       CALL getl(m,rec)

* loop over variables
       DO 1 i=1,nvar
        IF (varnam(i)(1:1).NE.'$') GOTO 1
        CALL match(rec(irc:m),varnam(i),jrc)
        IF (jrc.NE.0) THEN
         CALL getl(jr,varnam(i))
         WRITE (idbg,*) varnam(i)(1:jr),' typed',itvar(i)
         GOTO 20
        ENDIF
1      CONTINUE
       ipend=irc
      ENDIF

* replace dollar
20    CALL rdollar(rec,irc)
      IF (.NOT.chgq) THEN
       DO 41 j=1,iq
41     q(j)(1:5)='CDOLL'
       chgq=.TRUE.
       isaveq=iq
      ENDIF
      GOTO 90
999   CONTINUE
      
      IF (ipend.NE.0)
     * CALL wexplty(rec(ipend:),implt(mdollar),impll(mdollar))
      IF (chgq) THEN
       CALL makeq(lf,rec,isaveq,0)
      ENDIF
      RETURN
      END
****************************************************************************
* replace dollar character by the string 'dollar_'
****************************************************************************
      SUBROUTINE rdollar(rec,irc)
      CHARACTER*(*) rec
      INCLUDE 'cmn.h'
      CHARACTER*2000 bufla
      CALL getl(m,rec)
      CALL wipe(bufla)
      jp=0
      IF (irc.NE.1) CALL putc(bufla,jp,'*',rec(1:irc-1))
      CALL putc(bufla,jp,'*','DOLLAR_')
* the rest of the statement
      CALL putc(bufla,jp,'*',rec(irc+1:m))
      CALL getl(li,bufla)
      CALL wipe(rec)
      rec(1:li)=bufla(1:li)
      RETURN
      END
****************************************************************************
* write a type statement to file 'TMPdelr.h'
****************************************************************************
      SUBROUTINE wexplty(var,it,il)
      CHARACTER*(*) var
      INCLUDE 'cmn.h'
      LOGICAL notascii
      DO 1 i=1,LEN(var)
       IF (notascii(var(i:i))) GOTO 2
1     CONTINUE
      i=LEN(var)+1
2     i=i-1
        
      CALL wipe(bufscr)
      jp=7
      IF (it.EQ.tint) THEN
       CALL putc(bufscr,jp,'*','INTEGER')
      ELSEIF (it.EQ.tlogical) THEN
       CALL putc(bufscr,jp,'*','LOGICAL')
      ELSEIF (it.EQ.treal) THEN
       CALL putc(bufscr,jp,'*','REAL')
      ELSEIF (it.EQ.tchar) THEN
       CALL putc(bufscr,jp,'*','CHARACTER')
      ELSE
       CALL putc(bufscr,jp,'*','TYPE')
       CALL puti(bufscr,jp,it)
      ENDIF
      CALL putc(bufscr,jp,'*','*')
      CALL puti(bufscr,jp,il)
      CALL putc(bufscr,jp,'*',' ')
      CALL putc(bufscr,jp,'*',var(1:i))
      CALL getl(l,bufscr)
      WRITE (itmph,'(A)') bufscr(1:l)
      RETURN
      END
       
      SUBROUTINE incc(card,irc)
      IMPLICIT none
      INCLUDE 'cmn.h'
      CHARACTER*(*) card
      INTEGER irc
      INTEGER ifirst,inpl,i,katt,irt
      LOGICAL yes
      CHARACTER*80 name
      CHARACTER*7 x

      irc=-1
      IF (leave.NE.0) RETURN
      ifirst=1
      CALL skipbl(card,ifirst)
      x=card(ifirst:ifirst+6)
      CALL upper(x,7)
      IF (x.NE.'INCLUDE') RETURN
      irc=0

      IF (card(1:1).EQ.'*') RETURN

C      conditionally commented INCLUDEs

      IF (CARD(1:1).EQ.'C' .OR. CARD(1:1).EQ.'c') THEN
       CARD(1:1)='C'
       CALL ffin(card,katt,irt)
       IF (katt.NE.1) RETURN
       CARD(1:2)='  '
      ENDIF

      NC4=NC4+1
*             FLSH buffer (dispose of INCLUDE statement)
      IQ=0
      IF (iimpl.GT.0) CALL addimpl
      CALL flsh(out)
      CARD(1:3)='C'//DIRSIG
      CALL GETL(INPL,CARD)
C
C      SEARCH FOR FILENAME
      CALL GETNAM(CARD,NAME,IFIRST+7)
      DO 64 I=1,NFIL
       IF (NAME.EQ.FILNAM(I)) THEN
        ifram=ifram+1
        CALL ckdim(ifram,mxfram,'frames','mxfram')
        fn(ifram)=cfram
        cfram=ifram
        fs(ifram)=fis(i)
        fe(ifram)=fie(i)
        GOTO 46
       ENDIF
64     CONTINUE
      CALL getl(irt,name)
      INQUIRE (file=name(2:irt-1),EXIST=yes)
      WRITE (idbg,*)
     * '  incc| test for existence of ',name(1:irt),': ',yes      
      IF (yes) THEN
       CALL ckfile(name(2:irt-1),4,irt)
       fn(irt)=cfram
       cfram=irt
      ELSE
       CARD(1:3)='   '
      ENDIF
46    CONTINUE
      WRITE (OUT,101) CARD(1:INPL)
101   FORMAT((A))
      RETURN
      END
* delrem.inivar: initialize global variables and open files
* V 1.65: get filename from argument list
      SUBROUTINE inivar(version)
      IMPLICIT none
      INCLUDE 'cmn.h'
      CHARACTER*(*) version
      CHARACTER*256 oname
      INTEGER i

      mwordl=4
      mlongr=2
      CALL wipe(srname)
      srname(1:4)='main'
      lsrname=4
      idollar=0
      ifex=0
      itmph=0
      ndata=0
      idbg=41
      outsig=' |'
      dirsig='c.'
      ierr=0
      icpp=0
      ISTIO=0
      IENDDO=0
      NENDDO=0
      MEMCHK=0
      IHEXX=0
      NWATI=0
      NWATR=0
      LEAVE=0
      IDEBUG=0
      IPROF=-3
      ISPROF=0
      IREP=0
      ITIM=0
      ISTAT=0
      IBIGL=0
      IUPPER=0
      IBATCH=0
      NSUB=1
      IDO=1
      LOGF=7
      nvar=0
      ipointer=1000000
      JDO(1)=MXDOL
      NDOL=0
      IQ=0
      OUT=2
      IDEL=0
      IEOF=0
      NR=0
      NC1=0
      NC2=0
      NC3=0
      NC4=0
      NCTR=0
      NFIL=0
      NAXF=1
      ITRACE=0
      IFLOW=0
      ISAVS=0
      IIMPL=0
      IENBL=0
      IBFRD=0
      itabs=0
      DO 59 i=1,8
59    ixstat(i)=0
      ILY=90000
      UNIT='MAIN  '
      ILX=0
      DO 45 I=1,99999
45    ILA(I)=0
      DIRSIG='..'
      ifram=0

      WRITE (idbg,*) VERSION
      OPEN (UNIT=LOGF,FILE='DELRTMPL',FORM='FORMATTED',STATUS='UNKNOWN')
      RETURN
      END
      SUBROUTINE makescal(x)
      IMPLICIT none
      CHARACTER*(*) x
      INTEGER i,l
      l=LEN(x)
      DO i=1,l
       IF (x(i:i).EQ.'(') x(i:i)='_'
       IF (x(i:i).EQ.',') x(i:i)='_'
       IF (x(i:i).EQ.')') x(i:i)='_'
      ENDDO
      RETURN
      END
      SUBROUTINE mkfram(jn,fctrl,f)
      IMPLICIT none
      INCLUDE 'cmn.h'
      INTEGER jn,fctrl,l,nn,ifr,ito,nrec,k
      CHARACTER*(*) f
      CHARACTER*255 rec,recc
      LOGICAL comment_card,zcomm
      nrec=1
      ifram=ifram+1
      CALL ckdim(ifram,mxfram,'frames','mxfram')
      fctrl=ifram
      fs(ifram)=ifileb+1
      fe(ifram)=ifileb+1
      fn(ifram)=0
      nn=0
1     ifileb=ifileb+1
      CALL ckdim(ifileb,mxcard,'card slots','mxcard')
      IF (nrec.EQ.2) THEN
       rec=recc
      ELSE
       READ (jn,'(A)',END=10) rec
      ENDIF
*
* a filename to be read from may be communicated by a C//FILENAME <filename> statement
*
      IF (rec(1:12).EQ.'C//FILENAME ') THEN
       CALL clear(buf,128)
       buf=rec(13:73)
       ifram=ifram-1
       fctrl=-1
       RETURN
      ENDIF
      nrec=1
      zcomm=comment_card(rec)
      IF (.NOT.zcomm) THEN
       CALL match(rec,'!',k)
       IF (k.NE.0) THEN
        CALL wipe(recc)
        recc(6:255)=rec(k+1:255)
        CALL wipe(rec(k:255))
        recc(1:1)='C'
        nrec=2
       ENDIF
      ENDIF
      nn=nn+1
      CALL getl(l,rec)
      IF (zcomm) l=72
      IF (l.GT.72) THEN
       CALL wipe(fileb(ifileb))
       fileb(ifileb)=rec(1:72)
       ifr=73
       ito=l
11     l=ito-ifr+1
       ifileb=ifileb+1
       CALL ckdim(ifileb,mxcard,'card slots','mxcard')
       CALL wipe(fileb(ifileb))
       fileb(ifileb)(6:6)='*'
       IF (l.GT.65) THEN
        fileb(ifileb)(7:72)=rec(ifr:ifr+65)
        ifr=ifr+66
        GOTO 11
       ELSE
        fileb(ifileb)(7:)=rec(ifr:ito)
       ENDIF
      ELSE
       fileb(ifileb)=rec
      ENDIF
      GOTO 1
10    ifileb=ifileb-1
      IF (ifileb.LT.fs(ifram)) fctrl=0
      fe(ifram)=ifileb
      WRITE (idbg,*)
     *  'mkfram| ifram, fs, fe :',ifram, fs(ifram),fe(ifram)
      RETURN
      END
      SUBROUTINE MKTREC(TREC,UNIT,CARD)
      CHARACTER*(*) TREC,CARD
      CHARACTER*6 UNIT
      CALL CLEAR(TREC,128)
      TREC(1:7)='     *'''
      TREC(8:13)=UNIT
      TREC(14:15)=': '
      TREC(16:20)=CARD(1:5)
      TREC(21:71)=CARD(7:57)
      TREC(72:72)=' '
      DO 7 I=8,72
      IF (TREC(I:I).EQ.'''') TREC(I:I)='"'
7     CONTINUE
      DO 5 I=72,1,-1
      IF (TREC(I:I).EQ.' ') GOTO 5
      TREC(I+1:I+1)=''''
      GOTO 6
5     CONTINUE
6     CONTINUE
      RETURN
      END
****************************************************************************
* handle POINTER statement
****************************************************************************
      SUBROUTINE pointer(rec)
      INCLUDE 'cmn.h'
      CHARACTER*(*) rec
* POINTER (X1,Y1),(X2,Y2),...
      il=8
      CALL getl(ir,rec)
* comment out the POINTER statement in the source code
       DO 41 i=1,iq
41     q(i)(1:5)='CMMGR'
* scan over list elements
2     CALL lstloc(rec(il:ir),irc)
      CALL point2(rec(il:il+irc-1))
      il=il+irc+1
      IF (il.LT.ir) GOTO 2
C@    CALL dmpvars('after constructing pointer variable')
      RETURN
      END
****************************************************************************
* handle a single argument pair of a POINTER statement
****************************************************************************
      SUBROUTINE point2(rec)
      CHARACTER*(*) rec
      INCLUDE 'cmn.h'
* 
      il=2
      ir=LEN(rec)-1
* first argument of (XXX,YYY(I,J,K))
      CALL lstloc(rec(il:ir),irc)
      jl=il
      jr=jl+irc-1
      CALL mkvar(rec(jl:jr),tpointer)

* second argument
      CALL lstloc(rec(jr+2:ir),irc)
      kl=jr+2
      kr=kl+irc-1
      CALL parsvar(rec(kl:kr))

* emit the declaration for the memory area
      IF (ixstat(7).EQ.0) THEN
       CALL putc(bufscr,jp,'I','      INTEGER nlongr,delrm1,delrm2')
       CALL queue(bufscr)
       CALL putc(bufscr,jp,'I','      REAL    delrr1(2)')
       CALL queue(bufscr)
       IF (mwordl.EQ.4) THEN
        CALL putc(bufscr,jp,'I','      REAL*8 delrr8(2)')
        CALL queue(bufscr)
        CALL putc(bufscr,jp,'I','      INTEGER*2 delri2(2)')
        CALL queue(bufscr)
       ENDIF
       CALL putc(bufscr,jp,'I','      PARAMETER (delrm2=')
       WRITE (bufscr(jp:jp+13),'(I14)') ipointer
       JP=JP+14
       CALL putc(bufscr,jp,'*',')')
       CALL queue(bufscr)
       CALL putc(bufscr,jp,'I',
     *  '      COMMON /delrm8/ nwordl,nlongr,delrm1(delrm2)')
       CALL queue(bufscr)
       IF (mlongr.EQ.2) THEN
        CALL putc(bufscr,jp,'I',
     *   '      EQUIVALENCE (delrm1(1),delrr8(1))')
        CALL queue(bufscr)
        CALL putc(bufscr,jp,'I',
     *   '      EQUIVALENCE (delrm1(1),delri2(1))')
        CALL queue(bufscr)
       ENDIF
       CALL putc(bufscr,jp,'I',
     *  '      EQUIVALENCE (delrm1(1),delrr1(1))')
       CALL queue(bufscr)
       ixstat(7)=1
      ENDIF
* emit the declaration for the pointer variable
      CALL putc(bufscr,jp,'I','      INTEGER ')
      CALL putc(bufscr,jp,'*',rec(jl:jr))
      CALL queue(bufscr)
      RETURN
      END
****************************************************************************
* check if a pointer variable is present in the statement
****************************************************************************
      SUBROUTINE point3(rec,card)
      CHARACTER*(*) rec,card
      INCLUDE 'cmn.h'
      LOGICAL notascii,found1,found2,chgq
      CHARACTER*5 lf
      CHARACTER*2000 bufla
* save label field
      CALL getl(l,rec)
      lf=q(1)(1:5)
      chgq=.FALSE.

* loop over pointee variables
      i=0
1     i=i+1
      IF (i.GT.nvar) GOTO 90
      IF (itvar(i).NE.tpointer) GOTO 1
      i=i+1
      left=1
      CALL getl(m,rec)

*
31    CONTINUE
      IF (left.GT.m) GOTO 32

      CALL match(rec(left:m),varnam(i),irc)
 
      IF (irc.NE.0) THEN
       irc=irc+left-1
       CALL getl(l,varnam(i))

* character before and after the variable must be non-ascii
       found1 = irc.EQ.1 .OR. notascii(rec(irc-1:irc-1))
       found2 = irc.EQ.m .OR. notascii(rec(irc+l:irc+l))
       IF (.NOT. (found1.AND.found2) ) THEN
* move on
        left=irc+l
        GOTO 31
       ELSE
        WRITE (idbg,*) '### pointer variable ',varnam(i)(1:l)
        WRITE (idbg,*) '### irc=             ',irc
        CALL chktype(varnam(i)(1:l),it,il)
* comment out
        IF (.NOT.chgq) THEN
         DO 41 j=1,iq
41       q(j)(1:5)='CMMGR'
         chgq=.TRUE.
         isaveq=iq
        ENDIF

* debug
        IF (memchk.NE.0 .AND. cmemck(1:1).EQ.'*') THEN
         CALL wipe(bufscr)
         jp=7
         CALL putc(bufscr,jp,'*','CALL delr11(delrm1(')
         CALL getl(li,varnam(i-1))
         CALL putc(bufscr,jp,'*',varnam(i-1)(1:li))
         CALL putc(bufscr,jp,'*','+1),''')
         CALL putc(bufscr,jp,'*',srname(1:lsrname))
         CALL putc(bufscr,jp,'*','.')
         CALL putc(bufscr,jp,'*',varnam(i)(1:l))
         CALL putc(bufscr,jp,'*','[')
         CALL puti(bufscr,jp,nr-1)
         CALL putc(bufscr,jp,'*',']'',')
         CALL putc(bufscr,jp,'*',varnam(i-1)(1:li))
         CALL putc(bufscr,jp,'*',')')
         CALL queue(bufscr)
        ENDIF

* save variable stack pointer
        isvar=nvar
        CALL parsvar(rec(irc:m))
        CALL dmpvars('after retrieval of pointee')
        nvar=isvar
        ndim=ixvar(nvar+1)
        CALL wipe(bufla)
        jp=0
        IF (irc.NE.1) CALL putc(bufla,jp,'*',rec(1:irc-1))
        IF (it.EQ.26) THEN
         IF (il.EQ.mwordl) THEN
          CALL putc(bufla,jp,'*','delrm1(')
         ELSEIF (il.EQ.mwordl/2) THEN
          CALL putc(bufla,jp,'*','delri2(')
         ELSEIF (il.EQ.mwordl/4) THEN
          CALL putc(bufla,jp,'*','delri4(')
         ELSEIF (il.EQ.2*mwordl) THEN
          CALL putc(bufla,jp,'*','delri8(')
         ELSE
          CALL putc(bufla,jp,'*','delri1(')
         ENDIF
        ELSEIF (it.EQ.17) THEN
         IF (il.EQ.mwordl) THEN
          CALL putc(bufla,jp,'*','delrr1(')
         ELSEIF (il.EQ.mwordl/2) THEN
          CALL putc(bufla,jp,'*','delrr2(')
         ELSEIF (il.EQ.2*mwordl) THEN
          CALL putc(bufla,jp,'*','delrr8(')
         ELSE
          CALL putc(bufla,jp,'*',
     *     'error - unknown lenght of real variable')
         ENDIF
        ELSE
          CALL putc(bufla,jp,'*',
     *     'error - unknown type variable')
        ENDIF
* pointer
        IF (il.EQ.mwordl/2) CALL putc(bufla,jp,'*','2*')
        IF (il.EQ.mwordl/4) CALL putc(bufla,jp,'*','4*')
        IF (il.EQ.mwordl/8) CALL putc(bufla,jp,'*','8*')
        CALL getl(li,varnam(i-1))
        CALL putc(bufla,jp,'*',varnam(i-1)(1:li))
        IF (il.EQ.mwordl*2) CALL putc(bufla,jp,'*','/2')
        IF (ndim .GT. 0) THEN
         CALL putc(bufla,jp,'*','+')

         DO 10 id=2,ndim
* the actual dimensions (apart from the first)
          CALL putc(bufla,jp,'*','(')
          CALL getl(il,varnam(isvar+ndim-id+3))
          CALL putc(bufla,jp,'*',varnam(isvar+ndim-id+3)(1:il))
          CALL putc(bufla,jp,'*','-1)')

* lower dimensions
          DO 20 jd=id,ndim
           CALL putc(bufla,jp,'*','*')
           CALL getl(il,varnam(i+ndim-jd+1))
* ranges not yet implemented here ...
           CALL match(varnam(i+ndim-jd+1),':',icol)
           IF (icol.NE.0) THEN
            CALL putc(bufla,jp,'*',' !!! ranges not yet implemented')
            CALL makeq('ERROR',bufla,isaveq,0)
            CALL wipe(bufla)
           ENDIF
           CALL putc(bufla,jp,'*',varnam(i+ndim-jd+1)(1:il))
20        CONTINUE
          CALL putc(bufla,jp,'*','+')
10       CONTINUE

         CALL getl(il,varnam(isvar+2))
         CALL putc(bufla,jp,'*',varnam(isvar+2)(1:il))
        ELSE
* range
         mdim=ixvar(i)
         CALL match(varnam(i+mdim),':',icol)
         CALL getl(jcol,varnam(i+mdim))
         IF (icol.NE.0) THEN
          IF (icol.EQ.2 .AND. varnam(i+mdim)(1:1).EQ.'0') THEN
           CALL putc(bufla,jp,'*','+2')
          ELSE
           CALL putc(bufla,jp,'*','+2-(')
           CALL putc(bufla,jp,'*',varnam(i+mdim)(1:icol-1))
           CALL putc(bufla,jp,'*',')')
          ENDIF
         ELSE
          CALL putc(bufla,jp,'*','+1')
         ENDIF
        ENDIF

* range
        CALL match(varnam(i+ndim),':',icol)
        CALL getl(jcol,varnam(i+ndim))
        IF (icol.NE.0) THEN
         IF (icol.EQ.2 .AND. varnam(i+ndim)(1:1).EQ.'0') THEN
          CALL putc(bufla,jp,'*','+1')
         ELSE
          CALL putc(bufla,jp,'*','+1-(')
          CALL putc(bufla,jp,'*',varnam(i+ndim)(1:icol-1))
          CALL putc(bufla,jp,'*',')')
         ENDIF
        ENDIF

        CALL getl(m,rec)
        CALL putc(bufla,jp,'*',')')
        IF (ndim.GT.0) THEN
         CALL argloc(rec(irc:m),kl,kr)
         kr=kr+1
        ELSE
* in case that only the array name is passed as a parameter
         CALL getl(kr,varnam(i))
        ENDIF
* the rest of the statement
        CALL putc(bufla,jp,'*',rec(irc+kr:m))
        CALL getl(li,bufla)
        CALL wipe(rec)
        rec(1:li)=bufla(1:li)

* start all over with this variable
        left=1
        CALL getl(m,rec)
        GOTO 31
       ENDIF
      ENDIF

* next variable
32    CONTINUE
      i=i+ixvar(i)
      GOTO 1
90    CONTINUE
      IF (chgq) THEN
       CALL makeq(lf,rec,isaveq,0)
      ENDIF
      RETURN
      END
* 
      SUBROUTINE mkvar(tx,type)
      CHARACTER*(*) tx
      INTEGER type
      INCLUDE 'cmn.h'
      nvar=nvar+1
      IF (nvar.GT.mxvar) STOP 'not enough space for variables'
      l=LEN(tx)
      CALL wipe(varnam(nvar))
      varnam(nvar)(1:l) = tx
      ixvar(nvar)=0
      itvar(nvar)=type
      RETURN
      END
      SUBROUTINE dmpvars(tx)
      CHARACTER*(*) tx
      INCLUDE 'cmn.h'
      INTEGER idone
      DATA idone /0/
      WRITE (idbg,*) '*** variables ',tx
      DO 1 i=idone+1,nvar
      CALL getl(l,varnam(i))
      WRITE (idbg,'(3I4,2X,A)') i,ixvar(i),itvar(i),varnam(i)(1:l)
1     CONTINUE
      CONTINUE
      idone=nvar
      RETURN
      END
      LOGICAL FUNCTION notascii(t)
      CHARACTER*1 t
      CHARACTER*1 asc(37)
      DATA  asc /'A','B','C','D','E','F','G','H','I','J',
     *           'K','L','M','N','O','P','Q','R','S','T',
     *           'U','V','W','X','Y','Z','_',
     *           '1','2','3','4','5','6','7','8','9','0'/
      DO i=1,37
       IF (asc(i).EQ.t) THEN
        notascii=.FALSE.
        RETURN
       ENDIF
      ENDDO
      notascii=.TRUE.
      RETURN
      END
      SUBROUTINE parsvar(rec)
      CHARACTER*(*) rec
      INCLUDE 'cmn.h'
      kl=1
      CALL getl(kr,rec)

* search for open ( or comma
      kkl=1
      DO 3 i=kl,kr
       IF (rec(i:i).EQ.'(') GOTO 2
       IF (rec(i:i).EQ.',') GOTO 4
 3    CONTINUE     
      GOTO 4

* determine dimension of second variable
2     CALL argloc(rec(kl:kr),kkl,kkr)
* variable name
4     IF (kkl.EQ.1) THEN
* variable not indexed
       CALL mkvar(rec(kl:kr),tpointee)
      ELSE
       CALL mkvar(rec(kl:kl+kkl-3),tpointee)
       ivar=nvar

       kr=kl+kkr-1
       kl=kl+kkl-1

       ndim=0
1      ndim=ndim+1
       CALL lstloc(rec(kl:kr),jrc)
       kkl=kl
       kkr=kl+jrc-1
       CALL mkvar(rec(kkl:kkr),tdim)
       kl=kkr+2
       IF (kl.LE.kr) GOTO 1
       ixvar(ivar)=ndim
      ENDIF
      RETURN
      END
****************************************************************************
* split rec and queue the result; if iqu==0, queue it to iq-queue,
* otherwise queue it to dstsmt(ndata)
****************************************************************************
      SUBROUTINE makeq(lb,rec,isaveq,iqu)
      CHARACTER*(*) rec
      CHARACTER*5 lb
      INTEGER iqu
      INCLUDE 'cmn.h'
      jq=isaveq
      CALL getl(ll,rec)
      call wipe(bufscr)
      bufscr(1:5)=lb
      il=1
      ir=65
      IF (ir.GT.ll) ir=ll
1     CONTINUE
      jp=7
      CALL putc(bufscr,jp,'*',rec(il:ir))
      IF (iqu.EQ.0) THEN
       CALL queue(bufscr)
      ELSE
       CALL nxdata
       dstmt(ndata)=bufscr
      ENDIF
      call wipe(bufscr)
      bufscr(6:6)='*'
      il=ir+1
      ir=il+65
      IF (ir.GT.ll) ir=ll
      IF (il.LE.ll) GOTO 1
* shift 'old' block after 'new' block
*     DO 40 i=jq,1,-1
*      bufscr=q(i)
*      DO 50 j=i,iq-i
*50    q(j)=q(j+1)
*40   q(iq-i+1)=bufscr
      RETURN
      END
****************************************************************************
* put character string on card
****************************************************************************
      SUBROUTINE putc(card,ip,what,tx)
*
* what:
* 1:1   I        initialize ip and clear card
* 1:1   N        copy until next blank
* 2:2   _        replace ( and ) by _
* 2:2   "        replace ! by "
*
      CHARACTER*(*) card,what,tx
      INTEGER k
      l=LEN(card)
      IF (what(1:1).EQ.'I') THEN
       CALL clear(card,l)
       ip=0
      ENDIF
      IF (ip.EQ.0) ip=1
      k=LEN(tx)
      IF (what(1:1).EQ.'N') THEN
       DO 8007 I=1,K
       IF (TX(I:I) .EQ.' ') GOTO 10
8007   CONTINUE
       I=K+1
10     K=I-1
      ENDIF
      CARD(IP:IP+K-1)=TX
      IF (LEN(WHAT).GT.1 .AND. WHAT(2:2).EQ.'_') THEN
       DO 11 i=ip,ip+k-1
        IF (card(I:I) .EQ.'(') card(I:I)='_'
        IF (card(I:I) .EQ.')') card(I:I)='_'
  11   CONTINUE
      ENDIF
      IF (LEN(WHAT).GT.1 .AND. WHAT(2:2).EQ.'"') THEN
       DO 12 i=ip,ip+k-1
        IF (card(I:I) .EQ.'''') card(I:I)='"'
  12   CONTINUE
      ENDIF
      ip=ip+k
      RETURN
      END
****************************************************************************
* put integer on card
****************************************************************************
      SUBROUTINE puti(card,ip,iint)
      CHARACTER*(*) CARD
      CHARACTER*80 cbu
      L=LEN(CARD)
      IF (IP.LE.0) THEN
       CALL CLEAR(CARD,L)
       IP=1
      ENDIF
      WRITE (cbu,'(I16)') iint
      i=0
1     i=i+1
      IF (i.GT.16) GOTO 999
      IF (cbu(i:i).EQ.' ') GOTO 1
      IF (ip.GE.l) GOTO 999
      card(ip:ip)=cbu(i:i)
      ip=ip+1
      GOTO 1
999   CONTINUE
      RETURN
      END
******
****** REMOVE BLANKS FROM FORTRAN STATEMENT. TREAT ALSO SEQUENCE CARDS
******
      SUBROUTINE preprec(rec)
      IMPLICIT none
      CHARACTER*(*) REC
      INCLUDE 'cmn.h'
      LOGICAL quote,dquote,string,comment_card
      INTEGER i,ip,jq,l,ll
      quote=.FALSE.
      dquote=.FALSE.
      CALL wipe(rec)
      ll=LEN(rec)
      jq=0
      DO 1 i=1,iq
       IF (.NOT.comment_card(q(i))) THEN
        CALL getl(l,q(i))
        DO 10 ip=7,l
* if we have a quote or a double quote, then toggle flag
         IF (q(i)(ip:ip).EQ.'''') quote=.NOT.quote
         IF (q(i)(ip:ip).EQ.'"') dquote=.NOT.dquote
         string=quote.OR.dquote.OR.q(i)(ip:ip).NE.' '
         IF (string) THEN
          jq=jq+1
          IF (jq.GT.ll) THEN
           rec(ll:ll)='?'
           RETURN
          ENDIF
          rec(jq:jq)=q(i)(ip:ip)
         ENDIF
10      CONTINUE
       ENDIF
1     CONTINUE
      CALL upper(rec,jq)
      RETURN
      END
      SUBROUTINE queue(card)
      CHARACTER*128 card,c
      INCLUDE 'cmn.h'
      CALL getl(inpl,card)
      IF (inpl.GT.72
     * .AND. card(1:1).NE.'C'
     * .AND. card(1:1).NE.'c'
     * .AND. card(1:1).NE.'*') THEN
       CALL inciq(card)
       q(iq)=card(1:72)
       CALL clear(c,128)
       c(1:6)='     *'
       c(7:inpl-72+7)=card(73:inpl)
       card=c
       inpl=inpl-72+6
      ENDIF
      CALL inciq(card)
      q(iq)=card
      RETURN
      END
      SUBROUTINE inciq(card)
      CHARACTER*128 card
      INCLUDE 'cmn.h'
      IF (iq.GE.maxc) THEN
       WRITE (*,*) '###### not more than',maxc,' continuation cards'
       WRITE (*,*) card(1:60)
       STOP 'QUEUE: FATAL ERROR'
      ENDIF
      iq=iq+1
      RETURN
      END
      SUBROUTINE stack(card)
      CHARACTER*128 card,c
      INCLUDE 'cmn.h'
      istack=0
      CALL getl(inpl,card)
      IF (inpl.GT.72
     * .AND. card(1:1).NE.'C'
     * .AND. card(1:1).NE.'c'
     * .AND. card(1:1).NE.'*') THEN
       CALL clear(c,128)
       c(1:6)='     *'
       c(7:inpl-72+7)=card(73:inpl)
       inpl=inpl-72+7
       istack=1
      ENDIF
      IF (istack.EQ.1) THEN
       CALL pstack(c)
       CALL pstack(card(1:72))
      ELSE
       CALL pstack(card)
      ENDIF
      RETURN
      END
******
******
******
      SUBROUTINE pstack(card)
      CHARACTER*(*) card
      INCLUDE 'cmn.h'
      DO 1 i=iq,1,-1
1     q(i+1)=q(i)
      CALL inciq(card)
* see if the first card has a label, but ignore comment cards
      DO 2 i=2,iq
       IF (q(i)(1:1).NE.'C'
     * .AND. q(i)(1:1).NE.'c'
     * .AND. q(i)(1:1).NE.'*') GOTO 3
2     CONTINUE
      i=0
3     CONTINUE
      IF (i.GT.0) THEN
* shift label
       card(1:5)=q(i)(1:5)
       q(i)(1:5)='     '
      ENDIF
      CALL clear(q(1),128)
      q(1)=card
      RETURN
      END
      SUBROUTINE runout(vnr)
      IMPLICIT none
      INCLUDE 'cmn.h'
      INTEGER i,n,j
      CHARACTER*(*) vnr

      IF (ITRACE.GT.0) NCTR=NCTR+ITRACE-1

      WRITE (6,300) vnr,NC1,NC3,NC4,NCTR,NC2,icpp,npointer,NR
300   FORMAT('delrem-',A4,I5,'C',I5,'F',I5,'I',I5,'T',I5,'S',I5,'D',
     *I5,'P',I6,' cards total.')
      IF (itabs.NE.0) THEN
       WRITE (6,303) vnr,itabs
303    FORMAT('delrem-',A4,' *WARNING* ',I10,' tabs expanded.')
      ENDIF
C*    WRITE (6,*) '___________________________________________________'

      IF (NCTR.GT.0) THEN
      NC1=0
       DO 78 I=1,9999
       IF (ILA(I).NE.0) THEN
       IF (NC1.EQ.0) THEN
       NC1=1
       WRITE (*,301)
301    FORMAT(//' FOLLOWING DO LOOPS EXTEND BEYOND TRACE UNIT:'/)
       ENDIF
        IF (ILA(I).GT.0) THEN
         WRITE (*,302) I,ILA(I)
302      FORMAT(1X,I4,' (NOW ',I5,')')
        ELSE
         N=-ILA(I)
         WRITE (*,*) 'LABEL',I,' IS TARGET FOR MORE THAN ONE DO LOOP:'
         DO 79 J=1,ILX
         IF (ILB(J).EQ.I) THEN
          WRITE (*,302) I,ILC(J)
          N=N-1
          IF (N.EQ.0) GOTO 80
         ENDIF
79       CONTINUE
80       CONTINUE
        ENDIF
       ENDIF
78     CONTINUE
      ENDIF

      IF (ISPROF.GT.0 .AND. ISTAT.NE.0) THEN
       IF (IREP.EQ.0) THEN
        WRITE (*,*) '###### NO REPORT GENERATED FROM PROFILE.'
       ENDIF
       IF (IREP.GT.0) THEN
        WRITE (*,*) '****** A report will be generated before the'
        WRITE (*,*) '****** execution of the STOP stmts. in this batch.'
       ENDIF
       IF (IREP.GE.0) THEN
        WRITE (*,*) ' '
        WRITE (*,*) '****** If you are not sure whether your program'
        WRITE (*,*) '****** terminates by executing a STOP statement'
        WRITE (*,*) '****** located in the current batch of code,'
        WRITE (*,*) '****** include an explicit //REPORT directive'
        WRITE (*,*) '****** to be sure to get a report from profiling'
       ENDIF
      ENDIF
C*    IF (NC1.EQ.1) THEN
C*    WRITE (*,*) 'PLACE C//NOTRACE STATEMENT BEYOND THE LAST ONE'
C*    WRITE (*,*) 'OF THESE LABELS AND RERUN THIS PROGRAM'
C*    ENDIF
C
C     WRITE DELR04 SUBROUTINE TO FORTRAN FILE
      IF (ITIM.GT.0) CALL TIMI01
      STOP
      END

* determine card type and status of source
****************************************************************************
      SUBROUTINE setstat(card,rec)
      INCLUDE 'cmn.h'
      CHARACTER*(*) card,rec
      INTEGER ntypes
      PARAMETER (ntypes=59)
      INTEGER lens(ntypes)
      INTEGER iptr
      CHARACTER*20 cty(ntypes)
      DATA lens /7, 10, 9, 8, 8,
     *8, 8, 6, 4,
     *9, 9, 6, 15, 6,
     *6, 7, 4, 9, 10, 10, 7, 9, 9, 9, 9, 7, 9, 9, 9, 7, 9, 11, 4, 9, 7,
     *4, 5,
     *4, 5, 6, 3, 4, 5, 4, 4, 7, 4, 4,
     *2, 5, 4, 6, 9, 5, 6, 5, 9, 6, 7/
      DATA cty /
*** 1-5           program initializers
     *'PROGRAM','SUBROUTINE','BLOCKDATA','IMPLICIT','FUNCTION',
*** 6-9           block free declarations
     *'EXTERNAL','NAMELIST','FORMAT','SAVE',
*** 10-33         declaration block
     *'PARAMETER','DIMENSION','COMMON','DOUBLEPRECISION','REAL*4',
     *'REAL*8','REAL*16','REAL','COMPLEX*8','COMPLEX*16',
     *'COMPLEX*32','COMPLEX','INTEGER*1','INTEGER*2','INTEGER*4',
     *'INTEGER*8','INTEGER','LOGICAL*1','LOGICAL*4','LOGICAL*8',
     *'LOGICAL','CHARACTER','EQUIVALENCE','BYTE','INTRINSIC','POINTER',
*** 35 data block
     *'DATA',
*** 36 function definition
     *'dummy',
     *'ELSE','ENDIF','ENDDO','END',
     *'CALL','WRITE','READ','OPEN','INQUIRE','READ','GOTO',
     *'IF', 'PRINT', 'STOP','RETURN', 'CONTINUE', 'ENTRY',
     *'REWIND','CLOSE','BACKSPACE','ASSIGN','DOWHILE'/

* statement type unknown at first.
      i=tunknown

* check for dollar
      CALL match(rec,'$',irc)
      IF (irc.NE.0) idollar=1

* check for assignment; must at least have an = sign
      CALL match(rec,'=',irc)

      IF (irc.NE.0) THEN
* make sure that it is not a parameter or I/O statement
* assignment statements do not have equal sign between parentheses
       CALL eqbetpar(rec,jrc)

* OK, we have the parentheses BEFORE the equal sign!

       IF (ixstat(6).EQ.0 .AND. jrc.LT.0) THEN
* possibly a function definition; maybe the first executable statement,
* an assignment to an array element
        CALL argloc(rec,il,ir)
        CALL fvar(rec(1:il-2),krc)

        IF (krc.EQ.0) THEN
* no, a declaration is not there
         CALL dmatch(rec,'(',')=',il,ir)
         IF (il.GT.0) THEN
          ixstat(5)=1
          i=tfctdef
          GOTO 999
         ENDIF
        ENDIF
       ENDIF

* If the first pair of () occurs right from the = sign, it might be a do loop
       IF (jrc.EQ.0) THEN
        CALL ttdo(rec,krc)
        IF (krc.NE.0) THEN
         i=tdoloop
         GOTO 999
        ENDIF
       ENDIF

       i=tassign
      ENDIF
*
* check keywords
*
      DO is=1,ntypes
       IF (rec(1:lens(is)) .EQ. cty(is)) THEN
        iptr=lens(is)
        i=is
        GOTO 999
       ENDIF
      ENDDO

999   CONTINUE
*
* take care for DOUBLE PRECISION and DOUBLE COMPLEX
*
      IF (i. EQ. tdouble) THEN
       is=lens(i)+1
       IF (rec(is:is+8) .EQ. 'PRECISION') THEN
        i=tr8
        iptr=iptr+9
       ENDIF
       IF (rec(is:is+6) .EQ. 'COMPLEX') THEN
        i=tc16
        iptr=iptr+7
       ENDIF
      ENDIF

      ixstat(8)=i

* PROGRAM
      IF (i.EQ.1) THEN
* IMPLICIT, PROGRAM, SUBROUTINE statement already there?
       IF (ixstat(2).NE.0) CALL pmsg(1,'PROGRAM',card,nr)
       IF (ixstat(1).NE.0) CALL pmsg(2,'PROGRAM',card,nr)
       ixstat(1)=1
       CALL getnam(rec,srname,8)
       CALL mkascii(srname)
       CALL getl(lsrname,srname)
      ENDIF

* SUBROUTINE
      IF (i.EQ.2) THEN
* IMPLICIT, PROGRAM, SUBROUTINE statement already there?
       IF (ixstat(2).NE.0) CALL pmsg(1,'SUBROUTINE',card,nr)
       IF (ixstat(1).NE.0) CALL pmsg(2,'SUBROUTINE',card,nr)
       ixstat(1)=2
       CALL getnam(rec,srname,11)
       CALL mkascii(srname)
       CALL getl(lsrname,srname)
      ENDIF

* BLOCK DATA
      IF (i.EQ.3) THEN
* IMPLICIT, PROGRAM, SUBROUTINE statement already there?
       IF (ixstat(2).NE.0) CALL pmsg(1,'BLOCK DATA',card,nr)
       IF (ixstat(1).NE.0) CALL pmsg(2,'BLOCK DATA',card,nr)
       ixstat(1)=5
      ENDIF

* FUNCTION
      IF (i.EQ.5) THEN
* IMPLICIT, PROGRAM, SUBROUTINE statement already there?
       IF (ixstat(2).NE.0) CALL pmsg(1,'FUNCTION',card,nr)
       IF (ixstat(1).NE.0) CALL pmsg(2,'FUNCTION',card,nr)
       ixstat(1)=6
      ENDIF

* IMPLICIT
      IF (i.EQ.4) THEN
       IF (ixstat(1).EQ.0) ixstat(1)=3
       ixstat(2)=1
       CALL implst(rec)
      ENDIF

* any statement except PROGRAM, SUBROUTINE, BLOCK DATA, IMPLICIT
      IF (i.GT.5) THEN
       IF (ixstat(1).EQ.0) ixstat(1)=4
       IF (iimpl.GT.0) CALL addimpl
      ENDIF

* executable
      IF (i.GT.tfctdef) ixstat(6)=1

* data
      IF (i.EQ.tdata) THEN
       ixstat(4)=1
       DO j=1,iq
        call nxdata
        dstmt(ndata)=q(j)
        q(j)(1:5)='CDATA'
       ENDDO
      ENDIF

* declaration block
      IF (i.GE.tpara .AND. i.LE.tpointer) THEN
       IF (ixstat(4).NE.0) CALL pmsg(3,'DECLARATION',card,nr)
       IF (ixstat(6).NE.0) CALL pmsg(5,'DECLARATION',card,nr)
       ixstat(3)=1

* array declaration
       IF (i.GE.tpara .AND. i.LE.tchar) THEN
        CALL typedec(rec,it,il,nx)
        CALL mkvlist(i,iptr,rec,irc)
* data given in declaration?
        IF (irc.NE.0 .AND. i.NE.tcommon) THEN
         CALL xdecl(rec,iptr,irc)
         IF (irc.NE.0) CALL pmsg(9,'DECLARATION',card,nr)
        ENDIF
C@      CALL dmpvars('after processing declaration')
       ENDIF
      ENDIF

* END
      IF (i.EQ.tend) THEN
       IF (ndata.NE.0) CALL flshd(out)
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
       DO 1 j=1,7
1      ixstat(j)=0
       WRITE (idbg,*) 'setstat: ',nvar,' variable slots active.'
       DO j=1,nvar
        CALL getl(is,varnam(j))
        WRITE (idbg,*) varnam(j)(1:is),' : ',itvar(j)
       ENDDO
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       nvar=0
       nwati=0
       nwatr=0
       itrace=0
* default IMPLICIT rules
       CALL impldef
       CALL wipe(srname)
       srname(1:4)='main'
       lsrname=4
       idollar=0
       IF (itmph.NE.0) THEN
        CLOSE(itmph)
        itmph=0
       ENDIF
      ENDIF

* POINTER
      IF (i.EQ.tpointer) THEN
       CALL pointer(rec)
       npointer=npointer+1
      ENDIF

* if a dollar sign was explicitly or implicitly typed, check for a dollar
* on the card
      IF (idollar.NE.0) CALL hdollar(rec,card,irc)

* if a pointer is avtive, check if the variable appears in the statement
* check function definitions and executale statements only
      k=ixstat(5)+ixstat(6)
      IF (nvar.GT.0 .AND. k.GT.0) CALL point3(rec,card)
*
* test for MALLOC/FREE statement
*
      CALL tmalloc(rec)
      CALL tfree(rec)

* unknown statement
      IF (i.EQ.tunknown) CALL pmsg(10,'UNKNOWN',card,nr)

* flush data statement queue, if function definition or executable stmt found
      IF (ndata.NE.0 .AND. ixstat(5)+ixstat(6).NE.0) THEN
       CALL flshd(out)
       WRITE (idbg,*)
     *  '      | data queue flushed ',ndata,ixstat(5),ixstat(6)
      ENDIF
* flush exec statement queue, if executable stmt found
      IF (ixstat(6).NE.0 .AND. ifex.NE.0) THEN
       CALL flshframe(ifex)
       WRITE (idbg,*)
     *  '      | exec queue flushed '
      ENDIF

      CALL getl(l,rec)
      WRITE (idbg,'(7I1,1X,I2,1X,A)',ERR=900) ixstat,rec(1:l)
900   CONTINUE
      RETURN
      END
****************************************************************************
* bump and check ndata pointer (counting the number of DATA records)
****************************************************************************
      SUBROUTINE nxdata
      INCLUDE 'cmn.h'
      ndata=ndata+1
      IF (ndata.GT.mxdata) THEN
       WRITE (*,*) 'too many data statments - increase MXDATA'
       STOP 'mxdata'
      ENDIF
      RETURN
      END
****************************************************************************
* print error message
****************************************************************************
      SUBROUTINE pmsg(n,what,card,no)
      IMPLICIT none
      CHARACTER*(*) what,card
      INTEGER n,i,k,no
      k=6
      WRITE (k,*) '++++++++ in ',what,' statement on card ',no,':'
      CALL getl(i,card)
      WRITE (k,*) card(1:i)
      IF (n.EQ.1) WRITE (k,*) 'comes after IMPLICIT within a routine'
      IF (n.EQ.2) WRITE (k,*) 'within an active (sub)routine'
      IF (n.EQ.3) WRITE (k,*) 'declaration after data (fixed)'
      IF (n.EQ.4) WRITE (k,*) 'declaration after function definition'
      IF (n.EQ.5) WRITE (k,*) 'declaration after executable stmt'
      IF (n.EQ.6) WRITE (k,*)
     * 'function definition after executable stmt'
      IF (n.EQ.7) WRITE (k,*)
     *  'assignment to undeclared array or misplaced fct definition'
      IF (n.EQ.8) WRITE (k,*) 'multiple card - only one allowed'
      IF (n.EQ.9) WRITE (k,*) 'data given in declaration (fixed)'
      IF (n.EQ.10) WRITE (k,*) 'unknown statement'
      IF (n.GT.10) THEN
       WRITE (k,*) '*ERROR',n
      ENDIF
      WRITE (k,*) '----------------------------------------------------'
*
* status array keeps track of the context of the current statement in the
* FORTRAN program
* status
* 1       1          SUBROUTINE statement read
*         2          PROGRAM statement read
*         3          PROGRAM active since IMPLICIT was found
*         4          PROGRAM active since declaration or executable stmt found
*         5          BLOCK DATA
* 2       1          IMPLICIT statement read
*         2          IMPLICIT statement inserted
* 3                  DECLARATION read
* 4                  DATA stment read
* 5                  function definiton read
* 6                  executable statement read
* 7                  reserved
* 8                  type of card
*
      RETURN
      END
****************************************************************************
* fill character variable with blanks
****************************************************************************
      SUBROUTINE wipe(x)
      IMPLICIT none
      CHARACTER*(*) x
      INTEGER i
      DO 1 i=1,LEN(x)
1     X(I:I)=' '
      RETURN
      END
****************************************************************************
* determine <what> is a substring in <rec>
****************************************************************************
      SUBROUTINE match(rec,what,irc)
      IMPLICIT none
      CHARACTER*(*) rec,what
      INTEGER irc,i
      INTEGER lrec,lwhat
      LOGICAL quote,dquote
      quote=.FALSE.
      dquote=.FALSE.
      irc=0
      CALL getl(lrec,rec)
      CALL getl(lwhat,what)
      IF (lwhat.GT.lrec) lwhat=lrec
      DO 1 i=1,lrec-lwhat+1
       IF (rec(i:i).EQ.'''') quote=.NOT.quote
       IF (rec(i:i).EQ.'"') dquote=.NOT.dquote
       IF (.NOT.quote .AND. .NOT.dquote) THEN
        IF (rec(i:i).EQ.what(1:1)) THEN
         IF (rec(i:i+lwhat-1) .EQ. what(1:lwhat)) THEN
          irc=i
          RETURN
         ENDIF
        ENDIF
       ENDIF
1     CONTINUE
      RETURN
      END
****************************************************************************
* get the end location of the first list element
****************************************************************************
      SUBROUTINE lstloc(rec,irc)
      IMPLICIT none
      CHARACTER*(*) rec
      INTEGER i,l,irc
      LOGICAL quote,dquote
      quote=.FALSE.
      dquote=.FALSE.
      irc=0
      CALL getl(l,rec)
      DO 1 i=1,l
       IF (rec(i:i).EQ.'''') quote=.NOT.quote
       IF (rec(i:i).EQ.'"') dquote=.NOT.dquote
       IF (.NOT.quote .AND. .NOT.dquote) THEN
        IF (rec(i:i).EQ.'(') irc=irc+1
        IF (rec(i:i).EQ.')') irc=irc-1
         IF (irc.EQ.0 .AND. rec(i:i).EQ.',') THEN
          irc=i-1
          RETURN
         ENDIF
       ENDIF
1     CONTINUE
      irc=l
      RETURN
      END
****************************************************************************
****************************************************************************
      SUBROUTINE ttdo(rec,irc)
      CHARACTER*(*) rec
      INCLUDE 'cmn.h'
      irc=0
      IF (rec(1:2).NE.'DO') RETURN
* after the do loop, there must be a list of more than 1 element
      CALL getl(l,rec)
      CALL lstloc(rec,jrc)
      IF (jrc.EQ.l) RETURN
      irc=jrc
      RETURN
      END
****************************************************************************
* make list of variables encountered in the declaration statement 
****************************************************************************
      SUBROUTINE mkvlist(ity,ils,rec,irc)
      INTEGER ity,ils
      INTEGER intgr
      CHARACTER *(*) rec
      INTEGER jrc
      INCLUDE 'cmn.h'
      irc=0
      jty=ity
      il=ils+1
      CALL getl(ir,rec)
      CALL cmnname(rec(il:ir),il,jrc)
      irc=irc+jrc
C@    WRITE (idbg,*) 'enter mkvlist: ',jty,il,ir,rec(1:ir)
      IF (rec(il:il).EQ.'*') THEN
       il=il+1
       jty=intgr(rec(il:ir),ip,10)
       jty=-jty
       il=il+ip
      ENDIF
10    CONTINUE
      CALL lstloc(rec(il:ir),irc)
      irc=irc+il-1
      CALL argloc(rec(il:irc),ill,irr)
      ill=il+ill-1
      irr=il+irr-1
C@    WRITE (idbg,*) 'mkvlist il irc ill irr ',il,irc,ill,irr
      IF (irc.LE.irr) ill=irc+2
      CALL mkvar(rec(il:ill-2),jty)
      il=irc+2
      IF (irc.GT.irr) THEN
       mvar=nvar
       CALL mkidx(tdim,0,rec(ill:irr))
       ixvar(mvar)=nvar-mvar
       il=irr+2
* COMMON name following? cmnname takes care of a possible comma
       CALL cmnname(rec(irr+2:ir),il,jrc)
       irc=irc+jrc
      ENDIF
C@    WRITE (idbg,*) 'exit  mkvlist: ',jty,il,ir,rec(il:ir)
      IF (il.LE.ir) GOTO 10
      RETURN
      END
****************************************************************************
* make list of index values
****************************************************************************
      SUBROUTINE mkidx(ity,ils,rec)
      INTEGER ity,ils
      CHARACTER *(*) rec
      INCLUDE 'cmn.h'
      jty=ity
      il=ils+1
      CALL getl(ir,rec)
C@    WRITE (idbg,*) 'enter mkidx: ',jty,il,ir,rec(1:ir)
10    CONTINUE
      CALL lstloc(rec(il:ir),irc)
      irc=irc+il-1
      CALL mkvar(rec(il:irc),jty)
      il=irc+2
C@    WRITE (idbg,*) 'exit  mkidx: ',jty,il,ir,rec(il:ir)
      IF (il.LE.ir) GOTO 10
      RETURN
      END
****************************************************************************
****************************************************************************
      SUBROUTINE cmnname(rec,irc,jrc)
      CHARACTER*(*) rec
      INCLUDE 'cmn.h'
      jrc=0
      ip=1
      IF (rec(ip:ip).EQ.',') ip=ip+1
      IF (rec(ip:ip).NE.'/') GOTO 999
      CALL getl(l,rec)
1     ip=ip+1
      IF (ip.GT.l) RETURN
      IF (rec(ip:ip).NE.'/') GOTO 1
      CALL mkvar(rec(2:ip-1),tcmnn)
C@    WRITE (idbg,*) '   cmn| ',rec(2:ip-1)
      jrc=1
      ip=ip+1
999   CONTINUE
      irc=irc+ip-1
      RETURN
      END
****************************************************************************
* find a variable in the variable data base; irc is equal to the number
* of the entry, or the number of the entry times -1 if the variable occurs
* only as an index to an array
****************************************************************************
      SUBROUTINE fvar(tag,irc)
      CHARACTER*(*) tag
      INTEGER irc
      INCLUDE 'cmn.h'
      jrc=0
      DO 1 i=1,nvar
       IF (varnam(i).EQ.tag) THEN
        IF (itvar(i).NE.tdim) THEN
         irc=i
         RETURN
        ENDIF
        jrc=-i
       ENDIF
1     CONTINUE
      irc=jrc
      RETURN
      END
****************************************************************************
****************************************************************************
      SUBROUTINE tmalloc(rec)
      CHARACTER*(*) rec
      INCLUDE 'cmn.h'
*
* replace MALLOC by call to delrm9
*
      CALL getl(i,rec)
      CALL match(rec,'=MALLOC(',irc)
      IF (irc.NE.0) THEN
* get argument of malloc
       CALL argloc(rec(irc:i),il,ir)
       il=il+irc-1
       ir=ir+irc-1
       jl=il
       jr=ir
C@     WRITE (idbg,*) il,ir,'arg: ',rec(il:ir)
* in case it's specified as %val, strip the %val function
       IF (rec(il:il+3).EQ.'%VAL') THEN
        CALL argloc(rec(il:ir),jl,jr)
        jl=jl+il-1
        jr=jr+il-1
C@      WRITE (idbg,*) jl,jr,'arg: ',rec(jl:jr)
       ENDIF
* emit the call to delrm9
       CALL putc(bufscr,jp,'I',q(1)(1:6))
       CALL putc(bufscr,jp,'*','CALL delrm9(')
       CALL putc(bufscr,jp,'*',rec(1:irc-1))
       CALL putc(bufscr,jp,'*',',')
       CALL putc(bufscr,jp,'*',rec(jl:jr))
**     CALL putc(bufscr,jp,'*',',')
**     WRITE (bufscr(jp:jp+13),'(I14)') ipointer
**     JP=JP+14
       CALL putc(bufscr,jp,'*',')')
* comment out the old MALLOC call
       DO 40 i=1,iq
40      q(i)(1:5)='CMMGR'
       CALL queue(bufscr)
      ENDIF
      RETURN
      END
****************************************************************************
****************************************************************************
      SUBROUTINE tfree(rec)
      CHARACTER*(*) rec
      INCLUDE 'cmn.h'
*
* comment out DISCLAIM call
*
      CALL match(rec,'CALLDISCLAIM(',irc)
      IF (irc.NE.0) THEN
* comment out the old call
       DO 41 i=1,iq
41      q(i)(1:5)='CMMGR'
       RETURN
      ENDIF
*
* replace call to FREE by call to delrm7
*
      CALL getl(i,rec)
      CALL match(rec,'CALLFREE(',irc)
      IF (irc.NE.0) THEN
* get argument
       CALL argloc(rec(irc:i),il,ir)
       il=il+irc-1
       ir=ir+irc-1
       jl=il
       jr=ir
C@     WRITE (idbg,*) il,ir,'arg: ',rec(il:ir)
* in case it's specified as %val, strip the %val function
       IF (rec(il:il+3).EQ.'%VAL') THEN
        CALL argloc(rec(il:ir),jl,jr)
        jl=jl+il-1
        jr=jr+il-1
C@      WRITE (idbg,*) jl,jr,'arg: ',rec(jl:jr)
       ENDIF
* emit the call to delrm8
       CALL putc(bufscr,jp,'I',q(1)(1:6))
       CALL putc(bufscr,jp,'*','CALL delrm7(')
       CALL putc(bufscr,jp,'*',rec(jl:jr))
       CALL putc(bufscr,jp,'*',')')
* comment out the old call
       DO 40 i=1,iq
40      q(i)(1:5)='CMMGR'
       CALL queue(bufscr)
      ENDIF
      RETURN
      END
****************************************************************************
* debug printout of text
****************************************************************************
      SUBROUTINE tdbg(t,x)
      CHARACTER*(*) t,x
      CALL getl(l,t)
      WRITE (*,*) 'tdbg: ',x
      WRITE (*,*) 'tdbg: <',t(1:l),'>'
      RETURN
      END
****************************************************************************
* clear all characters beyond the first non-ascii character
****************************************************************************
      SUBROUTINE mkascii(t)
      CHARACTER*(*) t
      LOGICAL notascii
      CALL getl(l,t)
      DO 2 i=1,l
       IF (notascii(t(i:i))) GOTO 1
2     CONTINUE
      i=l+1
1     DO 3 j=i,l
       t(j:j)=' '
3     CONTINUE
      RETURN
      END
****************************************************************************
* determine if the equal sign is between parentheses
****************************************************************************
      SUBROUTINE eqbetpar(rec,irc)
      IMPLICIT none
      CHARACTER*(*) rec
      INTEGER i,irc,ipast
      LOGICAL quote,dquote
      quote=.FALSE.
      dquote=.FALSE.
      irc=0
* ...( ... = ... ) ...        irc > 0
* ...( ... ) ... = ...        irc < 0
* ...= ( ... ) ...            irc = 0
      ipast=0
      DO 1 i=1,LEN(rec)
       IF (rec(i:i).EQ.'''') quote=.NOT.quote
       IF (rec(i:i).EQ.'"') dquote=.NOT.dquote
       IF (.NOT.quote .AND. .NOT.dquote) THEN
        IF (rec(i:i).EQ.'(') irc=irc+1
        IF (rec(i:i).EQ.')') irc=irc-1
        IF (irc.NE.0) ipast=1
        IF (rec(i:i).EQ.'=') THEN
         IF (ipast.GT.0.AND.irc.EQ.0) irc=-1
         RETURN
        ENDIF
       ENDIF
1     CONTINUE
      RETURN
      END
****************************************************************************
* flush data statement queue
****************************************************************************
      SUBROUTINE flshd(ntape)
      INCLUDE 'cmn.h'
      DO 1 I=1,ndata
      CALL GETL(L,dstmt(I))
      WRITE (NTAPE,100) dstmt(I)(1:L)
1     CONTINUE
      ndata=0
100   FORMAT((A))
      RETURN
      END
* expand tabs; if not enough space left, replace by just 1 blank
      SUBROUTINE texpnd(card,k)
      IMPLICIT none
      INCLUDE 'cmn.h'
      INTEGER nbl
      PARAMETER (nbl=6)
      CHARACTER*(*) card
      INTEGER k
      INTEGER i,l,ll,ir
      CALL getl(l,card)
      ll=LEN(card)
      ir=nbl
      IF (ll-l+1.LT.ir) ir=ll-l+1
      WRITE (idbg,*) 'texpnd| column ',k,ir
      card(k+ir-1:l+ir-1)=card(k:l)
      DO i=k,k+ir-1
       card(i:i)=' '
      ENDDO
      itabs=itabs+1
      RETURN
      END
      SUBROUTINE tlength(aname,l)
* length until last nonblank on line
      IMPLICIT none
      CHARACTER*(*) aname
      INTEGER i,l
      l=LEN(aname)
      DO i=l,1,-1
       IF (aname(i:i).NE.' ') GOTO 1
      ENDDO
      i=0
1     l=i
      RETURN
      END
      SUBROUTINE trcgen(rec)
*
* subroutine to trace a statement
*

      IMPLICIT none
      CHARACTER*(*) rec
      INCLUDE 'cmn.h'
      INTEGER l,ip,irc,il,istack,jrc
      CHARACTER*20 tag
      istack=1
      CALL getl(l,rec)
      IF (l.EQ.0) RETURN
      IF (l.GT.80) l=80

* write out statement

      CALL putc(bufscr,ip,'I ','      WRITE (*,*) ''')
      CALL putc(bufscr,ip,'  ',unit)
      CALL putc(bufscr,ip,'  ','['',')
      CALL puti(bufscr,ip,nr)
      CALL putc(bufscr,ip,'  ',',''] ')
      CALL putc(bufscr,ip,' "',rec(1:l))
      CALL putc(bufscr,ip,'  ','''')

* write out result of assignment, if applicable

      IF (ixstat(8).EQ.tassign) THEN
       CALL match(rec,'=',irc)
       IF (irc.GT.0) THEN
        ip=ip-1
        bufscr(ip:ip)=' '
        IF (ip.LT.60) ip=60
        CALL putc(bufscr,ip,'  ',' -->'',')
        CALL putc(bufscr,ip,'  ',rec(1:irc-1))
        istack=0
       ENDIF
      ENDIF

* write out do-loop bounds

      IF (ixstat(8).EQ.tdoloop) THEN
       CALL match(rec,'=',il)
       CALL lstloc(rec(il+1:),irc)
       irc=irc+il
       ip=ip-1
       bufscr(ip:ip)=' '
       IF (ip.LT.60) ip=60
        CALL putc(bufscr,ip,'  ',' -->'',')
       CALL putc(bufscr,ip,'*',rec(il+1:irc))
       CALL putc(bufscr,ip,'*',','' ...'',')
       CALL lstloc(rec(irc+2:),jrc)
       call putc(bufscr,ip,'N',rec(irc+2:))
      ENDIF

* stack; since assignment must be executed first, queue in that case.

      IF (istack.EQ.1) THEN
       CALL stack(bufscr)
      ELSE
       CALL queue(bufscr)
      ENDIF
      RETURN
      END
****************************************************************************
* copy the declaration to a data statement, remove dimensions and put
* the statements into the data queue; remove data items from declaration
* in the queue
****************************************************************************
      SUBROUTINE xdecl(rec,kx,nd)
      INCLUDE 'cmn.h'
      CHARACTER*(*) rec
      CHARACTER*2000 x
      INTEGER intgr,nd
* uncomment the following declaration if start/end location of the length
* specification is required
C;    INTEGER left,right

      nd=0
      lx=kx
* in case we have an unresolved length specification
      IF (rec(lx+1:lx+1).EQ.'*') THEN
       lx=lx+1
       IF (rec(lx+1:lx+1).EQ.'(') lx=lx+1
C;     left=lx+1
       jty=intgr(rec(lx+1:lx+10),ip,10)
       IF (jty.NE.0) THEN
        lx=lx+ip
       ELSE
        DO WHILE (rec(lx+1:lx+1).NE.')')
         lx=lx+1
        ENDDO
       ENDIF
C;     right=lx
       IF (rec(lx+1:lx+1).EQ.')') lx=lx+1
C@     WRITE (idbg,*) ' xdecl| length spec: ',jty,ip,'<',rec(left:right),'>'
      ENDIF

* prepare data statement; remove dimensions
      x=rec
      CALL getl(l,x)
      CALL wipe(x(1:lx))
      x(1:4)='DATA'
      i=lx+1
      idata=0

1     CALL lstloc(x(i:),irc)
      irc=irc+i
C@    WRITE (idbg,*) ' xdecl| item: ','<',x(i:irc-1),'>'

* exclude slashes between parentheses
      k=0
      CALL argloc(x(i:irc-1),il,ir)
       
      IF (il.GT.1) THEN
*      remove dimensions from data statement
       CALL wipe(x(i+il-2:i+ir))
       k=k+ir+1
      ENDIF

      il=0
      IF (i+k.LE.irc-1) THEN
       CALL dmatch(x(i+k:irc-1),'/','/',il,ir)
      ENDIF

      IF (il.GT.0) THEN
       il=il+k
       ir=ir+k
      ENDIF
      IF (il.LT.0) il=il-k
* no slash found - remove item totally
      IF (il.EQ.0) THEN
       IF (idata.NE.0) GOTO 3
       CALL wipe(x(i:irc))
       GOTO 3
      ENDIF
* one (il<0) or two (il>0) slashes
      IF (il.NE.0) THEN
       nd=nd+1
       IF (il.LT.0.AND.idata.EQ.0) THEN
        idata=i
        kl=-il
        GOTO 3
       ELSE
        IF (idata.GT.0) THEN
         CALL wipe(rec(idata+kl-1:-il+i-1))
        ELSE
         CALL wipe(rec(il+i-1:ir+i-1))
        ENDIF
        idata=0
       ENDIF
      ENDIF
3     i=irc+1
      IF (i.LT.l) GOTO 1
2     CONTINUE

      IF (nd.GT.0) THEN
* if declarations without data follow declarations with data, the trailing
* comma must be removed
       CALL getl(l,x)
       if (x(l:l).EQ.',') x(l:l)=' '

* queue into DATA queue
       CALL nxdata
       dstmt(ndata)='CDECL: data transferred from declaration statement'
       CALL makeq('     ',x,ndata,1)

       DO i=1,iq
        q(i)(1:5)='CDECL'
       ENDDO
       CALL makeq('     ',rec,iq,0)
      ENDIF
      RETURN
      END
