# V 1.0 - 29.08.97
# (C) Bernd A. Hess, 1997
# parser for PARM file
# recognized are
# (cond x y) (eq x y) (neq x y) (set a b)
# (and a b) (or a b)
# files are varfile and dia
{
 i=0; eof=1; ql=0; ml=0; qr=0; mr=0; state=0; qls=0
 comment=0; pp=0
 result=""
 n=0
 while (getline < varfile !=0) {
  split($1,a,"=")
  n++
  name[n]=a[1]
  val[n]=a[2]
  }
 
 for (i=1; i<=n; i++) {
  printf "%d %s %s\n", i, name[i], val[i] > dia
  }
  printf "variable=%s\n", variable > dia

 while (eof!=0) {
  printf "%s\n", getlist("",0,1) > dia
  }
}
END{print result}

function getitem() {
# function to get next item in input stream, i.e., the next left or right
# parenthese or the next atom
#printf "[getitem] i=%d ql=%d qr=%d state=%d\n", i, ql, qr,state
# status indicators:
#           state== 0     record not exhausted
#           state== 1     record exhausted
#           qls  == 0     left par not yet emitted
#           qls  == 1     left par emitted in previous call
 if (qls+qrs==0) qr++
 if (qr>mr) {
  if (qls+qrs==0) ql++
  if (ql>ml) {
   if (qls+qrs==0) i++
   if ($i=="") {
    if (state==0) {state=1; return("");}
    state=0
    comment=0
    do {
     eof=getline
     } while (eof!=0 && $1=="")
    if (eof==0) return("")
    i=1
    }
   ml=split($i,bl,"(")
   ql=1
   mr=0
   qr=mr+1
#  printf "ml=%d 1(%s) 2(%s) 3(%s) 4(%s) \n", ml, bl[1], bl[2], bl[3], bl[4]
   if (bl[1]=="") ql++
   qls=0
   }

  if ((ml>2 || ql>1) && qls==0) {
   qls=1
   if (bl[ql]=="") qls=0
   return("(")
   }
  qls=0

  mr=split(bl[ql],br,")")
  qr=1
  qrs=0
# printf "mr=%d 1(%s) 2(%s) 3(%s) 4(%s) \n", mr, br[1], br[2], br[3], br[4]
  if (mr==0) return("")
  if (mr==1) return(br[1])
  if (mr==2 && br[1]=="" && br[2]=="") {qr=mr+1; return(")");}
  }
  if (qrs==1) {
   if (br[qr+1]=="") qr++
   qrs=0
   return(")")
   }
  qrs=1

  return(br[qr])
 }

function getlist(list,suppress,cond,item,nx,i,r,v,var,condition,
 v2,v1) {
 item=getitem()
 if (eof==0 || state!=0) return("")
 for (i=1; i<=n; i++) {
  if (index(item,"%"name[i]) !=0) gsub("%"name[i],val[i],item)
  }
 if (item==")") {
  pp--
  if (suppress==1) return(""); else return("]")
  }
 if (item=="") return(getlist("",suppress,cond))
 if (item=="(") {
  pp++
  list=list" [ "
  nx=getlist("",suppress,cond)
  list=list" "nx
  }
 else {
  if (item=="#") comment=1

  if (comment==0) {
   if (item=="if") {
    condition=getlist("",0,cond)
    if (cr==1) ex=cond; else ex=0
    do {r=getlist("",0,ex)} while (r=="]")
    list="cond("ex") "condition" "r" ]"
    return(list)
    }

   if (item=="eq") {
    var=getitem()
    v=getitem()
    cr=0
    for (i=1; i<=n; i++) {
     if (name[i]==var && val[i]==v) cr=1
     }
    nx=getitem()
    return("<eq("cr") "var" "v"> ]")
    }

   if (item=="neq") {
    var=getitem()
    v=getitem()
    cr=0
    for (i=1; i<=n; i++) {
     if (name[i]==var && val[i]!=v) cr=1
     }
    nx=getitem()
    return("<neq("cr") "var" "v"> ]")
    }

   if (item=="and") {
    v1=getlist("",0,cond)
    cr1=cr
    v2=getlist("",0,cond)
    cr2=cr
    cr=cr1*cr2
    return("<and("cr") "v1" "v2"> ]")
    }

   if (item=="then") {
    v2="{"
    do {v1=getlist("",0,cond); v2=v2" "v1; } while (v1!="]")
    v2=v2"}"
    return(v2)
    }


   if (item=="or") {
    v1=getlist("",suppress,cond)
    cr1=cr
    v2=getlist("",suppress,cond)
    cr2=cr
    cr=cr1+cr2
    if (cr>1) cr=1
    return("<or("cr") "v1" "v2"> ]")
    }


   if (item=="set") {
    varname=getitem()
    setto=getlist("",1,cond)
    v=getitem()
    if (cond==1 && varname==variable) {
     result=setto
     return("<set(1) "varname" "setto" {"variable"/"cond"}> ]")
     }
     else return("<set(0) "varname" "setto" {"variable"/"cond"}> ]")
    }
   }
  list=list" "item" "getlist("",suppress,cond)
  }
 return(list)
 }
