
!********************************************************************************
!*   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
!*   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
!*   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
!*
!*
!*   This file is part of the package SNF.
!*
!*   SNF is free software; you can redistribute it and/or modify
!*   it under the terms of the GNU General Public License as published by
!*   the Free Software Foundation; either version 2 of the License, or
!*   (at your option) any later version.
!*
!*   This program is distributed in the hope that it will be useful,
!*   but WITHOUT ANY WARRANTY; without even the implied warranty of
!*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!*   GNU General Public License for more details.
!*
!*   You should have received a copy of the GNU General Public License
!*   along with this program; if not, write to the Free Software
!*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
!*
!********************************************************************************
      subroutine upper(c)
      implicit none
      character*(*) c
      integer n,i
      n=len(c)
      do i=1,n
         if (c(i:i).ge.'a' .and. c(i:i).le.'z') then
            c(i:i)= char( ichar(c(i:i)) - ichar('a') + ichar('A') )
         endif
      enddo
      end

      subroutine lower(c)
C
C     written by J. Neugebauer, Uni Erlangen, 05/2001
C
      implicit none
      character*(*) c
      integer n,i
      n=len(c)
      do i=1,n
         if (c(i:i).ge.'A' .and. c(i:i).le.'Z') then
            c(i:i)= char( ichar(c(i:i)) - ichar('A') + ichar('a') )
         endif
      enddo
      end





