*//FILE  'defs.h'
      IMPLICIT none
      INTEGER nlongr,itape,jtape,idbg,iosl,iprmem,iprq,mxwrk
      REAL*8 zero,one,zthr,bohr2aa,pi
******
****** master INCLUDE file with customizable parameters
******
****** customize the following parameters:
****** nlongr        number of words per long real
****** itape         logical unit for standard input
****** jtape         logical unit for standard output
****** idbg          logical unit for debugging output
****** iosl          logical unit for slave process debugging
****** iprmem        print level for memory manager; useful values:
******               PARAMETER (iprmpr=1,iprmck=2,iprnof=4)
****** iprq          print level for subroutine trace; useful values:
******               PARAMETER (qprint=1,qtimer=2)
****** mxwrk         size of work array in words
****** zthr          zero threshold
****** bohr2aa       conversion factor from bohrs to angstroms
******
      PARAMETER (nlongr=2,itape=5,jtape=6,idbg=41)
      PARAMETER (zthr=1.D-6,zero=0.0D0,one=1.0D0)
      PARAMETER (bohr2aa=0.529177260d0)
      PARAMETER (mxwrk=5000000)
      PARAMETER (pi=3.1415926535897932384626433832795029d0)
      INTEGER is
      REAL*8 S8(mxwrk/2)
      COMMON /flags/ iprq,iprmem,iosl

      COMMON /work/ is(mxwrk)
      EQUIVALENCE (is(1),s8(1))
*//END
