CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE getarch(name,step,mypid,jrc)
      INCLUDE 'defs.h'
      INCLUDE 'param.h'  
      CHARACTER*(*) name
      INTEGER step,mypid,jrc
* local
      CHARACTER*255 b1,b2,b3
      INTEGER l1,l2,xeq

      jrc=1
      IF (arpath(1:1).NE.' ') THEN
       CALL clean(b1)
       b1=tempdir(1:lt)//'/'//name
       CALL llen(b1,l1)
       CALL clean(b2)
       b2=arpath(1:lar)//'/'//name//'.'
       CALL llen(b2,l2)
       CALL augnum(b3,b2(1:l2),step)
       CALL llen(b3,l2)
       CALL reqctok(mypid)
       b2='scp '//b3(1:l2)//' '//b1(1:l1)
       CALL llen(b2,l2)
       jrc=xeq(b2(1:l2))
       CALL mnotify(6,mypid,jrc,b2,l2)
       CALL relctok(mypid)
      ENDIF
      RETURN
      END
