CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE getfile(name,mynode,pnode,info)
      IMPLICIT none
      INCLUDE 'param.h'
*
* tempdir,mydir
* lt,lm,mytid             used from COMMON
*
      CHARACTER*(*) name,mynode,pnode
      CHARACTER*255 b1,b2
      INTEGER info,l,irc
      INTEGER xeq
      CALL clean(b2)
      IF (mynode.EQ.pnode) THEN
* copy locally
       b2='cp '
       l=3
      ELSE
* copy from master
       b2='scp '//masterid(1:li)//':'
       CALL llen(b2,l)
      ENDIF
      b1=b2(1:l)//mydir(1:lm)//'/'//name//' '//tempdir(1:lt)
      CALL llen(b1,l)
      irc=xeq(b1(1:l))
      IF (irc.GT.0) irc=2
      IF (irc.LT.0) irc=3
      IF (irc.EQ.0) irc=1
      info=10*info+irc
      RETURN
      END
