CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE gfile(name,tid,info)
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
*
* get file through parallel interface (pvm or mpi)
*
      CHARACTER*(*) name
      INTEGER tid,info
      CHARACTER*255 b2
      CHARACTER*40 name_sent
      CHARACTER*255 card
      INTEGER l,irc,lu,ibuf

      CALL clean(b2)
      b2=tempdir(1:lt)//'/'//name
      lu=1
      OPEN (UNIT=lu,FILE=b2,FORM='FORMATTED',STATUS='UNKNOWN',
     * IOSTAT=irc)
      IF (irc.NE.0) GOTO 999
      WRITE (iosl,*) '  gfile| receiving ',name
      CALL pgetstr('gfile: filename',name_sent,tid,40,440,irc)
      IF (irc.NE.0) GOTO 999
      WRITE (iosl,*) '       | ',name_sent
      IF (name_sent(1:6).NE.'%FILE '.OR. name_sent(7:40).NE.name) THEN
       WRITE (iosl,*) '       | wrong filename, expecting file <',
     *  name,'>'
       GOTO 999
      ENDIF
1     CONTINUE
      CALL clean(card)
      CALL pgetstr('gfile: card',card,tid,255,441,irc)
C@    WRITE (iosl,*) '       | {',irc,'} ',card(1:30)
C@    CALL flush(iosl)
      IF (irc.NE.0) GOTO 999
      IF (card(1:6).EQ.'%EOF% ') GOTO 999
      WRITE (lu,'(A)') card
      GOTO 1
999   CONTINUE
      IF (irc.GT.0) irc=2
      IF (irc.LT.0) irc=3
      IF (irc.EQ.0) irc=1
      info=10*info+irc
      CLOSE (UNIT=lu)
      RETURN
      END
