CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE howmany(ize,ipe,iprc,stepfl)
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INCLUDE 'sadmch.h'
      INTEGER i,p,ize,ipe,iprc,stepfl(*)
*
* determine number of points still to calculate, number of currently
* pending runs, and number of available processors
*
      ize=0
      ipe=0
      iprc=0
      DO i=1,nstept
       IF (stepfl(i).EQ.0) ize=ize+1
       IF (stepfl(i).EQ.-1) ipe=ipe+1
      ENDDO
      iprc=0
      p=pmch
1     IF (p.EQ.0) RETURN
      IF (is(p+sadmch_nodf).GT.0) iprc=iprc+1
      p=is(p+sadmch_next)
      GOTO 1
      END
