CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE inicomm(mytid,tid0,ipe)

* initialize communications system
* returns own TID in mytid, parent TID in tid0
* ipe is zero if this is the master process

      INCLUDE 'defs.h'
      INCLUDE 'comm.h'
      INTEGER mytid,tid0,ipe
* local
      INTEGER info,read

C#    CALL MPI_INIT(info)
C#    CALL mpierr('MPI_INIT','inicomm',info)
C#    CALL MPI_COMM_RANK(MPI_COMM_WORLD,ipe,info)
C#    CALL mpierr('MPI_COMM_RANK','inicomm',info)
C#    mytid=ipe
C#    tid0=0
C@    WRITE (idbg,*) 'MPI initialized - ipe=',ipe
C@    CALL flush(idbg)
C//SKIPC#

* PVM part; may me tuned by means of file PVM_INIT

      read=0
      CALL PVMFMYTID ( mytid )
C@    WRITE (jtape,*) '@inicomm@ tape=',jtape,' mytid=',mytid
C@    CALL flush(jtape)
C@    WRITE (iosl,*) '@inicomm@ tape=',iosl,' mytid=',mytid
C@    CALL flush(iosl)
C@    WRITE (idbg,*) '@inicomm@ tape=',idbg,' mytid=',mytid
C@    CALL flush(idbg)
C%    IF (mytid.LT.0) THEN
C%     CALL PVMFSTARTPVMD('PVM_INIT',1,info)
C%     IF (info.NE.0) THEN
C%      CALL PVMFPERROR('trying to start pvmd')
C%      CALL errex('error trying to start pvmd')
C%     ENDIF
C%    ENDIF

      CALL PVMFMYTID ( mytid )
      IF(mytid.lt.0) THEN
       WRITE (*,*) 'pvmd not running - cannot start it'
       CALL errex('cannot start pvm')
      ENDIF

C%    CALL PVMFPARENT( tid0  )
C%    ipe=mytid
C%    IF (tid0 .EQ. PVMNOPARENT) ipe=0

C//SKIPC%3
      CALL PVMFGETTID(PVMALL,0,tid0)
      CALL PVMFGETPE(mytid,ipe)
C//END

      RETURN
      END
