CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE readin

* read input file and store it in-core

      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER lu,lupvm,iostat,irc
      CHARACTER*255 rec,item(mxitem)
      CHARACTER*255 param
      INTEGER i,ip,l
      inrec=0
      lupvm=1
      lu=5
      WRITE (idbg,*) '@readin@ reading input from lu ',lu
      OPEN (UNIT=lu,FILE='DCINPUT',STATUS='OLD',IOSTAT=irc)
      IF (irc.NE.0) THEN
       WRITE (*,*) '#readin# cannot open file DCINPUT'
       CALL errex('DCINPUT missing')
      ENDIF
90    READ (lu,'(A)',END=99) rec
      inrec=inrec+1
      IF (inrec.GT.mxinfi) THEN
       WRITE (jtape,*)
     *   '* number of input records exceeds maximum of ',mxinfi
       WRITE (jtape,*)
     *   '* increase mxinfi in util.r[readin] and recompile'
       CALL errex('too many input records')
      ENDIF
      CALL split(rec,item,mxitem)
      infi(inrec)=rec
      GOTO 90
99    CLOSE (UNIT=lu)
      WRITE (idbg,*) '@readin@ ',inrec,' input records read.'
      RETURN
      END
