CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE rxxxx(fn,nit,cpu,wall)
      IMPLICIT none
      INCLUDE 'param.h'
      INTEGER nit
      REAL*8 cpu,wall
      CHARACTER*(*) fn
      CHARACTER*255 b1,b2
      INTEGER info,l,irc,xeq
      CHARACTER*255 filename
      CHARACTER*255 item(mxitem)
      LOGICAL yes
      INTEGER lu,i,intgr
      REAL*8 rr
      CALL clean(filename)
      filename=tempdir(1:lt)//'/'//fn
      nit=0
      cpu=0.
      wall=0.
      INQUIRE (FILE=filename,EXIST=yes)
      IF (yes) THEN
       lu=1
       OPEN (UNIT=lu,FILE=filename,STATUS='OLD')
1      READ (lu,'(A)',END=999) filename
       CALL split(filename,item,mxitem)
       i=0
       IF (item(3).EQ.'satisfied') nit=intgr(item(5),i,20)
       IF (item(2).EQ.'cpu-time') CALL tosec(item,cpu)
       IF (item(2).EQ.'wall-time') CALL tosec(item,wall)
       GOTO 1
999    CLOSE (UNIT=lu)
      ENDIF
      RETURN
      END
