CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE sadmch_dmp(it,p)
*
* dump sadmch structure
*
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INCLUDE 'objects.h'
      INCLUDE 'sadmch.h'
      INTEGER it,p
* local
      INTEGER i
      WRITE (it,*) '       | SADMCH structure at ',p
      WRITE (it,'(20A4)') '       | ',(is(p+sadmch_name+i-1),i=1,10)
      WRITE (it,'(20A4)') '       | ',(is(p+sadmch_arch+i-1),i=1,2)
      WRITE (it,*) '       | next ',is(p+sadmch_next)
      WRITE (it,*) '       | tid  ',is(p+sadmch_tid)
      WRITE (it,*) '       | tpid ',is(p+sadmch_tpid)
      WRITE (it,*) '       | nodf ',is(p+sadmch_nodf)
      WRITE (it,*) '       | time ',is(p+sadmch_time)
      WRITE (it,*) '       | tmsg ',is(p+sadmch_tmsg )
      WRITE (it,*) '       | last ',is(p+sadmch_last )
      WRITE (it,*) '       | mxlo ',is(p+sadmch_mxlo )
      WRITE (it,*) '       | stpa ',is(p+sadmch_stpa )
      WRITE (it,*) '       | stpb ',is(p+sadmch_stpb )
      CALL flush(it)
      RETURN
      END
