CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE updvm(opt)
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INCLUDE 'sadmch.h'
      INTEGER p,opt,mxlo
      CHARACTER*255 b
      CHARACTER*40 name
**
** update virtual machine
**

      IF (MOD(opt,2).GE.1) THEN
*
* shutdown running processes with excessive workload
*
       p=pmch
20     IF (p.EQ.0) GOTO 21
       IF (is(p+sadmch_nodf).EQ.sadmch_rdy) THEN
        CALL sadmch_gname(p,name)
        CALL sadmch_fname(pvmmch,name)
        IF (cmch.NE.0) THEN
         mxlo=is(cmch+sadmch_mxlo)
         IF (mxlo.GT.0) THEN
          IF (is(p+sadmch_load).GT.mxlo) THEN
           WRITE (idbg,*) '       | ',is(p+sadmch_load),mxlo,' ',name
           is(p+sadmch_cmd)=sadmch_vbsy
          ENDIF
          IF (is(p+sadmch_load).LT.mxlo
     *     .AND.is(p+sadmch_cmd).EQ.sadmch_vbsy) is(p+sadmch_cmd)=0
          ENDIF
         ENDIF
       ENDIF
       p=is(p+sadmch_next)
       GOTO 20
21     CONTINUE      
      ENDIF
      IF (MOD(opt,4).GE.2) THEN
*
* add new machines which are idle
*
       CALL clean(b)
       CALL cmd_spawn(b)
      ENDIF
      RETURN
      END
