C
C      PROGRAM TO REMOVE REMARKS FROM FORTRAN SOURCE TEXT
C
C      C//DELC#          SETS # 'ON'; ACTIVATES ALL C#
C      C//SKIPC#XY       SKIPS XY CARDS IF # IS 'ON'
C                        IF XY IS A BLANK FIELD, ALL CARDS UP TO A
C                        C//END STATEMENT WILL BE COMMENTED OUT
C      C//FILE X         DEFINES FILE WITH NAME X, CONTENTS IS ALL
C                        CARDS UP TO THE NEXT C//END STATEMENT
C                        LIMITED TO MAXF=100 CARDS IN THIS VERSION
C
C            INCLUDE X   INCLUDES CARDS DEFINED BY FILE X
C
C     V 1.4.1 
C     V 1.4 - C//TRACE C//NOTRACE
C     V 1.3 - C//FILE AND INCLUDE
C     V 1.2 - RECORDLENGTH 72
      PARAMETER (MAXF=100,MFIL=5,MILX=100,MAXC=50)
      CHARACTER*60 FILNAM(MFIL)
      CHARACTER*80 BUF
      CHARACTER*80 FI(MAXF)
      CHARACTER*60 NAME
      CHARACTER*72 OUTC,CARD
      CHARACTER*6  UNIT
      INTEGER FIS(MFIL),FIE(MFIL)
      EQUIVALENCE (CARD,OUTC)
      INTEGER IN,OUT,IDEL
      CHARACTER*2 DEL(10)
      COMMON /CHARS/ UNIT
      COMMON /CVT/ IBFRD,IQ,ILA(9999),ILX,ILY,ILB(MILX),ILC(MILX)
      CHARACTER*72 Q
      COMMON /QU/ BUF,Q(MAXC)
660   FORMAT(1X,I5,' | ',A80)
      WRITE (6,*) ' ###### DELREM V 1.4.1 - 4.7.89 ######'
      IQ=0
      IN=5
      OUT=2
      OPEN (UNIT=OUT,FILE='fort.2',FORM='FORMATTED',
     * STATUS='UNKNOWN')
      IDEL=0
      NR=0
      NC1=0
      NC2=0
      NC3=0
      NC4=0
      NCTR=0
      NFIL=0
      NAXF=1
      ITRACE=0
      IENBL=0
      IBFRD=0
      ILY=10000
      UNIT='MAIN  '
      ILX=0
      DO 45 I=1,9999
45    ILA(I)=0
      READ (IN,100,END=2) BUF
      NR=1
      WRITE (*,660) NR,BUF
      IBFRD=1
C
C     FLSH BUFFER
C
1     IF (IQ.GT.0) CALL FLSH(OUT)
      IF (IBFRD.LT.0) GOTO 2
      IF (IBFRD.EQ.0) READ (IN,100,END=2) BUF
      CALL QUEUE(BUF)
      
C
C     READ INPUT CARD. BUF IS READAHEAD BUFFER
C
61    READ (IN,100,END=2) BUF
100   FORMAT(A80)
101   FORMAT(A72)
      NR=NR+1
      IF (BUF(1:1).NE.'C' .AND. BUF(6:6).NE.' ') THEN
      CALL QUEUE(BUF)
      GOTO 61
      ENDIF
C     REMEMBER THAT WE HAVE A CARD IN THE READAHEAD BUFFER
      IBFRD=1
C
C     ANALYZE BUFFER
C
222   CONTINUE
      CARD=Q(1)
C
C     C//DELC# CARD
C
      IF (CARD(1:6).EQ.'C//DEL') THEN
       IF (IDEL.EQ.10) THEN
        WRITE (*,*) '######## NOT MORE THAN 10 C//DELC CARDS ALLOWED'
        STOP 'DELREM FATAL ERROR'
       ELSE
        IDEL=IDEL+1
        DEL(IDEL)=CARD(7:8)
        CARD (2:3)='..'
       ENDIF
       Q(1)=CARD
       WRITE (6,660) NR,CARD
       GOTO 1
      ENDIF
C
C     C//TRACE CARD
C
      IF (CARD(1:8).EQ.'C//TRACE') THEN
      IF (IENBL.EQ.1) THEN
      ITRACE=1
      CARD(2:3)='..'
      ELSE
      CARD(2:3)='--'
      ENDIF
      CARD(10:16)=UNIT
      Q(1)=CARD
      WRITE (6,660) NR,CARD
      GOTO 1
      ENDIF
C
C     C//NOTRACE CARD
C
      IF (CARD(1:10).EQ.'C//NOTRACE') THEN
      IF (IENBL.EQ.1) THEN
      IF (ITRACE.GT.0) THEN
      NCTR=NCTR+ITRACE-1
      ITRACE=0
      CARD(2:3)='..'
      ELSE
      CARD(2:3)=' ?'
      ENDIF
      ELSE
      CARD(2:3)='--'
      ENDIF
      Q(1)=CARD
      WRITE (6,660) NR,CARD
      GOTO 1
      ENDIF
C
C     C//ENABLE CARD
C
      IF (CARD(1:9).EQ.'C//ENABLE') THEN
      IENBL=1
      CARD(2:3)='..'
      Q(1)=CARD
      WRITE (6,660) NR,CARD
      GOTO 1
      ENDIF
C
C     C//FILE XXX CARD
C
      IF (CARD(1:7).EQ.'C//FILE') THEN
       NC3=NC3+1
       CARD(1:3)='C..'
C      FLSH BUFFER
       IQ=0
       WRITE (OUT,101) CARD
       WRITE (6,660) NR,CARD
       DO 39 I=1,60
39     NAME(I:I)=' '
       DO 30 I=8,60
       IF (CARD(I:I).NE.' ') GOTO 31
30     CONTINUE
31     J=0
       DO 32 K=I,60
       IF (CARD(K:K).EQ.' ') GOTO 33
       J=J+1
       NAME(J:J)=CARD(K:K)
32     CONTINUE
33     CONTINUE
       DO 34 I=1,NFIL
        IF (NAME.EQ.FILNAM(I)) THEN
         WRITE (6,38) NR,NAME
38       FORMAT(1X,I5,' | DUPLICATE FILE: ',A60)
         IF (IBFRD.GT.0) THEN
         CARD=BUF(1:72)
         IBFRD=0
         GOTO 371
	 ENDIF
37       READ (IN,101,END=2) CARD
         NR=NR+1
371      IF (CARD(1:6).EQ.'C//END') GOTO 1
         GOTO 37
        ENDIF
 34    CONTINUE
       IF (NFIL.EQ.MFIL) THEN
        WRITE (6,48) NR,NAME
48      FORMAT(1X,I5,' | TOO MANY FILES: ',A60)
        IF (IBFRD.GT.0) THEN
        CARD=BUF(1:72)
        IBFRD=0
        GOTO 471
	ENDIF
47      READ (IN,101,END=2) CARD
        NR=NR+1
471     IF (CARD(1:6).EQ.'C//END') GOTO 1
        GOTO 47
       ENDIF
       NFIL=NFIL+1
       FILNAM(NFIL)=NAME
       FIS(NFIL)=NAXF
       IF (IBFRD.GT.0) THEN
       CARD=BUF(1:72)
       IBFRD=0
       GOTO 571
       ENDIF
       GOTO 41
43     NAXF=NAXF+1
       IF (NAXF.EQ.MAXF) THEN
        WRITE (6,58) NR,CARD
58      FORMAT(1X,I5,' | TOO MANY LINES: ',A80)
57      READ (IN,101,END=2) CARD
        NR=NR+1
        IF (CARD(1:6).EQ.'C//END') GOTO 1
        GOTO 57
       ENDIF
       IF (IBFRD.GT.0) THEN
       CARD=BUF(1:72)
       IBFRD=0
       GOTO 411
       ENDIF
41     READ (IN,101,END=2) CARD
571    IF (CARD(1:6).EQ.'C//END') GOTO 42
411    CALL CCARD(IN,OUT,CARD,OUTC,NR,NC1,IDEL,DEL,NC2,ITRACE,IRET)
       IF (IRET.EQ.1) GOTO 41
       FI(NAXF)=CARD
       GOTO 43
42     FIE(NFIL)=NAXF
      GOTO 1
      ENDIF
C
C            INCLUDE - CARD
C
      IF (CARD(1:13).EQ.'      INCLUDE') THEN
       NC4=NC4+1
       CARD(1:3)='C..'
C      FLSH BUFFER
       IQ=0
       WRITE (OUT,101) CARD
       WRITE (6,660) NR,CARD
       DO 69 I=1,60
69     NAME(I:I)=' '
       DO 60 I=14,74
       IF (CARD(I:I).NE.' ') GOTO 611
60     CONTINUE
611    J=0
       DO 62 K=I,74
       IF (CARD(K:K).EQ.' ') GOTO 63
       J=J+1
       NAME(J:J)=CARD(K:K)
62     CONTINUE
63     CONTINUE
       DO 64 I=1,NFIL
        IF (NAME.EQ.FILNAM(I)) THEN
         J=FIS(I)
         DO 54 K=J,FIE(I)-1
         WRITE (OUT,101) FI(K)
54       CONTINUE
         GOTO 46
        ENDIF
64     CONTINUE
       WRITE (6,44) NR,NAME
44     FORMAT(1X,I5,' | FILE NOT FOUND: ',A60)
46     CONTINUE
      GOTO 1
      ENDIF
      DO 68 I=1,IQ
      CALL CCARD(IN,OUT,Q(I),OUTC,NR,NC1,IDEL,DEL,NC2,ITRACE,IRET)
      IF (IRET.EQ.1) GOTO 67
68    CONTINUE
      CARD=Q(1)(1:72)
      IF (CARD(1:1).NE.'C' .AND. IENBL.EQ.1) 
     *CALL DTRC(IN,OUT,CARD,OUTC,ITRACE,IRET)
      GOTO 1
67    IQ=0
      GOTO 1
2     CONTINUE
      IF (IBFRD.GT.0) THEN
      IBFRD=-1
      GOTO 222
      ENDIF
      IF (ITRACE.GT.0) NCTR=NCTR+ITRACE-1
      WRITE (6,300) NR,NC1,NC3,NC4,NCTR,NC2
300   FORMAT(' NUMBER OF CARDS READ',T40,I10/,
     *       ' NUMBER OF COMMENTS REMOVED',T40,I10/,
     *       ' NUMBER OF FILE STATMENTS',T40,I10/,
     *       ' NUMBER OF INCLUDE STATEMENTS',T40,I10/,
     *       ' NUMBER OF CARDS TRACED',T40,I10/,
     *       ' NUMBER OF STATEMENTS SKIPPED',T40,I10//)
      IF (NCTR.GT.0) THEN
      NC1=0
       DO 78 I=1,9999
       IF (ILA(I).NE.0) THEN
       IF (NC1.EQ.0) THEN
       NC1=1
       WRITE (*,301)
301    FORMAT(//' FOLLOWING DO LOOPS EXTEND BEYOND TRACE UNIT:'/)
       ENDIF
        IF (ILA(I).GT.0) THEN
         WRITE (*,302) I,ILA(I)
302      FORMAT(1X,I4,' (NOW ',I5,')')
        ELSE
         N=-ILA(I)
         WRITE (*,*) 'LABEL',I,' IS TARGET FOR MORE THAN ONE DO LOOP:'
         DO 79 J=1,ILX
         IF (ILB(J).EQ.I) THEN
          WRITE (*,302) I,ILC(J)
          N=N-1
          IF (N.EQ.0) GOTO 80
         ENDIF
79       CONTINUE
80       CONTINUE
        ENDIF
       ENDIF
78     CONTINUE
      ENDIF
      IF (NC1.EQ.1) THEN
      WRITE (*,*) 'PLACE C//NOTRACE STATEMENT BEYOND THE LAST ONE'
      WRITE (*,*) 'OF THESE LABELS AND RERUN THIS PROGRAM'
      STOP 'DELREM: FATAL ERROR'
      ENDIF
      STOP
      END
      SUBROUTINE QUEUE(CARD)
      PARAMETER (MAXF=100,MFIL=5,MILX=100,MAXC=50)
      CHARACTER*72 CARD
      COMMON /CVT/ IBFRD,IQ,ILA(9999),ILX,ILY,ILB(MILX),ILC(MILX)
      CHARACTER*72 Q,BUF*80
      COMMON /QU/ BUF,Q(MAXC)
      IF (IQ.EQ.MAXC) THEN
      WRITE (*,*) '###### NOT MORE THAN',MAXC,' CONTINUATION CARDS'
      WRITE (*,*) CARD
      STOP 'QUEUE: FATAL ERROR'
      ENDIF
      IQ=IQ+1
      Q(IQ)=CARD
      RETURN
      END
      SUBROUTINE STACK(CARD)
      PARAMETER (MAXF=100,MFIL=5,MILX=100,MAXC=50)
      CHARACTER*72 CARD
      COMMON /CVT/ IBFRD,IQ,ILA(9999),ILX,ILY,ILB(MILX),ILC(MILX)
      CHARACTER*72 Q,BUF*80
      COMMON /QU/ BUF,Q(MAXC)
      IF (IQ.EQ.MAXC) THEN
      WRITE (*,*) '###### NOT MORE THAN',MAXC,' CONTINUATION CARDS'
      WRITE (*,*) CARD
      STOP 'STACK: FATAL ERROR'
      ENDIF
      DO 1 I=IQ,1,-1
1     Q(I+1)=Q(I)
      IQ=IQ+1
      CARD(1:5)=Q(1)(1:5)
      Q(1)=CARD
      Q(2)(1:5)='     '
      RETURN
      END
      SUBROUTINE FLSH(NTAPE)
      PARAMETER (MAXF=100,MFIL=5,MILX=100,MAXC=50)
      COMMON /CVT/ IBFRD,IQ,ILA(9999),ILX,ILY,ILB(MILX),ILC(MILX)
      CHARACTER*72 Q,BUF*80
      COMMON /QU/ BUF,Q(MAXC)
      DO 1 I=1,IQ
      WRITE (NTAPE,100) Q(I)
1     CONTINUE
      IQ=0
100   FORMAT(A72)
      RETURN
      END
C
C     PROCESS COMMENTS AND SKIP CARDS
C
      SUBROUTINE CCARD(IN,OUT,CARD,OUTC,NR,NC1,IDEL,DEL,NC2,ITRACE,IRET)
      PARAMETER (MAXF=100,MFIL=5,MILX=100,MAXC=50)
      CHARACTER CARD*72,OUTC*72
      CHARACTER*2 DEL(*)
      INTEGER OUT
      COMMON /CVT/ IBFRD,IQ,ILA(9999),ILX,ILY,ILB(MILX),ILC(MILX)
      CHARACTER*72 Q,BUF*80
      COMMON /QU/ BUF,Q(MAXC)
      IRET=0
C
C     C//SKIPC# CARD
C
      IF (CARD(1:7).EQ.'C//SKIP') THEN
       DO 11 I=1,IDEL
       IF (DEL(I).EQ.CARD(8:9)) THEN
       IRET=1
       IF (CARD(10:10).EQ.' ') THEN
        ISKIP=1000000
       ELSE
        ISKIP=0
        J=10
22      K=-1
        IF (CARD(J:J).EQ.'0') K=0
        IF (CARD(J:J).EQ.'1') K=1
        IF (CARD(J:J).EQ.'2') K=2
        IF (CARD(J:J).EQ.'3') K=3
        IF (CARD(J:J).EQ.'4') K=4
        IF (CARD(J:J).EQ.'5') K=5
        IF (CARD(J:J).EQ.'6') K=6
        IF (CARD(J:J).EQ.'7') K=7
        IF (CARD(J:J).EQ.'8') K=8
        IF (CARD(J:J).EQ.'9') K=9
         IF (K.GE.0) THEN
          ISKIP=10*ISKIP+K
          J=J+1
          GOTO 22
         ENDIF
        ENDIF
        CARD(2:3)='..'
        WRITE (OUT,101) OUTC
        IQ=0
        WRITE (6,660) NR,CARD
        DO 12 J=1,ISKIP
	IF (J.EQ.1 .AND. IBFRD.GT.0) THEN
        CARD=BUF(1:72)
        IBFRD=0
        ELSE
        READ (IN,100,END=2) CARD
	ENDIF
        NR=NR+1
        CARD(50:64)='### SKIPPED ###'
	CARD(1:1)='C'
        NC2=NC2+1
        WRITE (OUT,101) OUTC
        IF (CARD(1:6).EQ.'C//END') GOTO 2
12      CONTINUE
        GOTO 2
       ENDIF
11     CONTINUE
       GOTO 2
      ENDIF
      DO 10 I=1,IDEL
      IF (CARD(1:2).EQ.DEL(I)) THEN
      CARD(1:2)='  '
      NC1=NC1+1
      ENDIF
10    CONTINUE
100   FORMAT(A72)
101   FORMAT(A72)
660   FORMAT(1X,I5,' | ',A80)
      RETURN
2     IRET=1
      RETURN
      END
      SUBROUTINE DTRC(IN,OUT,CARD,OUTC,ITRACE,IRET)
      PARAMETER (MAXF=100,MFIL=5,MILX=100,MAXC=50)
      CHARACTER CARD*72,OUTC*72,TREC*80,REC*72,VAR*72,T72*72
      CHARACTER*6 UNIT
      COMMON /CHARS/ UNIT
      COMMON /CVT/ IBFRD,IQ,ILA(9999),ILX,ILY,ILB(MILX),ILC(MILX)
      CHARACTER*72 Q,BUF*80
      COMMON /QU/ BUF,Q(MAXC)
      INTEGER OUT
      EQUIVALENCE (TREC,T72)
      CALL CLEAR(VAR,72)
      CALL CLEAR(REC,72)
C
C     REMOVE BLANKS FROM FORTRAN STATEMENT
C
      JQ=0
      DO 10 IP=7,72
      IF (CARD(IP:IP).NE.' ') THEN
      JQ=JQ+1
      REC(JQ:JQ)=CARD(IP:IP)
      ENDIF
10    CONTINUE
C
C     DO NOT TRACE NON-EXECUTABLE STATEMENTS
C
      IF (REC(1:10).EQ.'SUBROUTINE') THEN
      ILX=0
      ILY=10000
      DO 41 I=1,9999
41    ILA(I)=0
      UNIT='      '
      DO 15 I=11,16
      IF (REC(I:I).EQ.' '.OR.REC(I:I).EQ.'(') GOTO 17
      UNIT(I-10:I-10)=REC(I:I)
15    CONTINUE
17    CONTINUE
      WRITE (*,*) UNIT
      RETURN
      ENDIF
C
C     HANDLE DO STATEMENT
C
      IF (REC(1:2).EQ.'DO') THEN
      CALL DOLOOP(CARD,REC)
      ENDIF
      IF (ITRACE.EQ.0) GOTO 999
      IF (REC(1:6).EQ.'FORMAT') RETURN
      IF (REC(1:9).EQ.'CHARACTER') RETURN
      IF (REC(1:9).EQ.'PARAMETER') RETURN
      IF (REC(1:9).EQ.'DIMENSION') RETURN
      IF (REC(1:9).EQ.'BLOCKDATA') RETURN
      IF (REC(1:9).EQ.'EQUIVALEN') RETURN
      IF (REC(1:8).EQ.'IMPLICIT') RETURN
      IF (REC(1:7).EQ.'INTEGER') RETURN
      IF (REC(1:4).EQ.'REAL') RETURN
      IF (REC(1:7).EQ.'LOGICAL') RETURN
      IF (REC(1:4).EQ.'DATA') RETURN
      IF (REC(1:4).EQ.'ELSE') GOTO 999
      IF (REC(1:6).EQ.'COMMON') RETURN
      IF (REC(1:5).EQ.'ENDIF') RETURN
C
C     DETERMINE IF WE HAVE AN ASSIGNMENT STATEMENT
C
      IASGN=0
      IF (REC(1:2).NE.'DO' .AND.
     *    REC(1:2).NE.'IF' .AND.
     *    REC(1:5).NE.'WRITE' .AND.
     *    REC(1:4).NE.'READ')
     *THEN
      DO 11 IP=1,66
      IF (REC(IP:IP).EQ.'''') GOTO 12
      IASGN=IASGN+1
      IF (REC(IP:IP).EQ.'=') GOTO 13
11    CONTINUE
12    IASGN=0
      GOTO 14
13    VAR(1:IASGN)=REC(1:IASGN)
14    CONTINUE
      ENDIF
      IRET=0
      ITRACE=ITRACE+1
      CALL CLEAR(TREC,80)
      TREC(1:7)='     *'''
      TREC(8:13)=UNIT
      TREC(14:15)=': '
      TREC(16:20)=CARD(1:5)
      TREC(21:71)=CARD(7:57)
      TREC(72:72)=' '
      DO 7 I=8,72
      IF (TREC(I:I).EQ.'''') TREC(I:I)='"'
7     CONTINUE
      DO 5 I=72,1,-1
      IF (TREC(I:I).EQ.' ') GOTO 5
      TREC(I+1:I+1)=''''
      GOTO 6
5     CONTINUE
6     CONTINUE
      CALL STACK(T72)
      CALL CLEAR(TREC,80)
      TREC(6:17)=' WRITE (*,*)'
      CALL STACK(T72)
      CALL CLEAR(T72,72)
C
C     WRITE OUT CONTENTS OF VARIABLE
C
      IF (IASGN.GT.0) THEN
      CALL CLEAR(TREC,72)
      TREC(1:20)='      WRITE (*,*) ''*'
      TREC(21:21+IASGN-1)=VAR(1:IASGN)
      K=21+IASGN
      TREC(K:K+1)=''','
      K=K+2
      TREC(K:K+IASGN-1)=VAR(1:IASGN-1)
      CALL QUEUE(T72)
      ENDIF
C
C     HANDLE DO LOOP TARGETS
C
999   IF (CARD(1:6).NE.'      ') CALL PLABEL(CARD)
      RETURN
101   FORMAT(A72)
102   FORMAT(A80)
103   FORMAT(A17)
      END
      INTEGER FUNCTION INTGR(X,I,MX)
      CHARACTER*20 X
      CHARACTER*80 F
      DO 3 J=1,MX
      IF (X(J:J).NE.' ') GOTO 4
3     CONTINUE
4     CONTINUE
      DO 1 I=J,MX
      IF (X(I:I).GT.'9' .OR. X(I:I) .LT. '0') GOTO 2
1     CONTINUE
      I=21
2     I=I-J
      IF (I.EQ.0) THEN
      INTGR=0
      RETURN
      ENDIF
      WRITE (F,100) I
100   FORMAT('(I',I2,')')
      READ (X(J:20),F) K
      INTGR=K
      RETURN
      END
      SUBROUTINE CLEAR(X,N)
      CHARACTER*80 X
      DO 1 I=1,N
1     X(I:I)=' '
      RETURN
      END
      SUBROUTINE DOLOOP(CARD,REC)
      PARAMETER (MAXF=100,MFIL=5,MILX=100,MAXC=50)
      COMMON /CVT/ IBFRD,IQ,ILA(9999),ILX,ILY,ILB(MILX),ILC(MILX)
      CHARACTER*72 Q,BUF*80
      COMMON /QU/ BUF,Q(MAXC)
      CHARACTER*72 CARD,REC,VAR
      LABEL=INTGR(REC(3:22),IP,10)
      IF (LABEL.EQ.0) RETURN
      CALL CLEAR(VAR,72)
      IP=IP+2
      IF (LABEL.GT.9999) THEN
      WRITE (*,*) '###### CANNOT HANDLE LABELS GREATER THAN 9999'
      WRITE (*,*) CARD
      STOP 'DOLOOP: FATAL ERROR'
      ENDIF
      ILY=ILY+1
      IF (ILA(LABEL).NE.0) THEN
      IF (ILA(LABEL).GT.0) THEN
      IF (ILX.EQ.MILX) THEN
      WRITE (*,*) '###### CANNOT HANDLE THAT MANY IDENTICAL TARGETS'
      WRITE (*,*) '###### SPECIFY DIFFERENT TARGETS FOR EACH DO LOOP'
      STOP 'DOLOOP: FATAL ERROR'
      ENDIF
      ILX=ILX+1
      ILB(ILX)=LABEL
      ILC(ILX)=ILA(LABEL)
      ILA(LABEL)=-1
      ENDIF
      IF (ILX.EQ.MILX) THEN
      WRITE (*,*) '###### CANNOT HANDLE THAT MANY IDENTICAL TARGETS'
      WRITE (*,*) '###### SPECIFY DIFFERENT TARGETS FOR EACH DO LOOP'
      STOP 'DOLOOP: FATAL ERROR'
      ENDIF
      ILX=ILX+1
      ILB(ILX)=LABEL
      ILC(ILX)=ILY
      ILA(LABEL)=ILA(LABEL)-1
      ELSE
      ILA(LABEL)=ILY
      ENDIF
      VAR(1:6)=CARD(1:6)
      VAR(7:10)='DO '
      WRITE (VAR(11:16),'(I5,1X)') ILY
      DO 21 I=72,1,-1
      IF (REC(I:I).NE.' ') GOTO 22
21    CONTINUE
22    CONTINUE
      IREST=I-IP
      IF (IREST.GT.55) THEN
      WRITE (*,*) '###### SPLIT THIS STMT AND CONTINUE ON NEXT CARD:'
      WRITE (*,*) CARD
      STOP 'DOLOOP: FATAL ERROR'
      ENDIF
      VAR(17:17+IREST)=REC(IP+1:IP+IREST)
      Q(1)(1:72)=VAR(1:72)
      RETURN
      END
      SUBROUTINE PLABEL(CARD)
      PARAMETER (MAXF=100,MFIL=5,MILX=100,MAXC=50)
      COMMON /CVT/ IBFRD,IQ,ILA(9999),ILX,ILY,ILB(MILX),ILC(MILX)
      CHARACTER*72 Q,BUF*80
      COMMON /QU/ BUF,Q(MAXC)
      CHARACTER*72 CARD,VAR
      LABEL=INTGR(CARD(1:6),IP,6)
      IF (LABEL.LE.0) RETURN
      IF (LABEL.GT.9999) THEN
      WRITE (*,*) '###### CANNOT HANDLE LABELS GREATER THAN 9999'
      WRITE (*,*) CARD
      STOP 'PLABEL: FATAL ERROR'
      ENDIF
      IF (ILA(LABEL).EQ.0) RETURN
      IF (ILA(LABEL).GT.0) THEN
      CALL CLEAR(VAR,72)
      WRITE (VAR,100) ILA(LABEL)
100   FORMAT(I5,' CONTINUE')
      CALL QUEUE(VAR)
      ILA(LABEL)=0
      RETURN
      ENDIF
      N=-ILA(LABEL)
      DO 2 K=N,1,-1
      M=K
      DO 1 J=1,ILX
      IF (ILB(J).EQ.LABEL) M=M-1
      IF (M.EQ.0) THEN
      ILA(LABEL)=ILA(LABEL)+1
      CALL CLEAR(VAR,72)
      WRITE(VAR,100) ILC(J)
      CALL QUEUE(VAR)
      GOTO 2
      ENDIF
1     CONTINUE
2     CONTINUE
      END
