/*
program to fix FORTRAN lines that are longer than 72 characters
$Header: /home/hess/symlinks/tmp2/hess/f/ut/RCS/fixf.c,v 1.3 1992/04/20 17:30:07 hess Exp $
$Log: fixf.c,v $
 * Revision 1.3  1992/04/20  17:30:07  hess
 * comments not folded
 *
 * Revision 1.2  92/04/20  17:07:39  hess
 * max length parametrized, Revision level printed.
 * 
 * Revision 1.1  92/04/20  16:55:48  hess
 * Initial revision
 * 
B. Hess - 22.8.91
*/
#define MX 72
#include <stdio.h>
#define MAXLEN 255
main()
{
char buffer[MAXLEN+1];
register int i,folded,allfold;
int l; char c,c1,*p,*q;
allfold=0;
for (;;) {
 fgets(buffer,MAXLEN,stdin);
 if (feof(stdin)) break;
 l = strlen(buffer);
 folded=0;
 /* strip carriage return and all blanks from the end */
 p= &buffer[l-1]; l--; while (l>0 && *p == ' ') l--,p--; buffer[l]='\0';
 /* fold if the record is longer than MX and if it is not a comment */
 while (l>MX && buffer[0]!='C' && buffer[0]!='c' && buffer[0]!='*') {
  /* print out first MX characters. */
  c=buffer[MX]; buffer[MX]='\0';
  printf("%s\n",buffer);
  /* if the statement was a comment in the first place, remember to
     place a 'C' in the first column */
  /* not necessary in this version, since comments are not folded
  if (buffer[0]=='C' || buffer[0]=='c' || buffer[0]=='*')
   c1='C'; else c1=' ';
  strncpy(buffer,"     $",6); buffer[0]=c1; buffer[72]=c;
  */
  strncpy(buffer,"     $",6); buffer[72]=c;
  p = &buffer[6]; q = &buffer[MX];
  for (i=MX; i<=l; i++) *p++ = *q++;
  l -= MX; folded++;
  }
 printf("%s\n",buffer);
 if (folded) printf("C folded %d (fixf $Revision: 1.3 $) \n",folded);
 allfold+=folded;
 }
/* fprintf(stderr,"fixf: %d record(s) folded.\n",allfold); */
}
