
!********************************************************************************
!*   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
!*   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
!*   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
!*
!*
!*   This file is part of the package SNF.
!*
!*   SNF is free software; you can redistribute it and/or modify
!*   it under the terms of the GNU General Public License as published by
!*   the Free Software Foundation; either version 2 of the License, or
!*   (at your option) any later version.
!*
!*   This program is distributed in the hope that it will be useful,
!*   but WITHOUT ANY WARRANTY; without even the implied warranty of
!*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!*   GNU General Public License for more details.
!*
!*   You should have received a copy of the GNU General Public License
!*   along with this program; if not, write to the Free Software
!*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
!*
!********************************************************************************
      subroutine preig(io,norbs,spectrum,a)
      use snf_spectrum, only : type_peak
      implicit real*8 (a-h,o-z)
!-------------------------------------------------------------------------------
! BAH the f90 compiler on tcal3 requires that the variables are explicitly typed
!-------------------------------------------------------------------------------
      INTEGER io,norbs,n,ntimes,nrest,ie,j,n2,k,i
      character*(*) a
      type(type_peak) :: spectrum(*)
      write(io,'(/,10x,a)')a                                       
      n=6                                                                       
      ntimes=norbs/n                                                            
      nrest=mod(norbs,n)                                                        
      if(ntimes.eq.0) nrest=norbs                                               
      ie=nrest-1                                                              
                                                                                
      j=1                                                                       
      n2=n                                                                      
                                                                                
      do k=1,ntimes                                                             
      write(io,*)                                                               
      write(io,100)(i,i=j,n2)                                                   
      write(io,300)(spectrum(i)%freq,i=j,n2)
      j =j +n                                                                   
      n2=n2+n                                                                   
      enddo                                                                     
                                                                                
      if(nrest.gt.0.or.ntimes.eq.0) then                                        
      write(io,*)                                                               
      ie=j+nrest-1                                                              
      write(io,100)(i,i=j,ie)                                                   
      write(io,300)(spectrum(i)%freq,i=j,ie)                                                
      endif                              
      return                                                                    
 100  format(' ROOT NO.: ',2x,6(4x,i4,2x))                                      
 300  format(' EIGVAL. : ',2x,6f10.3)                                           
      end                                                                       
                                                                                



