CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE concat(a,b,res)
      IMPLICIT none
      CHARACTER*(*) a,b,res
*
* concatenate strings a and b to give string c
* needed because g77 does not support concatenation of non-scalar strings
*
      INTEGER l1,l2,l3,l
      l1=LEN(a)
      l2=LEN(b)
      l3=LEN(res)
      CALL clean(res)
      IF (l1.LE.l3) THEN
       res(1:l1)=a
       IF (l1+l2.LE.l3) THEN
        res(l1+1:l1+l2)=b
        RETURN
       ENDIF
       l=l1+l2-l3
       res(l1+1:l3)=b(1:l)
       RETURN
      ENDIF
      res=a(1:l3)
      RETURN
      END
      SUBROUTINE appba(a,b)
      IMPLICIT none
      CHARACTER*(*) a,b
*
* concatenate strings a and b to give string c
* needed because g77 does not support concatenation of non-scalar strings
*
      INTEGER l1,l2,l
      l1=LEN(a)
      l2=LEN(b)
      CALL llen(a,l)
      IF (l+l2.LT.l1) THEN
       a(l+1:l+l2)=b
       RETURN
      ENDIF
      l2=l1-l
      a(l+1:l1)=b(1:l2)
      RETURN
      END
