CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE cslave
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INCLUDE 'objects.h'

      INTEGER pgrad,pc,pl
      nvar=3*natoms

      CALL memmgr(memgdw,'grad    ',s8,pgrad ,nvar)
      CALL memmgr(memgdw,'co      ',s8,pc,natoms*3)
      CALL memmgr(memget,'ilab    ',is,pl,natoms)
      CALL rslave(s8(pgrad),s8(pc),is(pl))
      CALL memmgr(memfdw,'grad    ',s8,pgrad ,nvar)
      CALL memmgr(memfdw,'co      ',s8,pc,natoms*3)
      CALL memmgr(memfre,'ilab    ',is,pl,natoms)
      RETURN
      END
