CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
C $Id: errex.r,v 1.4 2002/02/12 12:50:54 nbauer Exp $
C error exit routine
C $Log: errex.r,v $
C Revision 1.4  2002/02/12 12:50:54  nbauer
C GNU GPL included
C
C Revision 1.3  2002/01/30 19:44:57  nbauer
C MCSCF calculations possible
C
c  Revision 1.1  1994/08/31  14:49:15  hess
c  Initial revision
c
      SUBROUTINE ERREX(TX)
      INCLUDE 'defs.h'
      INCLUDE 'comm.h'
      CHARACTER*(*) TX
      INTEGER info
C#    INTEGER w
C#    DATA w /MPI_COMM_WORLD/
      WRITE (*,*) '  errex| program aborted due to error(s).'
      WRITE (*,*) '       | ',TX
C#    CALL MPI_ABORT(w,info)
      CALL termcomm('errex')
** termcomm will not return
      STOP 'miracle in errex'
      END
