CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE inictok

* initialize communication token request queue

      INCLUDE 'defs.h'
      INCLUDE 'strctok.h'

      ctok_first=0
      ctok_last=0
      ctok_number=4

      RETURN
      END
      SUBROUTINE enq_ctok(tid,pid)

* enqueue entry into communication token request queue

      INCLUDE 'defs.h'
      INCLUDE 'strctok.h'
      INCLUDE 'objects.h'
      INTEGER pid,tid

      INTEGER p
      CALL memmgr(memget,'ctok    ',is,p,strctok_len)
      is(p+strctok_next)=0
      is(p+strctok_tid)=tid
      is(p+strctok_pid)=tid
      IF (ctok_first.EQ.0) THEN
       ctok_first=p
       ctok_last=p
       RETURN
      ENDIF
      is(ctok_last+strctok_next)=p
      ctok_last=p
      RETURN
      END
      SUBROUTINE deq_ctok(tid,pid)

* get first entry from communication token queue

      INCLUDE 'defs.h'
      INCLUDE 'strctok.h'
      INCLUDE 'objects.h'
      INTEGER pid,tid,p,q

      tid=0
      pid=0
      IF (ctok_first.EQ.0) RETURN
      p=ctok_first
      tid=is(p+strctok_tid)
      pid=is(p+strctok_pid)
      q=is(p+strctok_next)
      ctok_first=q
      IF (p.EQ.0) ctok_last=0
      CALL memmgr(memfre,'ctok    ',is,p,strctok_len)
      RETURN
      END
