CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE mnotify(icase,pid,irc,cmd,len)
      INCLUDE 'defs.h'
      INCLUDE 'comm.h'
      INCLUDE 'param.h'
      INTEGER pid,len
      CHARACTER*255 cmd
      INTEGER icase,info,mbuf,irc
      INTEGER dest
      INTEGER*4 tid4,pid4,irc4,icase4,ilen4
      CHARACTER*24 date
C#    INTEGER w,st(MPI_STATUS_SIZE)
C#    DATA w /MPI_COMM_WORLD/
      CALL fdate(date)
      IF (icase.LT.3) WRITE (iosl,*) date,icase,pid,irc,' ',cmd(1:len)
      tid4=mytid
      pid4=pid
      irc4=irc
      dest=tid0
      icase4=icase
      ilen4=len

* do not send to myself
C//SKIPC#1
      IF (tid0.EQ.PVMNOPARENT) RETURN
C#    IF (mytid.EQ.tid0) RETURN

* do not send if pvm is not up ...
      IF (mytid.LT.0) RETURN

C#    CALL MPI_SEND(mytid,1,MPI_INTEGER,tid0,fsys_mpitag,w,info)
C#    CALL mpierr('MPI_SEND mytid','mnotify',info)
C#    CALL MPI_SEND(fsys_mnotify,1,MPI_INTEGER,tid0,501,w,info)
C#    CALL mpierr('MPI_SEND mnotify','mnotify',info)
C#    CALL MPI_SEND(pid,1,MPI_INTEGER,tid0,502,w,info)
C#    CALL mpierr('MPI_SEND pid','mnotify',info)
C#    CALL MPI_SEND(irc,1,MPI_INTEGER,tid0,503,w,info)
C#    CALL mpierr('MPI_SEND irc','mnotify',info)
C#    CALL MPI_SEND(icase,1,MPI_INTEGER,tid0,504,w,info)
C#    CALL mpierr('MPI_SEND icase','mnotify',info)
C#    CALL MPI_SEND(len,1,MPI_INTEGER,tid0,505,w,info)
C#    CALL mpierr('MPI_SEND len','mnotify',info)
C#    CALL MPI_SEND(cmd,len,MPI_CHARACTER,tid0,506,w,info)
C#    CALL mpierr('MPI_SEND cmd','mnotify',info)
C//SKIPC#
      CALL PVMFINITSEND(PVMDATADEFAULT,mbuf)
      CALL PVMFPACK(INTEGER4,tid4,1,1,info)
      CALL PVMFPACK(INTEGER4,pid4,1,1,info)
      CALL PVMFPACK(INTEGER4,irc4,1,1,info)
      CALL PVMFPACK(INTEGER4,icase4,1,1,info)
      CALL PVMFPACK(INTEGER4,ilen4,1,1,info)
      CALL PVMFPACK(STRING,cmd,len,1,info)
      CALL PVMFSEND(dest,BAHFSYSCAL,info)
      IF (info.NE.0) CALL pvmfperror('mnotify',info)
      CALL ssys
C//END
      RETURN
      END
