CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE rdir(name,val,l,islash,ierr)
**
** get directory name from input file and check them for existence
** 
      IMPLICIT none
      CHARACTER*(*) val,name
      CHARACTER*255 cmdout,def
      INTEGER l
      INTEGER info,xeq,islash,ierr
      def=val
      CALL readv(name,val,def)
      CALL llen(val,l)
      CALL concat('test -d ',val(1:l),cmdout)
      info=xeq(cmdout)
      IF (info.NE.0) THEN
       WRITE (*,*) name,'=',val(1:l)
       WRITE (*,*) 'does not exist'
       ierr=ierr+1
      ENDIF
      IF (islash.NE.0 .AND. val(l:l).NE.'/') THEN
       val(l+1:l+1)='/'
       l=l+1
      ENDIF
      RETURN
      END
