CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE sfile(name,tid,info)
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
*
* send file through pvm or mpi
*
      CHARACTER*(*) name
      INTEGER tid
      CHARACTER*255 card
      INTEGER info,irc,lu,l,n

      info=0
      CALL slen(name,l)
      lu=1
      OPEN (UNIT=lu,FILE=name(1:l),
     * FORM='FORMATTED',STATUS='OLD',IOSTAT=irc)
      IF (irc.NE.0) THEN
       WRITE (*,*) 'sfile: cannot open file ',name
       WRITE (*,*) ' returncode is ',irc
       info=9
       RETURN
      ENDIF
      CALL clean(card)
      card(1:6)='%FILE '
      card(7:l+7)=name(1:l)
      WRITE (idbg,*) '       | sending <',name(1:l),'> to tid ',tid
      CALL pputstr('spawn: filename',card, tid, 40, 440, info )
      n=0
1     READ (lu,'(A)',END=998) card
      n=n+1
      CALL llen(card,l)
      CALL pputstr('spawn: card',card, tid, 255, 441, info )
      IF (info.NE.0) GOTO 999
      GOTO 1
998   CONTINUE
      CALL clean(card)
      card='%EOF% '
      CALL pputstr('spawn: EOF',card, tid, 255, 441, info )
999   CONTINUE
      WRITE (idbg,*) '       | #cards ',n,' info=',info
      CLOSE (UNIT=lu)
      RETURN
      END
