CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE trace_stat
      INCLUDE 'defs.h'
      INCLUDE 'param.h'  
      INCLUDE 'sadmch.h'
      INTEGER lu,i,l,p,tpid,trc,usag,nodf,ia,ib,cmd,k
      CHARACTER*40 pmsg,name
      CHARACTER*4 ccmd,cnodf
      lu=1
      OPEN (UNIT=lu,FILE=dcstat,STATUS='UNKNOWN')
      k=0
      p=pmch
1     IF (p.EQ.0) GOTO 2
      IF (is(p+sadmch_nodf).NE.sadmch_remo .AND.
     + is(p+sadmch_nodf).NE.sadmch_virt) THEN
       CALL sadmch_gpmsg(p,pmsg)
       CALL sadmch_gname(p,name)
       i=is(p+sadmch_numb)
       cmd=is(p+sadmch_cmd)
       ccmd='    '
       IF (cmd.EQ.sadmch_shut) ccmd='shut'
       IF (cmd.EQ.sadmch_term) ccmd='term'
       IF (cmd.EQ.sadmch_vbsy) ccmd='vbsy'
       tpid=is(p+sadmch_tpid)
       trc=is(p+sadmch_trc)

       usag=0
       CALL sadmch_fname(pvmmch,name)
       IF (cmch.GT.0) usag=is(cmch+sadmch_usag)

       nodf=is(p+sadmch_nodf)
       cnodf='    '
       IF (nodf.EQ.sadmch_unf)  cnodf='unf '
       IF (nodf.EQ.sadmch_nans) cnodf='nans'
       IF (nodf.EQ.sadmch_wait) cnodf='wait'
       IF (nodf.EQ.sadmch_runn) cnodf='run '
       IF (nodf.EQ.sadmch_rdy ) cnodf='rdy '
       IF (nodf.EQ.sadmch_dead) cnodf='dead'
       IF (nodf.EQ.sadmch_done) cnodf='done'
       IF (nodf.EQ.sadmch_chk ) cnodf='chk '
       IF (nodf.EQ.sadmch_pvme) cnodf='pvme'
       ia=is(p+sadmch_stpa)
       ib=is(p+sadmch_stpb)
       k=k+1
       WRITE (lu,100) i,k,name,ccmd,tpid,trc,usag,cnodf,ia,ib,pmsg
      ENDIF
      p=is(p+sadmch_next)
      GOTO 1
100   FORMAT(I3,1X,I3,1X,A10,1X,A4,1X,I8,I8,I4,1X,A4,1X,2I5,1X,A16)
2     CONTINUE
      CLOSE (UNIT=lu)
      RETURN
      END
